# Copyright (c) 1995 Merck and Co., Inc.
#       Whitehouse Station, NJ USA
#          All Rights Reserved

proc cbca { nm} {
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    global Nv_Priv NvCBCA
    
    set NvCBCA(maxRows) 4
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        set NvCBCA($iRow,active) 0
        set NvCBCA($iRow,full) 1
    }
    
    set NvCBCA(0,active) 1 ; # make it default to draw one row in Edit Clusters
 
    set NvCBCA(HNdim) HN
    set NvCBCA(Ndim) N
    set NvCBCA(Cdim) CAB
    set NvCBCA(CAdim) Ca
    set NvCBCA(COdim) Co
    set NvCBCA(HAdim) 1HA
    set NvCBCA(tolC13) 0.6
    set NvCBCA(nEditRows) 4
    
    set NvCBCA(winArgs,peak) "interResidue interResidue intraResidue intraResidue"
    set NvCBCA(winAxis,xdim,peak)   "Ndim HNdim HNdim Ndim"
    set NvCBCA(winAxis,ydim,peak)   "Cdim Cdim Cdim Cdim"
    set NvCBCA(winAxis,zdim,peak)   "HNdim Ndim Ndim HNdim"
    
    set NvCBCA(winArgs,peak4) "interResidue interResidue intraResidue intraResidue"
    set NvCBCA(winAxis,xdim,peak4)   "HNdim"
    set NvCBCA(winAxis,ydim,peak4)   "Ndim"
    
    set NvCBCA(winArgs,cluster) "intraResidue interResidue intraResidue interResidue"
    set NvCBCA(winAxis,xdim,cluster) "HNdim HNdim HNdim HNdim"
    set NvCBCA(winAxis,ydim,cluster) "Cdim Cdim Cdim Cdim"
    
    set NvCBCA(winArgs,cluster4) "intraResidue interResidue intraResidue interResidue"
    set NvCBCA(winAxis,xdim,cluster4) "CAdim CAdim CAdim CAdim"
    set NvCBCA(winAxis,ydim,cluster4) "COdim COdim COdim COdim"
    
    set NvCBCA(winArgs,cluster,2) {{proc getCACOp intraResidue} interResidue {proc getCACOs intraResidue} interResidue}
    set NvCBCA(winAxis,xdim,cluster,2) "HAdim HNdim HAdim HNdim"
    set NvCBCA(winAxis,ydim,cluster,2) "COdim COdim COdim COdim"
   
    set NvCBCA(filter,tolHN) .05   
    set NvCBCA(interList,tolHN) .05   
    set NvCBCA(intraList,tolHN) .05  
 
    set NvCBCA(filter,tolN) .5   
    set NvCBCA(interList,tolN) .5   
    set NvCBCA(intraList,tolN) .5  
 
    set NvCBCA(matchScript) MatchCBCA4
    set NvCBCA(matchLists) "hnca hncoca hncacb hncocacb"
    set NvCBCA(noIntra) 1
    set NvCBCA(updateSpectra) 1
    
    set NvCBCA(controlFrame) .nvassignCntrl
    set NvCBCA(mode) Inactive

    set NvCBCA(newCluster) 0
    set NvCBCA(addFrame) .addPeaktoCluster

    toplevel $nm
    set NvCBCA(toplevel) $nm
    wm minsize $nm 1 1
    wm geometry $nm 800x400
    
    set mbar $nm.mbar
    frame $mbar -relief raised -border 2 -height 50
    pack $mbar -side top  -fill x
 
   
    set fr2 $nm.fr2
    frame $fr2 -width 170 -relief raised -border 1
    pack $fr2 -side left -fill y  
    set NvCBCA(last) $fr2.examine

    button $fr2.examine -text "Examine Peaks" -command "set NvCBCA(mode) peak
							NvCBCAMkPeakCntrl $NvCBCA(controlFrame)
							makeActive $fr2.examine
							set NvCBCA(last) $fr2.examine" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.examine -side top -fill x 

    button $fr2.filter -text "Filter Peaks" -command "set NvCBCA(mode) filter 
							NvCBCAMkFilterCntrl $NvCBCA(controlFrame)
							makeActive $fr2.filter 
							set NvCBCA(last) $fr2.filter" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.filter -side top -fill x 

    button $fr2.cluster -text "Cluster Peaks" -command "set NvCBCA(mode) link 
							NvCBCAMkLinks $NvCBCA(controlFrame)
							makeActive $fr2.cluster
							set NvCBCA(last) $fr2.cluster" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.cluster -side top -fill x 

    button $fr2.editC -text "Edit Clusters (HN-C)" -command "set NvCBCA(mode) clusteredit 
							NvCBCAMkLinkEditCntrl $NvCBCA(controlFrame)
							makeActive $fr2.editC
							set NvCBCA(last) $fr2.editC" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.editC -side top -fill x

    button $fr2.editN -text "Edit Clusters (HN-N)" -command "set NvCBCA(mode) clusteredit4
							NvCBCAMkLinkEditCntrl $NvCBCA(controlFrame)
							makeActive $fr2.editN
							set NvCBCA(last) $fr2.editN" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.editN -side top -fill x 

    button $fr2.match -text "Match Clusters" -command "set NvCBCA(mode) clusterMatch 
							NvCBCAMkClusterMatchCntrl $NvCBCA(controlFrame)
							makeActive $fr2.match
							set NvCBCA(last) $fr2.match" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.match -side top -fill x 

    button $fr2.editMatch -text "Edit Matches" -command "set NvCBCA(mode) editmatches 
							NvCBCAMkClustCntrl $NvCBCA(controlFrame) 
							makeActive $fr2.editMatch
							set NvCBCA(last) $fr2.editMatch" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.editMatch -side top -fill x 

    button $fr2.assemble -text "Assemble Fragments" -command "set NvCBCA(mode) assemblefragments 
							NvCBCAMkFragCntrl $NvCBCA(controlFrame) 
							makeActive $fr2.assemble
							set NvCBCA(last) $fr2.assemble
							" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.assemble -side top -fill x 

    button $fr2.tocsy -text "TOCSY" -command "set NvCBCA(mode) tocsyedit
							NvCBCAMkTOCSY $NvCBCA(controlFrame) 
							makeActive $fr2.tocsy
							set NvCBCA(last) $fr2.tocsy" \
						-bg #dddddd -activebackground #cccccc 
    pack $fr2.tocsy -side top -fill x 

    frame $fr2.cntrl 
    pack $fr2.cntrl -side top -fill both

    set fr1 $nm.fr1 
    frame $fr1
    pack $fr1 -side top -fill both  -expand y
    
    set NvCBCA(refspecOn) 0
    if {$NvCBCA(refspecOn) } {
        set frame $nm.fr1.right
        frame $frame  -width 3c
        pack $frame -side right -fill y
        $frame config -bg green
        set fr $frame.refspec
        frame $fr
        pack $fr -side top  -fill both -expand y -anchor e
    }
    
    
    set fr $mbar
   
    menubutton $fr.mode -menu $fr.mode.menu -text Mode -underline 0

    menu $fr.mode.menu
        
 
    $fr.mode.menu add radiobutton -label "Examine Peaks" \
    -command "NvCBCAMkPeakCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.examine
	set NvCBCA(last) $fr2.examine" -value peak -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Filter Peaks" \
    -command "NvCBCAMkFilterCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.filter
	set NvCBCA(last) $fr2.filter" -value filter -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Cluster Peaks"\
    -command "NvCBCAMkLinks $NvCBCA(controlFrame) 
	makeActive $fr2.cluster
	set NvCBCA(last) $fr2.cluster" -value link -variable NvCBCA(mode)
   
    $fr.mode.menu add radiobutton -label "Edit Clusters (HN-C)"  \
    -command "NvCBCAMkLinkEditCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.editC
	set NvCBCA(last) $fr2.editC" -value clusteredit -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Edit Clusters (HN-N)"  \
    -command "NvCBCAMkLinkEditCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.editN
	set NvCBCA(last) $fr2.editN" -value clusteredit4 -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Match Clusters"  \
    -command "NvCBCAMkClusterMatchCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.match
	set NvCBCA(last) $fr2.match" -value clusterMatch -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Edit Matches"  \
    -command "NvCBCAMkClustCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.editMatch
	set NvCBCA(last) $fr2.editMatch" -value editmatches -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label "Assemble Fragments"  \
    -command "NvCBCAMkFragCntrl $NvCBCA(controlFrame) 
	makeActive $fr2.assemble
	set NvCBCA(last) $fr2.assemble" -value assemblefragments -variable NvCBCA(mode)
    
    $fr.mode.menu add radiobutton -label TOCSY  \
    -command "NvCBCAMkTOCSY $NvCBCA(controlFrame) 
	makeActive $fr2.tocsy
	set NvCBCA(last) $fr2.tocsy" -value tocsyedit -variable NvCBCA(mode)
    
    set NvCBCA(fileMenu) $fr.file.menu
    
    menubutton $fr.file -text File -underline 0 \
    -menu $NvCBCA(fileMenu)
    
    menu $NvCBCA(fileMenu) -tearoff 0
    set NvCBCA(clust) 0
    $NvCBCA(fileMenu) add command -label Preferences  -command "NvCBCAPreferences .nvassignPrefs"
    $NvCBCA(fileMenu) add command -label "Cluster Editor"  -command "NvCBCAMkClusterEditor \$NvCBCA(clust)"
    $NvCBCA(fileMenu) add command -label Save  -command "NvCBCASave"
    $NvCBCA(fileMenu) add command -label Restore  -command "NvCBCARestore"
    $NvCBCA(fileMenu) add command -label Close  -command "wm withdraw $nm"
    
    pack $fr.file $fr.mode  -side left
    
    button $fr.eubutton -text "Unify" -command "eu"
    pack $fr.eubutton -side right
    button $fr.gotoeleven -text 11 -command "nv_win lvl 11; eu"
    pack $fr.gotoeleven -side right 
    button $fr.togglenum -text "Toggle Peak Label" -command "NvCBCAToggle"
    pack $fr.togglenum -side right
   # button $fr.delPeak -text "DelPeak" -command "puts [nv_win act]; nv_peak delete [nv_peak close]; nv_win draw"
   # pack $fr.delPeak -side right
 
    frame $fr.cntrl
    pack $fr.cntrl -side left -fill x
    
    destroy .nvassignCntrl
    toplevel .nvassignCntrl
    wm withdraw .nvassignCntrl
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl
    frame $fr -relief raised
    pack $fr -side top  -fill both -expand y -anchor e
    
    if {$NvCBCA(refspecOn) } {
        set frame $nm.fr1.right.refspec
        NvMkSpectrum2 $frame.0 top
        set frame $nm.fr1.spec
        set win $nm.fr1.right.refspec.0
        bind $win <Double-1> "NvCBCAgoto %W"
    }
}

proc NvCBCAFillRowMenu {frame menu} {
    global NvCBCA
    $menu delete 0 end
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        $menu add radiobutton -label $iRow  -command "NvCBCASetupRows $frame $iRow"
    }
    set NvCBCA(mode) rows
}


proc NvCBCAMkSpectra {nm} {
    global NvCBCA
    if {[winfo exists $nm.fr1.spec]} {
        destroy $nm.fr1.spec
    }
    
    set NvCBCA(windows) "0 1 2 3"
    set frame $nm.fr1.spec
    frame $frame
    pack $frame -side right -fill both -expand y
    
    set NvCBCA(Windows) $nm.fr1.spec
    
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            set frame $nm.fr1.spec.$iRow
            frame $frame
            pack $frame -side top -fill both -expand y
            NvMkSpectrum2 $frame.0 left
            NvMkSpectrum2 $frame.1 left
            NvMkSpectrum2 $frame.2 left
            NvMkSpectrum2 $frame.3 left
        }
    }
}

proc NvCBCAMkSpectra2 {nm n} {
    global NvCBCA
    if {[winfo exists $nm.fr1.spec]} {
        destroy $nm.fr1.spec
    }
    
    set NvCBCA(windows) "0 1 2 3"
    set frame $nm.fr1.spec
    frame $frame
    pack $frame -side right -fill both -expand y
    
    set NvCBCA(Windows) $nm.fr1.spec
    
    for {set iRow 0} {$iRow<$n} {incr iRow} {
        set frame $nm.fr1.spec.$iRow
        frame $frame
        pack $frame -side top -fill both -expand y
        set iWin 0
        foreach peakList [NvCBCAGetPkLists] {
            NvMkSpectrum2 $frame.$iWin left
            incr iWin
        }
    }
}

proc NvWinGoto args {
    set win [lindex $args 0]
    set rngs [lrange $args  1 end]
    foreach rng $rngs {
        set dim [lindex $rng 0]
        set min [lindex $rng 1]
        set max [lindex $rng 2]
        $win ppm $dim $min $max
    }
}

proc NvCBCAgoto {win} {
    set tol 0.1
    set x [$win cross1x]
    set y [$win cross1y]
    set tl [winfo toplevel $win]
    set fr $tl.fr1.spec
    foreach wn "1 2" {
        NvWinGoto $fr.$wn "x [expr $x-$tol] [expr $x+$tol]"
        NvWinGoto $fr.$wn "z $y $y"
        nv_win act $fr.$wn
        nv_win draw
        update
    }
}

proc NvCBCASetupWindowsOld {nm} {
    global NvCBCA NvSpectrum
    
    NvCBCAMkSpectra $nm
    
    
    set mode $NvCBCA(winMode)
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            foreach iWin $NvCBCA(windows) {
                set win $nm.fr1.spec.$iRow.$iWin
                
                if {[info exists NvCBCA(winArgs,$mode,$iRow)]} {
                    set winArgs $NvCBCA(winArgs,$mode,$iRow)
                } else {
                    set winArgs $NvCBCA(winArgs,$mode)
                }
                set type [lindex $winArgs $iWin]
                if {[lindex $type 0] == "proc"} {
                    set type [lindex $type 2]
                }
                
                if {[info exists NvCBCA(winAxis,xdim,$mode,$iRow)]} {
                    set xdim [lindex $NvCBCA(winAxis,xdim,$mode,$iRow) $iWin]
                    set ydim [lindex $NvCBCA(winAxis,ydim,$mode,$iRow) $iWin]
                } else {
                    set xdim [lindex $NvCBCA(winAxis,xdim,$mode) $iWin]
                    set ydim [lindex $NvCBCA(winAxis,ydim,$mode) $iWin]
                }
                if {$type == ""} {
                    set dataset ""
                    $win dataset $dataset
                    continue
                } else {
                    set dataset $NvCBCA($iRow,$type,file)
                    $win dataset $dataset
                }
                set NvSpectrum($win,datasets) $dataset
                $win dispeak $NvCBCA($iRow,$type,peaks)
                
                foreach dim1 {xdim ydim}    {
                    for {set i 1 } {$i<=[nv_dataset ndim $dataset]} {incr i} {
                        set label [nv_dataset label $dataset $i]
                        if {$label == $NvCBCA([set $dim1]) } {
                            $win $dim1  $i
                        }
                    }
                }
                if {!$NvCBCA($iRow,full)} {
                    $win ppm y $NvCBCA($iRow,minY) $NvCBCA($iRow,maxY)
                } else {
                    $win ppm y -1.0e6 1.0e6
                }
                
                
                if {$NvCBCA(mode) == "peak"} {
                    bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                    bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
                }
                if {$NvCBCA(mode) == "clusteredit"} {
                    bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                    bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
                }
                
                # Set plot limits to small region for faster drawing during setup.
                set max [lindex [$win  ppmMax x] 1]
                set min [lindex [$win  ppmMax x] 0]
                $win ppm x [expr $max- (($max-$min)/10.0)] $max
                
                $win pt z 1 1
                $win pt z2 1 1
                $win nlvl 20
                $win clm 1.2
                $win peak_off 0
                $win peak_col_type 3
                $win border x 20 0
            }
        }
    }
    if {$NvCBCA(refspecOn) } {
        set win $nm.fr1.right.refspec.0
        #    $win dataset $NvCBCA(hnco,file)
        #    $win nlvl 20
        #    $win clm 1.2
        #    $win pt z 1 1
        #    $win pt z2 1 1
        #    $win border x 20 0
    }
}

proc NvCBCASetupWindows {nm} {
    global NvCBCA NvSpectrum
    
    NvCBCAMkSpectra $nm
    
    set mode $NvCBCA(winMode)
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            foreach iWin $NvCBCA(windows) {
                set win $nm.fr1.spec.$iRow.$iWin
                
                if {[info exists NvCBCA(winArgs,$mode,$iRow)]} {
                    set winArgs $NvCBCA(winArgs,$mode,$iRow)
                } else {
                    set winArgs $NvCBCA(winArgs,$mode)
                }
                set type [lindex $winArgs $iWin]
                if {[lindex $type 0] == "proc"} {
                    set type [lindex $type 2]
                }
                
                if {[info exists NvCBCA(winAxis,xdim,$mode,$iRow)]} {
                    set xdim [lindex $NvCBCA(winAxis,xdim,$mode,$iRow) $iWin]
                    set ydim [lindex $NvCBCA(winAxis,ydim,$mode,$iRow) $iWin]
                } else {
                    set xdim [lindex $NvCBCA(winAxis,xdim,$mode) $iWin]
                    set ydim [lindex $NvCBCA(winAxis,ydim,$mode) $iWin]
                }
                if {$type == ""} {
                    set dataset ""
                    $win dataset $dataset
                    continue
                } else {
                    set dataset $NvCBCA($iRow,$type,file)
                    $win dataset $dataset
                }
                set NvSpectrum($win,datasets) $dataset
                $win dispeak $NvCBCA($iRow,$type,peaks)
                
                foreach dim1 {xdim ydim}    {
                    for {set i 1 } {$i<=[nv_dataset ndim $dataset]} {incr i} {
                        set label [nv_dataset label $dataset $i]
                        if {$label == $NvCBCA([set $dim1]) } {
                            $win $dim1  $i
                        }
                    }
                }
                if {!$NvCBCA($iRow,full)} {
                    $win ppm y $NvCBCA($iRow,minY) $NvCBCA($iRow,maxY)
                } else {
                    $win ppm y -1.0e6 1.0e6
                }
                
                
                if {$NvCBCA(mode) == "peak"} {
                    bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                    bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
                }
                if {$NvCBCA(mode) == "clusteredit"} {
                    bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                    bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
                }
                
                # Set plot limits to small region for faster drawing during setup.
                set max [lindex [$win  ppmMax x] 1]
                set min [lindex [$win  ppmMax x] 0]
                $win ppm x [expr $max- (($max-$min)/10.0)] $max
                
                $win pt z 1 1
                $win pt z2 1 1
                $win nlvl 20
                $win clm 1.2
                $win peak_off 0
                $win peak_col_type 3
                $win border x 20 0
            }
        }
    }
    if {$NvCBCA(refspecOn) } {
        set win $nm.fr1.right.refspec.0
        #    $win dataset $NvCBCA(hnco,file)
        #    $win nlvl 20
        #    $win clm 1.2
        #    $win pt z 1 1
        #    $win pt z2 1 1
        #    $win border x 20 0
    }
}

proc NvCBCASetupWindows2 {nm n} {
    global NvCBCA NvSpectrum
    
    NvCBCAMkSpectra2 $nm $n
    
    set mode $NvCBCA(winMode)
    for {set iRow 0} {$iRow<$n} {incr iRow} {
        set iWin -1
        foreach peakList [NvCBCAGetPkLists]{
            incr iWin
            set win $nm.fr1.spec.$iRow.$iWin
            
            if {[info exists NvCBCA(winArgs,$mode,$iRow)]} {
                set winArgs $NvCBCA(winArgs,$mode,$iRow)
            } else {
                set winArgs $NvCBCA(winArgs,$mode)
            }
            set type [lindex $winArgs 0]
            if {[lindex $type 0] == "proc"} {
                set type [lindex $type 2]
            }
            
            set xdim [lindex $NvCBCA(winAxis,xdim,$mode) 0]
            set ydim [lindex $NvCBCA(winAxis,ydim,$mode) 0]
            if {$type == ""} {
                set dataset ""
                $win dataset $dataset
                continue
            } else {
                set dataset [nv_peak dataset $peakList]
                $win dataset $dataset
            }
            set NvSpectrum($win,datasets) $dataset
            $win dispeak $peakList
            
            foreach dim1 {xdim ydim}    {
                for {set i 1 } {$i<=[nv_dataset ndim $dataset]} {incr i} {
                    set label [nv_dataset label $dataset $i]
                    if {$label == $NvCBCA([set $dim1]) } {
                        $win $dim1  $i
                    }
                }
            }
            if {!$NvCBCA(0,full)} {
                $win ppm y $NvCBCA($iRow,minY) $NvCBCA($iRow,maxY)
            } else {
                $win ppm y -1.0e6 1.0e6
            }
            
            
            if {$NvCBCA(mode) == "peak"} {
                bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
            }
            if {$NvCBCA(mode) == "clusteredit"} {
                bind $win <Double-1> {NvConfirmPeak 1 %W %x %y}
                bind $win <Double-2> {NvConfirmPeak 2 %W %x %y}
            }
            
            # Set plot limits to small region for faster drawing during setup.
            set max [lindex [$win  ppmMax x] 1]
            set min [lindex [$win  ppmMax x] 0]
            $win ppm x [expr $max- (($max-$min)/10.0)] $max
            
            $win pt z 1 1
            $win pt z2 1 1
            $win nlvl 20
            $win clm 1.2
            $win peak_off 0
            $win peak_col_type 3
            $win border x 20 0
        }
    }
    if {$NvCBCA(refspecOn) } {
        set win $nm.fr1.right.refspec.0
        #    $win dataset $NvCBCA(hnco,file)
        #    $win nlvl 20
        #    $win clm 1.2
        #    $win pt z 1 1
        #    $win pt z2 1 1
        #    $win border x 20 0
    }
}

proc NvCBCAUpdatePeak {win dir} {
    global NvCBCA
    set tolH 0.1
    set tolN 0.7
    set iPeak [expr {$NvCBCA(peak) + $dir}]
    set index [NvPeakCheckIndex $NvCBCA(list) $iPeak $dir]
    if {$index >= 0} {
        set NvCBCA(peak) [nv_peak idnum $NvCBCA(list).$index]
    }
    #    NvUpdatePeakAnal
    #    nv_peak sho $NvCBCA(list).$NvCBCA(peak)"
    set x [nv_peak elem $NvCBCA(HNdim).P $NvCBCA(list).$NvCBCA(peak)]
    set y [nv_peak elem $NvCBCA(Ndim).P $NvCBCA(list).$NvCBCA(peak)]
    
    set tl [winfo toplevel $win]
    if {$NvCBCA(mode) == "peak"} {
        for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
            if {$NvCBCA($iRow,active)} {
                set fr $tl.fr1.spec.$iRow
                foreach wn "0 3" {
                    set zdim [lindex $NvCBCA(winAxis,zdim,peak) $wn]
                    set zdim $NvCBCA($zdim)
                    set dataset [$fr.$wn dataset ]
                    set lDim [expr [$fr.$wn ndim]-1]
                    set labels [lrange "x y z z2" 0 $lDim]
                    foreach label $labels {
                        set wlabel [$fr.$wn lab $label]
                        if {$wlabel == $zdim } {
                            set zdimName $label
                            break
                        }
                    }
                    NvWinGoto $fr.$wn "x [expr $y-$tolN] [expr $y+$tolN]"
                    NvWinGoto $fr.$wn "$zdimName $x $x"
                    if {$zdimName == "z"} {
                        NvWinGoto $fr.$wn "a -1000 1000"
                    } else {
                        NvWinGoto $fr.$wn "z -1000 1000"
                    }
                    nv_win act $fr.$wn
                    nv_win draw
                    update
                }
            }
        }
    }
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            set fr $tl.fr1.spec.$iRow
            foreach wn "1 2" {
                set zdim [lindex $NvCBCA(winAxis,zdim,peak) $wn]
                set zdim $NvCBCA($zdim)
                foreach label "x y z z2" {
                    set wlabel [$fr.$wn lab $label]
                    if {$wlabel == $zdim } {
                        set zdimName $label
                        break
                    }
                }
                NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
                NvWinGoto $fr.$wn "$zdimName $y $y"
                if {$zdimName == "z"} {
                    NvWinGoto $fr.$wn "z2 -1000 1000"
                } else {
                    NvWinGoto $fr.$wn "z -1000 1000"
                }
                nv_win act $fr.$wn
                nv_win draw
                update
            }
        }
    }
    if {$NvCBCA(refspecOn) } {
        set win $tl.fr1.right.refspec.0
        if {![catch "$win dataset"]} {
            NvWinGoto $win "x [expr $x-$tolH] [expr $x+$tolH]"
            NvWinGoto $win "y [expr $y-3*$tolN] [expr $y+3*$tolN]"
            nv_win act $win
            nv_win draw
            update
        }
    }
}

proc NvCBCAUpdateClustEdit {frame dir} {
    global NvCBCA Clust Seq
    set tolH 0.2
    set tolN 0.7
    
    set old $NvCBCA(clust)
    incr NvCBCA(clust) $dir
    set iClust $NvCBCA(clust)
    if {![info exists Clust($iClust,HN)]} {
        set NvCBCA(clust) $old
        bell
        return
    }
    NvCBCAUpdateClusterEditor goto  $iClust
    set NvCBCA(clusterRes) ""
    if {[info exists Clust($iClust,Seq)] && ([string trim $Clust($iClust,Seq)] != "")} {
        foreach iSeq $Clust($iClust,Seq) {
            if {$iSeq > 0} {
                if {$iSeq > 1} {
                    set preSeq [expr {$iSeq-1}]
                    append NvCBCA(clusterRes) "$Seq($preSeq,rname).$preSeq $Seq($iSeq,rname).$iSeq  "
                } else {
                    append NvCBCA(clusterRes) "$Seq($iSeq,rname).$iSeq)  "
                }
                
            }
        }
    }
    
    if {$NvCBCA(updateSpectra)} {
        set x   $Clust($iClust,HN)
        set y   $Clust($iClust,N)
        
        set tl $NvCBCA(toplevel)
        if {$NvCBCA(winMode)=="cluster"} {
            for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
                if {$NvCBCA($iRow,active)} {
                    set fr $tl.fr1.spec.$iRow
                    foreach wn "1 2" {
                        $fr.$wn peak_lab_type  4
                        if {[info exists NvCBCA(winArgs,cluster,$iRow)]} {
                            set winArgs [lindex $NvCBCA(winArgs,cluster,$iRow) $wn]
                            if {[lindex $winArgs 0] == "proc"} {
                                set procName [lindex $winArgs 1]
                                eval $procName $fr.$wn $NvCBCA(clust) 0
                                continue
                            }
                        }
                        NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
                        NvWinGoto $fr.$wn "z $y $y"
                        bind $fr.$wn <a> {NvCBCAAddPeakToCluster %W}
                        nv_win act $fr.$wn
                        nv_win draw
                        update
                    }
                }
            }
        }
        
        if {$NvCBCA(refspecOn) } {
            set win $tl.fr1.right.refspec.0
            if {![catch "$win dataset"]} {
                NvWinGoto $win "x [expr $x-$tolH] [expr $x+$tolH]"
                NvWinGoto $win "z $y $y"
                nv_win act $win
                nv_win draw
                update
            }
        }
    }
    #HERE
    
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    set color white
    set index 0
    foreach clust $Clust($iClust,pre) {
        set pclust [lindex $clust 0]
        set confClust [NvCBCAFindConfirm  $pclust suc]
        set sclusters $Clust($pclust,suc)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        if {$confirmed} {
            set color #E0F080 
        } elseif {$confClust != -1 && $confClust != $iClust} {
	    set color #B0A060 
	} else {
	    set color #999999
	}
        set nmatches [lindex $clust 3]
        set outs [format "%4d %4.2f %1d %1d %3d %3d" $pclust $score $confirmed $nmatches $sclust $confClust]
        $fr.lbox1 insert end $outs
	$fr.lbox1 itemconfigure $index -bg $color
	incr index 1
    }
    
    if {[llength $Clust($iClust,pre)] > 0} {
        $fr.lbox1 select set  0
        update
        NvCBCAGotoClust $fr 1 0
    }
    
  #  $fr.lbox1 config -bg $color
    set color white
    set index 0
    foreach clust $Clust($iClust,suc) {
        set pclust [lindex $clust 0]
        set confClust [NvCBCAFindConfirm  $pclust pre]
        set sclusters $Clust($pclust,pre)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        if {$confirmed} {
            set color #E0F080
        } elseif {$confClust != $iClust && $confClust != -1} {
	    set color #B0A060
	} else {
	    set color #999999 
	}
        set nmatches [lindex $clust 3]
        set outs [format "%4d %4.2f %1d %1d %3d %3d" $pclust $score $confirmed $nmatches $sclust $confClust]
        $fr.lbox2 insert end $outs
	$fr.lbox2 itemconfigure $index -bg $color
	incr index 1
    }
    if {[llength $Clust($iClust,suc)] > 0} {
        $fr.lbox2 select  set 0
        update
        NvCBCAGotoClust $fr 2 3
    }
    
  #  $fr.lbox2 config -bg $color
}
proc NvCBCAUpdateTocsyEdit {frame dir} {
    global NvCBCA Clust
    set tolH 0.2
    set tolN 0.7
    incr NvCBCA(clust) $dir
    set iClust $NvCBCA(clust)
    set x   $Clust($iClust,HN)
    set y   $Clust($iClust,N)
    
    set tl $NvCBCA(toplevel)
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            set fr $tl.fr1.spec.$iRow
            foreach wn "2 3" {
                NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
                NvWinGoto $fr.$wn "z $y $y"
                nv_win act $fr.$wn
                nv_win draw
                update
            }
        }
    }
    set fr $NvCBCA(controlFrame)
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    foreach clust $Clust($iClust,pre) {
        set pclust [lindex $clust 0]
        set sclusters $Clust($pclust,suc)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        set nmatches [lindex $clust 3]
        set outs [format "%4d   %4.2f     %1d %1d %3d" $pclust $score $confirmed $nmatches $sclust]
        $fr.lbox1 insert end $outs
    }
    foreach clust $Clust($iClust,suc) {
        set pclust [lindex $clust 0]
        set sclusters $Clust($pclust,pre)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        set nmatches [lindex $clust 3]
        set outs [format "%4d   %4.2f     %1d %1d %3d" $pclust $score $confirmed $nmatches $sclust]
        $fr.lbox2 insert end $outs
    }
}

proc NvCBCAGotoClust {frame box1 wn} {
    global NvCBCA
    if {$NvCBCA(winMode) == "cluster4"} {
        NvCBCAGotoClust4 $frame $box1 $wn
    } else {
        NvCBCAGotoClust3 $frame $box1 $wn
    }
}
proc NvCBCAGotoClust3 {frame box1 wn} {
    global NvCBCA
    set nm $NvCBCA(toplevel)
    global NvCBCA Clust
    
    set tolX 0.2
    set tolN 0.7
    
    set selection [$frame.lbox$box1 curselection]
    set value [$frame.lbox$box1 get $selection]
    set clust [lindex  $value 0]
    set tl $NvCBCA(toplevel)
    
    if {$box1=="1"} {
        set NvCBCA(status) [lindex $Clust($NvCBCA(clust),pre) $selection]
    } else {
        set NvCBCA(status) [lindex $Clust($NvCBCA(clust),suc) $selection]
    }
    
    set x   $Clust($clust,HN)
    set y   $Clust($clust,N)
    
    
    if {!$NvCBCA(updateSpectra) } {return}
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            set fr $tl.fr1.spec.$iRow
            $fr.$wn peak_lab_type  4
            if {[info exists NvCBCA(winArgs,cluster,$iRow)]} {
                set winArgs [lindex $NvCBCA(winArgs,cluster,$iRow) $wn]
                if {[lindex $winArgs 0] == "proc"} {
                    set procName [lindex $winArgs 1]
                    eval $procName $fr.$wn $NvCBCA(clust) $selection
                    continue
                }
            }
            
            NvWinGoto $fr.$wn "x [expr $x-$tolX] [expr $x+$tolX]"
            NvWinGoto $fr.$wn "z $y $y"
            
            nv_win act $fr.$wn
            nv_win draw
            update
        }
    }
}

proc NvCBCAGotoClust4 {frame box1 wn} {
    global NvCBCA Clust
    set nm $NvCBCA(toplevel)
    
    set tolX 2.0
    set tolY 2.0
    
    set selection [$frame.lbox$box1 curselection]
    set value [$frame.lbox$box1 get $selection]
    set clust [lindex  $value 0]
    set tl $NvCBCA(toplevel)
    
    if {$box1=="1"} {
        set NvCBCA(status) [lindex $Clust($NvCBCA(clust),pre) $selection]
    } else {
        set NvCBCA(status) [lindex $Clust($NvCBCA(clust),suc) $selection]
    }
    
    set x   $Clust($clust,HN)
    set y   $Clust($clust,N)
    set peaks [lindex $NvCBCA(status) 4]
    
    if {!$NvCBCA(updateSpectra) } {return}
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            set fr $tl.fr1.spec.$iRow
            $fr.$wn peak_lab_type  4
            if {[info exists NvCBCA(winArgs,cluster,$iRow)]} {
                set winArgs [lindex $NvCBCA(winArgs,cluster,$iRow) $wn]
                if {[lindex $winArgs 0] == "proc"} {
                    set procName [lindex $winArgs 1]
                    eval $procName $fr.$wn $NvCBCA(clust) $selection
                    continue
                }
            }
            if {$wn == 0} {
                set wins "0 1"
            } else {
                set wins "2 3"
            }
            set peak [lindex $peaks 0]
            set x [eval nv_peak elem $NvCBCA(CAdim).P $peak]
            set y [eval nv_peak elem $NvCBCA(COdim).P $peak]
            foreach wn $wins peak $peaks {
                set z [eval nv_peak elem $NvCBCA(HNdim).P $peak]
                set z2 [eval nv_peak elem $NvCBCA(Ndim).P $peak]
                
                NvWinGoto $fr.$wn "x [expr $x-$tolX] [expr $x+$tolX]"
                NvWinGoto $fr.$wn "y [expr $y-$tolY] [expr $y+$tolY]"
                NvWinGoto $fr.$wn "z $z $z"
                NvWinGoto $fr.$wn "z2 $z2 $z2"
                
                nv_win act $fr.$wn
                nv_win draw
                update
            }
        }
    }
}

proc NvCBCAUpdateLinkEdit {frame dir} {
    global NvCBCA 
    if {[winfo exists $NvCBCA(addFrame)]} {destroy $NvCBCA(addFrame) }
    if {$NvCBCA(mode) == "clusteredit4"} {
        NvCBCAUpdateLinkEdit4 $frame $dir
    } else {
        NvCBCAUpdateLinkEdit3 $frame $dir
    }
}

proc NvCBCAUpdateLinkEdit3 {frame dir} {
    global NvCBCA Clust
    set tolH 0.1
    set tolN 0.7
    set old $NvCBCA(clust)
    incr NvCBCA(clust) $dir
    set iClust $NvCBCA(clust)
    if {![info exists Clust($iClust,HN)]} {
        set NvCBCA(clust) $old
        bell
        return
    }
    if {$NvCBCA(updateSpectra)} {
        set x   $Clust($iClust,HN)
        set y   $Clust($iClust,N)
        NvCBCAUpdateClusterEditor goto  $iClust
        
        set tl [winfo toplevel $frame]
        for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
            if {$NvCBCA($iRow,active)} {
                set fr $tl.fr1.spec.$iRow
                foreach wn "0 3" {
                    NvWinGoto $fr.$wn "x [expr $y-$tolN] [expr $y+$tolN]"
                    NvWinGoto $fr.$wn "z $x $x"
                    bind $fr.$wn <a> {NvCBCAAddPeakToCluster %W;NvCBCAUpdateLinkCntrl}
                    bind $fr.$wn <s> {NvCBCAShiftPeakCluster %W}
                    bind $fr.$wn <n> {NvAddPeak %W %x %y 0}
                    $fr.$wn peak_lab_type  4
                    nv_win act $fr.$wn
                    nv_win draw
                    update
                }
            }
        }
        for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
            if {$NvCBCA($iRow,active)} {
                set fr $tl.fr1.spec.$iRow
                foreach wn "1 2" {
                    NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
                    NvWinGoto $fr.$wn "z $y $y"
                    bind $fr.$wn <a> {NvCBCAAddPeakToCluster %W;NvCBCAUpdateLinkCntrl}
                    bind $fr.$wn <s> {NvCBCAShiftPeakCluster %W}
                    bind $fr.$wn <n> {NvAddPeak %W %x %y 0}
                    $fr.$wn peak_lab_type  4
                    nv_win act $fr.$wn
                    nv_win draw
                    update
                }
            }
        }
        
        
        foreach wn "0 3" {
            NvWinGoto $fr.$wn "x [expr $y-$tolN] [expr $y+$tolN]"
            NvWinGoto $fr.$wn "z $x $x"
            nv_win act $fr.$wn
            nv_win draw
            update
        }
        foreach wn "1 2" {
            NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
            NvWinGoto $fr.$wn "z $y $y"
            nv_win act $fr.$wn
            nv_win draw
            update
        }
	NvCBCAFindHSQC $iClust
    }
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    set plists [NvCBCAGetPkLists]
    foreach peaklist $plists {
        foreach peak $Clust($iClust,$peaklist) {
            $fr.lbox1 insert end $peak
        }
    }
    set NvCBCA(clust2) $Clust(nClust)
}


proc NvCBCAUpdateLinkEdit4 {frame dir} {
    global NvCBCA Clust
    set tolH 0.2
    set tolN 1.4
    set old $NvCBCA(clust)
    incr NvCBCA(clust) $dir
    set iClust $NvCBCA(clust)
    if {![info exists Clust($iClust,HN)]} {
        set NvCBCA(clust) $old
        bell
        return
    }
    if {$NvCBCA(updateSpectra)} {
        set x   $Clust($iClust,HN)
        set y   $Clust($iClust,N)
        set z 50
        set z2 50
        NvCBCAUpdateClusterEditor goto  $iClust
        
        set tl [winfo toplevel $frame]
        set wn 0
        foreach exp [NvCBCAGetPkLists]{
            for {set iRow 0} {$iRow < $NvCBCA(nEditRows)} {incr iRow} {
                set fr $tl.fr1.spec.$iRow
                $fr.$wn clear
                update
            }
            incr wn
        }
        
        set firstTime 1
        set wn 0
        foreach exp [NvCBCAGetPkLists]{
            set iRow -1
            set firstTime 1
            foreach peak $Clust($iClust,$exp) {
                incr iRow
                if {$firstTime} {
                    nv_win aclear 1
                } else {
                    nv_win aclear 0
                }
                set fr $tl.fr1.spec.$iRow
                if {$firstTime} {
                    NvWinGoto $fr.$wn "x [expr $x-$tolH] [expr $x+$tolH]"
                    NvWinGoto $fr.$wn "y [expr $y-$tolN] [expr $y+$tolN]"
                }
                set zlab [$fr.$wn label z]
                set zppm [eval nv_peak elem $zlab.P $peak]
                NvWinGoto $fr.$wn "z $zppm $zppm"
                if {![catch "$fr.$wn label z2" z2lab]} {
                    set z2ppm [eval nv_peak elem $z2lab.P $peak]
                    NvWinGoto $fr.$wn "z2 $z2ppm $z2ppm"
                }
                bind $fr.$wn <a> {NvCBCAAddPeakToCluster %W;NvCBCAUpdateLinkCntrl}
                bind $fr.$wn <s> {NvCBCAShiftPeakCluster %W}
                bind $fr.$wn <n> {NvAddPeak %W %x %y 0}
                $fr.$wn peak_lab_type  4
                nv_win act $fr.$wn
                nv_win draw
                update
                if {$iRow == ($NvCBCA(nEditRows)-1)} {
                    set iRow -1
                    set firstTime 0
                }
            }
            incr wn
        }
	NvCBCAFindHSQC $iClust
    }
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    set plists [NvCBCAGetPkLists]
    foreach peaklist $plists {
        foreach peak $Clust($iClust,$peaklist) {
            $fr.lbox1 insert end $peak
        }
    }
    set NvCBCA(clust2) $Clust(nClust)
}



proc NvCBCALinkUpdateBox {boxnum mode} {
    global NvCBCA Clust
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox$boxnum delete 0 end
    if { $mode == "neigh" } {
    	set iClust [NvCBCANeighbor]
    } else {
	if {$boxnum == 1} {
	    set iClust $NvCBCA(clust)
	} else {
	    set iClust $NvCBCA(clust2)
 	}
    }
    set plists [NvCBCAGetPkLists]
    foreach peaklist $plists {
        foreach peak $Clust($iClust,$peaklist) {
            $fr.lbox$boxnum insert end $peak
        }
    }
}

proc NvCBCAFindHSQC {i} {
    global Clust NvCBCA
    set hncacb [lindex [NvCBCAGetPkLists] 0]
    set hsqc $NvCBCA(list)
    set Hlabel [lindex [eval nv_peak label $hncacb] 0]
    set Nlabel [lindex [eval nv_peak label $hncacb] 2]

    set peak [lindex $Clust($i,$hncacb) 0]

    if {$peak == ""} {set Clust(closestHSQC) none; return}
    set Hppm [eval nv_peak elem $Hlabel.P $peak]
    set Nppm [eval nv_peak elem $Nlabel.P $peak]

    nv_peak template $hsqc $Hlabel .01 $Nlabel .1
    set Clust(closestHSQC) [eval nv_peak find $hsqc $Hppm $Nppm] 
}

proc NvCBCAUpdateLinkCntrl {} {
    global NvCBCA Clust
    set iClust $NvCBCA(clust)
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    set plists [NvCBCAGetPkLists]
    foreach peaklist $plists {
        foreach peak $Clust($iClust,$peaklist) {
            $fr.lbox1 insert end $peak
        }
    }
}

proc NvConfirmPeak {value win x y} {
    set peaklist [win dispeak]
    set closest [eval nv_peak closet $peaklist [nv_win pix2ppm $x $y]]
    nv_peak status $closest $value
    puts "Confirmed peak $closest $value"
    $win draw
    update
}

proc NvCBCAShiftPeakCluster {win} {
    global NvCBCA Clust
    set peaklist [nv_win dispeak]
    set closest [nv_peak closet $peaklist]
    
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    
    set list1 [$fr.lbox1 get 0 end]
    set list2 [$fr.lbox2 get 0 end]
    set index [lsearch $list1 $closest]
    if {$index >= 0} {
        set list1 [lreplace $list1 $index $index]
        lappend list2 $closest
    } else {
        set index [lsearch $list2 $closest]
        if {$index >= 0} {
            set list2 [lreplace $list2 $index $index]
            lappend list1 $closest
        }
    }
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    foreach peak $list1 {
        $fr.lbox1 insert end $peak
    }
    foreach peak $list2 {
        $fr.lbox2 insert end $peak
    }
}


proc NvCBCAAddPeakToCluster {win} {
    global NvCBCA Clust
    set peaklist [nv_win dispeak]
    set closest [nv_peak closet $peaklist]
    if {![info exists Clust($NvCBCA(clust),$peaklist)]} {
        lappend Clust($NvCBCA(clust),$peaklist) $closest
    } else {
        if {[lsearch $Clust($NvCBCA(clust),$peaklist) $closest] < 0} {
            lappend Clust($NvCBCA(clust),$peaklist) $closest
        }
    }
    set dimName [lindex [nv_peak label $peaklist] 0]
    eval nv_peak elem $dimName.c $closest $NvCBCA(clust)
    puts "Added peak $closest to  $NvCBCA(clust)"
    $win draw
    update
}

proc NvCBCAMkPeakCntrl {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) peak
    set nm $NvCBCA(toplevel)
    
    if {[winfo exists $nm.fr1.fraginfo]} {
	destroy $nm.fr1.fraginfo
    }

    destroy $frame
    destroy $nm.mbar.cntrl
    destroy $nm.mbar.best
    destroy $nm.fr2.cntrl
    
    set frame $nm.mbar
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    
    #    frame $fr -relief raised
    #    pack $fr -side top  -fill both -expand y -anchor e
    #    raise [winfo toplevel $frame]
    
    set fr $frame.cntrl.list
    frame $fr
    pack $fr -side left -fill x
    
    label $fr.pkslbl -text PeakList -width 10
    pack $fr.pkslbl -side left
    
    entry $fr.pkslist -textvariable NvCBCA(list) -width 12
    pack $fr.pkslist -side left
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list) {}  0"
    
    set fr $frame.cntrl.peak
    frame $fr
    pack $fr -side left -fill x
    
    
    
    label $fr.pkslbl -text Peak -width 10
    pack $fr.pkslbl -side left
    
    entry $fr.cpeak -width 6 -textvariable NvCBCA(peak)
    pack $fr.cpeak -side left
    set NvCBCA(peak) 0
    button $fr.prev -bitmap @[file join $Nv_Priv(imagedir) down.xbm] -width 20 -height 20 -command "NvCBCAUpdatePeak $nm -1"
    button $fr.next -bitmap @[file join $Nv_Priv(imagedir) up.xbm] -width 20 -height 20 -command "NvCBCAUpdatePeak $nm 1"
    bind $fr.cpeak <Return> "NvCBCAUpdatePeak $nm 0"
    
    pack $fr.prev $fr.next -side left
    NvCBCASetupWindows $nm
    #nv_win lvl 11
    eu
    NvCBCAUpdatePeak $nm 0
}

proc NvCBCAMkClustCntrl {ctl} {
    global Nv_Priv NvCBCA
    #set NvCBCA(winMode) cluster4
    set NvCBCA(winMode) cluster
    
    set nm $NvCBCA(toplevel)

    if {[winfo exists $nm.fr1.fraginfo]} {
	destroy $nm.fr1.fraginfo
    }

    destroy $ctl
    toplevel $ctl
    set fr $ctl.cntrl
    frame $fr -relief raised
    pack $fr -side top  -fill both -expand y -anchor e
    raise [winfo toplevel $ctl]
    
    set frame $nm.mbar
    destroy $frame.cntrl
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    set fr $frame.cntrl
    
    
    entry $fr.cpeak -width 6 -textvariable NvCBCA(clust)
    pack $fr.cpeak -side left
    set NvCBCA(clust) 0
    button $fr.prev -bitmap @[file join $Nv_Priv(imagedir) down.xbm]  -width 20 -height 20 -command "NvCBCAUpdateClustEdit $frame -1"
    button $fr.next -bitmap @[file join $Nv_Priv(imagedir) up.xbm] -width 20 -height 20 -command "NvCBCAUpdateClustEdit $frame 1"
    bind $fr.cpeak <Return> "NvCBCAUpdateClustEdit $frame 0"
    
    pack $fr.prev $fr.next -side left
    checkbutton $fr.updateSpectra -text UpdateSpectra -variable NvCBCA(updateSpectra) \
    -command  "NvCBCAUpdateClustEdit $frame 0"
    pack $fr.updateSpectra -side left
    frame $fr.space -width 5 -relief raised
    pack $fr.space -side left
    label $fr.clusterLabel -text "Residues:" -relief raised
    pack $fr.clusterLabel -side left
    label $fr.clusterRes -text "" -width 28 -textvariable NvCBCA(clusterRes)
    pack $fr.clusterRes -side left
    
    set frame $ctl
    set fr $frame.cntrl.boxes
    frame $fr
    pack $fr -side top -fill both -expand y
    
    if {!$Nv_Priv(javaMode)} {
        listbox  $fr.lbox1 -yscrollcommand "$fr.scroll1 set" -font "Courier 10 bold" -width 24 -bg #999999  
        scrollbar $fr.scroll1 -command "$fr.lbox1 yview" -bg #999999
        listbox  $fr.lbox2 -yscrollcommand "$fr.scroll2 set" -font "Courier 10 bold" -width 24 -bg #999999
        scrollbar $fr.scroll2 -command "$fr.lbox2 yview" -bg #999999
        pack $fr.lbox1 -fill both -expand y -side left
        pack $fr.scroll1 -fill y -expand y -side left
        pack $fr.lbox2 -fill both -expand y -side left
        pack $fr.scroll2 -fill y -expand y -side left
    } else {
        jscrollpane $fr.spane1
        jscrollpane $fr.spane2
        listbox  $fr.lbox1 -font "Courier 10 bold" -width 24
        listbox  $fr.lbox2 -font "Courier 10 bold" -width 24
        $fr.spane1 add $fr.lbox1
        $fr.spane2 add $fr.lbox2
        pack $fr.spane1 -side left -fill both -expand yes
        pack $fr.spane2 -side left -fill both -expand yes
    }
    
    bind $fr.lbox1  <ButtonRelease-1> "NvCBCAGotoClust $fr 1 0;set NvCBCA(box) 1"
    bind $fr.lbox2  <ButtonRelease-1> "NvCBCAGotoClust $fr 2 3;set NvCBCA(box) 2"
    set bfr $frame.cntrl.statusfr
    frame $bfr
    pack $bfr -side top -fill x
    entry $bfr.status -textvariable NvCBCA(status) -fg black -bg #999999 
    pack $bfr.status -fill x -expand y
    set NvCBCA(status) ""
    
    set bfr $frame.cntrl.bbar
    frame $bfr
    pack $bfr -side top -fill x
    
    button $bfr.confirm1 -text UnConfirm -command "NvCBCAConfirm $frame unconfirm" -bg #999999
    button $bfr.confirm2 -text Confirm -command "NvCBCAConfirm $frame confirm;NvCBCAUpdateClustEdit $frame 0" -bg #999999
    pack $bfr.confirm1 $bfr.confirm2 -side left
    
    #    set bfr $frame.cntrl.bbar2
    #    frame $bfr
    #    pack $bfr -side top -fill x
    
    button $bfr.replace -text Replace -command "NvCBCAConfirm $frame replace" -bg #999999
    button $bfr.add -text Add -command "NvCBCAConfirm $frame add" -bg #999999
    button $bfr.delete -text Delete -command "NvCBCAConfirm $frame delete" -bg #999999
    button $bfr.goto -text Goto -command "NvCBCAConfirm $frame goto" -bg #999999
    pack $bfr.replace $bfr.add $bfr.goto -side left
    NvCBCASetupWindows $nm
    #nv_win lvl 11
    eu
    NvCBCAUpdateClustEdit $nm 0
}
proc NvCBCAMkFragCntrl {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) peak
    set nm $NvCBCA(toplevel)
    
    destroy $frame
    destroy $nm.mbar.cntrl
    destroy $nm.mbar.best
    destroy $nm.fr2.cntrl
    
    set frame $nm.mbar
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    set fr $frame.cntrl
    
    pack $fr -side left -fill both -expand y
    button $fr.crtfrags -text "Create fragments" -command "creatFrags"
    button $fr.alignfrags -text "Align in sequence" -command "alignFrags"
    button $fr.importPACES -text "Import:PACES" -command "import PACES"
    button $fr.importMONTE -text "Import:MONTE" -command "import MONTE"
    pack $fr.crtfrags $fr.alignfrags $fr.importPACES $fr.importMONTE -side left
    
    set fr $nm.fr2.cntrl
    frame $fr
    pack $fr -side top

    set fr1 $fr.firstList
    frame $fr1
    pack $fr1 -side top

    label $fr1.label -text "CA InterResidue:"
    entry $fr1.entry -textvariable NvCBCA(list,CA,inter)
    pack $fr1.label -side top
    pack $fr1.entry -side left
    
    menubutton $fr1.pksmbut -text Select -underline 0 \
    -menu $fr1.pksmbut.menu -width 7 -relief raised
    pack $fr1.pksmbut -side left
    
    set menu $fr1.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list,CA,inter) {}  0"

    set fr2 $fr.secondList
    frame $fr2
    pack $fr2 -side top

    label $fr2.label -text "CB InterResidue:"
    entry $fr2.entry -textvariable NvCBCA(list,CB,inter)
    pack $fr2.label -side top
    pack $fr2.entry -side left

    menubutton $fr2.pksmbut -text Select -underline 0 \
    -menu $fr2.pksmbut.menu -width 7 -relief raised
    pack $fr2.pksmbut -side left
    
    set menu $fr2.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list,CB,inter) {}  0"

    set fr3 $fr.thirdList
    frame $fr3
    pack $fr3 -side top

    label $fr3.label -text "CA IntraResidue:"
    entry $fr3.entry -textvariable NvCBCA(list,CA,intra)
    pack $fr3.label -side top 
    pack $fr3.entry -side left

    menubutton $fr3.pksmbut -text Select -underline 0 \
    -menu $fr3.pksmbut.menu -width 7 -relief raised
    pack $fr3.pksmbut -side left
    
    set menu $fr3.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list,CA,intra) {}  0"

    set fr4 $fr.fourthList
    frame $fr4
    pack $fr4 -side top

    label $fr4.label -text "CB IntraResidue:"
    entry $fr4.entry -textvariable NvCBCA(list,CB,intra)
    pack $fr4.label -side top 
    pack $fr4.entry -side left

    menubutton $fr4.pksmbut -text Select -underline 0 \
    -menu $fr4.pksmbut.menu -width 7 -relief raised
    pack $fr4.pksmbut -side left
    
    set menu $fr4.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list,CB,intra) {}  0"
}

proc NvCBCAMkTOCSY {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) tocsy
    set nm $NvCBCA(toplevel)
    destroy $frame.cntrl
    set fr $frame.cntrl
    frame $fr -relief raised
    pack $fr -side top  -fill both -expand y -anchor e
    raise [winfo toplevel $frame]
    
    set fr $frame.cntrl.mbar
    frame $fr
    pack $fr -side top -fill x
    
    entry $fr.cpeak -width 6 -textvariable NvCBCA(clust)
    pack $fr.cpeak -side left
    set NvCBCA(clust) 0
    button $fr.prev -bitmap @[file join $Nv_Priv(imagedir) down.xbm]  -width 20 -height 20 -command "NvCBCAUpdateTocsyEdit $frame -1"
    button $fr.next -bitmap @[file join $Nv_Priv(imagedir) up.xbm] -width 20 -height 20 -command "NvCBCAUpdateTocsyEdit $frame 1"
    bind $fr.cpeak <Return> "NvCBCAUpdateTocsyEdit $frame 0"
    
    pack $fr.prev $fr.next -side left
    
    set fr $frame.cntrl.boxes
    frame $fr
    pack $fr -side top -fill both -expand y
    listbox  $fr.lbox1 -yscrollcommand "$fr.scroll1 set"
    scrollbar $fr.scroll1 -command "$fr.lbox1 yview" -bg #999999
    listbox  $fr.lbox2 -yscrollcommand "$fr.scroll2 set"
    scrollbar $fr.scroll2 -command "$fr.lbox2 yview" -bg #999999
    
    pack $fr.lbox1 -fill both -expand y -side left
    pack $fr.scroll1 -fill y -expand y -side left
    pack $fr.lbox2 -fill both -expand y -side left
    pack $fr.scroll2 -fill y -expand y -side left
    bind $fr.lbox1  <ButtonRelease-1> "NvCBCAGotoClust $fr 1 0"
    bind $fr.lbox2  <ButtonRelease-1> "NvCBCAGotoClust $fr 2 3"
    set bfr $frame.cntrl.statusfr
    frame $bfr
    pack $bfr -side top -fill x
    entry $bfr.status -textvariable NvCBCA(status) -fg black
    pack $bfr.status -fill x -expand y
    set NvCBCA(status) ""
    
    set bfr $frame.cntrl.bbar
    frame $bfr
    pack $bfr -side top -fill x
    
    button $bfr.goto -text Goto -command "NvCBCAShowTocsy $frame"
    pack $bfr.goto -side left
    NvCBCASetupWindows $nm
}
proc NvCBCAShowTocsy {frame } {
    set tolH 0.2
    set tl $NvCBCA(toplevel)
    set fr $tl.fr1.spec.a
    foreach wn "0 1" {
        set h1 [$fr.2 cross[expr $wn+1]y]
        set c13 [$fr.3 cross[expr $wn+1]y]
        NvWinGoto $fr.$wn "x [expr $h1-$tolH] [expr $h1+$tolH]"
        NvWinGoto $fr.$wn "z ${c13}f ${c13}f"
        nv_win act $fr.$wn
        nv_win draw
        update
    }
}

proc NvCBCAConfirm {frame status} {
    global Clust NvCBCA
    set fr $frame.cntrl.boxes
    set selection [$fr.lbox1 curselection]
    if {$selection==""} {
        set selection [$fr.lbox2 curselection]
        if {$selection==""} {
            error "No selection"
        }
    }
    if {![info exists NvCBCA(box)]} {
        error "No selection"
    }
    set box $NvCBCA(box)
    if {$box==1} {
        set dir pre
        set odir suc
    } else {
        set dir suc
        set odir pre
    }
    set iClust $NvCBCA(clust)
    if {$status == "goto"} {
        set NvCBCA(clust) [lindex [lindex $Clust($iClust,$dir) $selection] 0]
        NvCBCAUpdateClustEdit $frame 0
        return
    }
    
    if {$status == "replace"} {
        set Clust($iClust,$dir) [lreplace $Clust($iClust,$dir) $selection $selection $NvCBCA(status)]
    } elseif {$status == "add"} {
        lappend Clust($iClust,$dir) $NvCBCA(status)
    } elseif {$status == "delete"} {
        set Clust($iClust,$dir) [lreplace $Clust($iClust,$dir) $selection $selection]
    } else {
        if {$box==1} { set dir pre } else {set dir suc}
        NvCBCADoConfirm $iClust $selection $status $dir
    }
}

proc NvCBCADoConfirm {iClust selection status dir} {
    global Clust
    if {$status=="unconfirm"} {
        set statVar 0
    } else {
        set statVar 1
    }
    
    if {$dir == "pre"} {
        set odir suc
    } else {
        set odir pre
    }
    
    if {$statVar > 0} {
        while {1} {
            set ok 1
            foreach ocluster $Clust($iClust,$dir) {
                set prevStat [lindex $ocluster 2]
                if {$statVar == $prevStat} {
                    incr statVar
                    set ok 0
                    continue
                }
            }
            if {$ok} {break}
        }
    }
    
    set cluster [lindex $Clust($iClust,$dir) $selection]
    set cluster [lreplace $cluster 2 2 $statVar]
    set Clust($iClust,$dir) [lreplace $Clust($iClust,$dir) $selection $selection $cluster]
    set NvCBCA(status) $cluster
    
    set jClust [lindex $cluster 0]
    set i 0
    foreach ocluster $Clust($jClust,$odir) {
        if {$iClust == [lindex $ocluster 0] } {
            set cluster [lindex $Clust($jClust,$odir) $i]
            set cluster [lreplace $cluster 2 2 $statVar]
            set Clust($jClust,$odir) [lreplace $Clust($jClust,$odir) $i $i $cluster]
            break
        }
        incr i
    }
    
}

proc NvCBCAFindConfirm {jClust dir} {
    global Clust
    foreach cluster $Clust($jClust,$dir) {
        set status [lindex $cluster 2]
        if {$status>0} {
            return [lindex $cluster 0]
        }
    }
    return -1
}

proc NvCBCAMkLinkEditCntrl {ctl} {
    global Nv_Priv NvCBCA Clust
    set nm $NvCBCA(toplevel)
    destroy $nm.fr2.cntrl
    

    if {[winfo exists $nm.fr1.fraginfo]} {
	destroy $nm.fr1.fraginfo
    }

    if {$NvCBCA(mode) == "clusteredit4"} {
        set NvCBCA(winMode) peak4
    } else {
        set NvCBCA(winMode) peak
    }
    
    set nm $NvCBCA(toplevel)
    destroy $nm.fr2.cntrl
    
    destroy $ctl
    toplevel $ctl
    set fr $ctl.cntrl
    frame $fr -relief raised
    pack $fr -side top  -fill both -expand y -anchor e
    raise [winfo toplevel $ctl]
    
    set frame $nm.mbar
    destroy $frame.cntrl
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    set fr $frame.cntrl
    
    label $fr.label -text Cluster
    pack $fr.label -side left
    entry $fr.cpeak -width 6 -textvariable NvCBCA(clust)
    pack $fr.cpeak -side left
    set NvCBCA(clust) 0
    
    button $fr.prev -bitmap @[file join $Nv_Priv(imagedir) down.xbm]  -width 20 -height 20 -command "NvCBCAUpdateLinkEdit $frame -1"
    button $fr.next -bitmap @[file join $Nv_Priv(imagedir) up.xbm] -width 20 -height 20 -command "NvCBCAUpdateLinkEdit $frame 1"
    bind $fr.cpeak <Return> "NvCBCAUpdateLinkEdit $frame 0"
    
    pack $fr.prev $fr.next -side left
    checkbutton $fr.updateSpectra -text UpdateSpectra -variable NvCBCA(updateSpectra) \
    -command  "NvCBCAUpdateLinkEdit $frame 0"
    pack $fr.updateSpectra -side left

    destroy $frame.best
    pack [frame $frame.best] -side left
    label $frame.best.bestTitle -text "HSQC Peak:"
    pack $frame.best.bestTitle -side left

    label $frame.best.bestHSQC -textvariable Clust(closestHSQC)
    pack $frame.best.bestHSQC -side left

    if {$NvCBCA(mode) == "clusteredit4"} {
        label $fr.nRows -text "# of Rows "
        set menu [tk_optionMenu $fr.nEditRows NvCBCA(nEditRows) 1 2 3 4 5 6]
        button $fr.refresh -text Update -command "NvCBCASetupWindows2 $nm \$NvCBCA(nEditRows)"
        pack $fr.nRows $fr.nEditRows $fr.refresh -side left
    }
    
    
    
    
    set frame $ctl
    set fr $frame.cntrl.clusters
    frame $fr
    pack $fr -side top -fill x
    label $fr.space1 -text " " -width 7
    label $fr.space2 -text " " 
    label $fr.space3 -text " " -width 7
    entry $fr.clust1 -textvariable NvCBCA(clust) -width 7
    entry $fr.clust2 -textvariable NvCBCA(clust2) -width 7

    bind $fr.clust1 <Return> "NvCBCALinkUpdateBox 1 reg"
    bind $fr.clust2 <Return> "NvCBCALinkUpdateBox 2 reg"

    pack $fr.space1 $fr.clust1  -side left -fill none 
    pack $fr.space2 -side left -fill both -expand yes
    pack $fr.clust2 $fr.space3 -side left -fill none
    set fr $frame.cntrl.boxes
    frame $fr
    pack $fr -side top -fill both -expand y
    
    if {!$Nv_Priv(javaMode)} {
        listbox  $fr.lbox1 -yscrollcommand "$fr.scroll1 set" -font "Courier 10 bold" -width 24
        scrollbar $fr.scroll1 -command "$fr.lbox1 yview" -bg #999999
        listbox  $fr.lbox2 -yscrollcommand "$fr.scroll2 set" -font "Courier 10 bold" -width 24
        scrollbar $fr.scroll2 -command "$fr.lbox2 yview" -bg #999999
        pack $fr.lbox1 -fill both -expand y -side left
        pack $fr.scroll1 -fill y -expand y -side left
        pack $fr.lbox2 -fill both -expand y -side left
        pack $fr.scroll2 -fill y -expand y -side left
    } else {
        jscrollpane $fr.spane1
        jscrollpane $fr.spane2
        listbox  $fr.lbox1 -font "Courier 10 bold" -width 24 -bd 2 -relief raised
        listbox  $fr.lbox2 -font "Courier 10 bold" -width 24 -bd 2 -relief raised
        $fr.spane1 add $fr.lbox1
        $fr.spane2 add $fr.lbox2
        pack $fr.spane1 -side left -fill both -expand yes
        pack $fr.spane2 -side left -fill both -expand yes
    }
    
   # bind $fr.lbox1  <ButtonRelease-1> "NvCBCAMoveList $fr 1 2"
   # bind $fr.lbox2  <ButtonRelease-1> "NvCBCAMoveList $fr 2 1"
    set bfr $frame.cntrl.bbar
    frame $bfr
    pack $bfr -side top -fill x
    
    button $bfr.closecluster -text "Neighbor" -command "NvCBCALinkUpdateBox 2 neigh"
    button $bfr.relink -text "Save Clusts" -command "NvCBCARelink $fr"
    button $bfr.moveright -text ">" -command "NvCBCAMoveList $fr 1 2"
    button $bfr.moveleft -text "<" -command "NvCBCAMoveList $fr 2 1"
    button $bfr.remove -text "Remove" -command "NvCBCARemove $fr"
    button $bfr.add -text "Add" -command "NvCBCAAdd $fr"
    #    button $bfr.cluster -text ReCluster -command NvCBCAFormClusters
    pack $bfr.closecluster $bfr.relink $bfr.moveleft $bfr.moveright $bfr.remove $bfr.add -side left

    if {$NvCBCA(mode) == "clusteredit4"} {
        NvCBCASetupWindows2 $nm $NvCBCA(nEditRows)
    } else {
        NvCBCASetupWindows $nm
    }
    #nv_win lvl 11
    eu
    NvCBCAUpdateLinkEdit $nm 0 
}

proc NvCBCAAdd {fr} { 
    global NvCBCA
    set addFrame $NvCBCA(addFrame)
    destroy $addFrame
    toplevel $addFrame
    label $addFrame.title -text "Adding to Cluster $NvCBCA(clust)"
    pack $addFrame.title -side top

    label $addFrame.label -text "Peaklist:"
    pack $addFrame.label -side top 

    frame $addFrame.lineone
    pack $addFrame.lineone -side top
    entry $addFrame.lineone.pkslist -textvariable NvCBCA(peaklist) -width 16
    pack $addFrame.lineone.pkslist -side left
    
    menubutton $addFrame.lineone.pksmbut -text Select -underline 0 \
    -menu $addFrame.lineone.pksmbut.menu -width 7 -relief raised
    pack $addFrame.lineone.pksmbut -side left 
    
    set menu $addFrame.lineone.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(peaklist) {}  0"
    
    frame $addFrame.linetwo
    pack $addFrame.linetwo -side top

    label $addFrame.linetwo.label2 -text "Peak:"
    pack $addFrame.linetwo.label2 -side left

    entry $addFrame.linetwo.peakEnt -textvariable NvCBCA(addPeaknum)
    pack $addFrame.linetwo.peakEnt -side left

    button $addFrame.addButton -text Add -command "NvCBCAAddEm $fr"
    pack $addFrame.addButton -side top
}

proc NvCBCAAddEm {fr} {
    global NvCBCA
    $fr.lbox1 insert end $NvCBCA(peaklist).$NvCBCA(addPeaknum)
}

proc NvCBCARemove {fr} {
    global NvCBCA
    set selection [$fr.lbox1 curselection]
    set boxnum 1
    if {$selection==""} {
	set selection [$fr.lbox2 curselection]
	set boxnum 2
        if {$selection==""} {
	    puts "No Peak selected"
	    return
	} 
	incr NvCBCA(newCluster) -1
    } else {
	set $NvCBCA(clust2) $NvCBCA(clust)
    }
    $fr.lbox$boxnum delete $selection
}

proc NvCBCAMoveList {fr box1 box2} {
    global NvCBCA
    set selection [$fr.lbox$box1 curselection]
    if {$selection==""} {
	puts "Error in move, either wrong direction or no peak selected"
	return
    }
    if {$box1 == 1} {
	incr NvCBCA(newCluster) 1
    } else {
	incr NvCBCA(newCluster) -1
    }
    set value [$fr.lbox$box1 get $selection]
    $fr.lbox$box1 delete $selection
    $fr.lbox$box2 insert end $value
}

proc NvCBCARelink {fr} {
    global Clust NvCBCA
    set list1 [$fr.lbox1 get 0 end]
    set list2 [$fr.lbox2 get 0 end]
    foreach peak [concat $list1 $list2] {
        eval nv_peak unlink $peak
    }
    if {[llength $list1]>0} {
        eval nv_peak link $list1
    }
    if {[llength $list2]>0} {
        eval nv_peak link $list2
    }
    
    set clust1  $NvCBCA(clust)
    set clust2  $NvCBCA(clust2)
    
    if {$NvCBCA(newCluster) > 0} {set NvCBCA(newCluster) 0 ; incr Clust(nClust)}
    set pklists [NvCBCAGetPkLists]
    
    
    foreach iClust "$clust1 $clust2" peaks [list $list1 $list2] {
        
        foreach pklist $pklists {
            set Clust($iClust,$pklist) ""
        }
        
        set HNsum 0.0
        set Nsum 0.0
        set npeaks 0
        foreach peak $peaks {
            set pklist [extract_list $peak]
            #	set pklistnum [lsearch [nv_peak list] $pklist]
            set HN [eval nv_peak elem $NvCBCA(HNdim).P $peak]
            set N [eval nv_peak elem $NvCBCA(Ndim).P $peak]
            set HNsum [expr $HNsum+$HN]
            set Nsum [expr $Nsum+$N]
            incr npeaks
            lappend Clust($iClust,$pklist) $peak
            puts "$iClust $peak"
        }
        if {[expr {$npeaks>0}]} {
            set Clust($iClust,HN) [expr $HNsum/$npeaks]
            set Clust($iClust,N) [expr $Nsum/$npeaks]
        }
    }
    NvCBCASetCluster
}


proc NvCBCAPreferences {nm} {
    global NvCBCA
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    toplevel $nm
    set frame $nm.top
    pack [frame $frame -border 2 -relief raised] -fill both -expand yes

    pack [label $frame.label -text "Refrencing Peaklist:"] -side left
    entry $frame.pkslist -textvariable NvCBCA(list) -width 22
    pack $frame.pkslist -side left
    
    menubutton $frame.pksmbut -text Select -underline 0 \
    -menu $frame.pksmbut.menu -width 7 -relief raised
    pack $frame.pksmbut -side left
    
    set menu $frame.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(list) {}  0"


    NvCBCASetupLabels $nm
    
    set frame $nm.rows
    frame $frame -border 2 -relief raised
    pack $nm.rows -fill both -expand yes
    
    set fr $frame.rowSelect
    frame $fr
    pack $fr -fill x -expand yes
    label $fr.label -text Row:
    pack $fr.label -side left
    
    
    foreach row "0 1 2 3 " {
        radiobutton $fr.r$row -value $row -text $row -command "NvCBCASetupRows $frame $row" -variable NvCBCA(pRow)
        pack $fr.r$row -side left
    }
    
    
    NvCBCASetupRows $nm.rows 0
    
    set frame $nm.matching
    frame $frame -border 2 -relief raised
    pack $frame -fill both -expand yes
    
  # set fr $frame.matchLists
  # frame $fr
  # pack $fr -fill x -expand yes
  # label $fr.label -text MatchLists  -width 12
  # pack $fr.label -side left
  # entry $fr.lists -textvariable NvCBCA(matchLists) -width 30
  # pack $fr.lists -side left -fill x -expand y
    
    set fr $frame.matchScript
    frame $fr
    pack $fr -fill x -expand yes
    label $fr.label -text MatchScript  -width 12
    pack $fr.label -side left
    entry $fr.script -textvariable NvCBCA(matchScript) -width 30
    pack $fr.script -side left -fill x -expand y
    
    frame $nm.buttons -border 2
    button $nm.buttons.fragprefs -text "Fragment Preferences" -command "NvCBCAFragPreferences .nvassignFragPrefs"
    button $nm.buttons.close -text Close -command "destroy $nm"
    pack $nm.buttons.fragprefs $nm.buttons.close -padx 5 -side left
    pack $nm.buttons -anchor center
}

proc NvCBCASetupLabels {nm } {
    global NvCBCA
    
    set frame $nm.labels
    frame $frame  -border 2 -relief raised
    pack $frame -side top -fill both -expand yes
    
    set fr $frame.labels1
    frame $fr
    pack $fr -side top -fill both -expand yes
    
    label $fr.row -text "" -width 6
    pack $fr.row -side left
    label $fr.hnclabels -text "Spectrum" -width 9
    pack $fr.hnclabels -side left
    label $fr.tol -text "Tolerances" -width 27
    pack $fr.tol -side left
    
    
    set fr $frame.colLabels
    frame $fr
    pack $fr -side top -fill x -expand y
    
    label $fr.row -text "" -width 6
    pack $fr.row -side left
    label $fr.hnclabels -text "Labels" -width 9
    pack $fr.hnclabels -side left
    label $fr.filter -text "Filter" -width 9
    pack $fr.filter -side left
    label $fr.intraTol -text "IntraList" -width 9
    pack $fr.intraTol -side left
    label $fr.interTol -text "InterList" -width 9
    pack $fr.interTol -side left
    
    set fr $frame.hn
    frame $fr
    pack $fr -side top -fill x -expand y
    
    label $fr.hnlabel -text "HN" -width 6
    pack $fr.hnlabel -side left
    entry $fr.hnentry -textvariable NvCBCA(HNdim) -width 9
    pack $fr.hnentry -side left
    entry $fr.filterTol -textvariable NvCBCA(filter,tolHN) -width 9
    pack $fr.filterTol -side left
    entry $fr.intraTol -textvariable NvCBCA(intraList,tolHN) -width 9
    pack $fr.intraTol -side left
    entry $fr.interTol -textvariable NvCBCA(interList,tolHN) -width 9
    pack $fr.interTol -side left
    
    set fr $frame.n
    frame $fr
    pack $fr -side top -fill x -expand y
    
    label $fr.nlabel -text N -width 6
    pack $fr.nlabel -side left
    entry $fr.nentry -text N -textvariable NvCBCA(Ndim) -width 9
    pack $fr.nentry -side left
    entry $fr.filterTol -textvariable NvCBCA(filter,tolN) -width 9
    pack $fr.filterTol -side left
    entry $fr.intraTol -textvariable NvCBCA(intraList,tolN) -width 9
    pack $fr.intraTol -side left
    entry $fr.interTol -textvariable NvCBCA(interList,tolN) -width 9
    pack $fr.interTol -side left
    
    set fr $frame.c
    frame $fr
    pack $fr -side top -fill x -expand y
    
    label $fr.clabel -text C -width 6
    pack $fr.clabel -side left
    entry $fr.centry -text N -textvariable NvCBCA(Cdim) -width 9
    pack $fr.centry -side left
    label $fr.filter -text ""  -width 9
    pack $fr.filter -side left
    label $fr.intraTol -text ""  -width 9
    pack $fr.intraTol -side left
    entry $fr.interTol -textvariable NvCBCA(tolC13) -width 9
    pack $fr.interTol -side left
}

proc NvCBCAFragPreferences {nm} {
    global Nv_Priv UPPM LPPM ResidueSign NvCBCA
    
    destroy $nm
    toplevel $nm
    
    set m [menu $nm.menubar -tearoff 0]
    $m add cascade -label File -menu [menu $m.file]
    $m.file add command -label "Read shifts" -command "NvGetFile resshiftRead"
    $m.file add command -label "Write shifts" -command "NvSaveFile resshiftWrite"
    $m.file add command -label Close -command "destroy $nm"
    $nm configure -menu $m
    
    set fn [frame $nm.header]
    label $fn.lbl1 -text "Amino acid shift ranges"
    pack $fn.lbl1 -side top
    frame $fn.lbl2
    label $fn.lbl2.1 -text "CA" -width 30
    label $fn.lbl2.2 -text "CB" -width 30
    pack $fn.lbl2.1 $fn.lbl2.2 -side left
    pack $fn.lbl2 -side top
    pack $fn
    
    set signlabels "- +"
    
    set fn [frame $nm.tbl]
    
    #   check to see if UPPM/LPPM table populated; if not, rdppm
    if { ![info exists UPPM] } {
        rdppm
    }
    
    foreach res "ALA ARG ASN ASP CYS GLN GLU GLY HIS ILE LEU LYS MET PHE PRO SER THR TRP TYR VAL" {
        set littleres [string tolower $res]
        set sfn [frame $fn.$littleres]
        label $sfn.reslabel -text "$res" -width 3
        pack $sfn.reslabel -side left
        foreach atom "CA CB" {
            entry $sfn.up$atom -textvariable UPPM($res,$atom) -width 5
            entry $sfn.low$atom -textvariable LPPM($res,$atom) -width 5
            pack $sfn.up$atom $sfn.low$atom -side left
            foreach sign "0 1" {
                radiobutton $sfn.pksign$sign$atom -value [expr 2*$sign-1] \
                -text [lindex $signlabels $sign] -variable ResidueSign($res,$atom)
                pack $sfn.pksign$sign$atom -side left
            }
        }
        pack $sfn -side top
    }
    pack $fn
    
    set fn [frame $nm.buttons1 -border 2 -relief raised]
    label $fn.r1lbl -text "Sign conventions:"
    button $fn.r1b1 -text "CA positive/CB negative" -command "ModResSign stdCACB"
    button $fn.r1b2 -text "Constant time" -command "ModResSign ctCACB"
    button $fn.r1b3 -text "Invert CB" -command "ModResSign invertCB"
    pack $fn.r1lbl $fn.r1b1 $fn.r1b2 $fn.r1b3 -side left
    pack $fn -anchor center
    
    
    
    foreach atom { CA CB } {
        set fn [frame $nm.buttons$atom -border 2]
        label $fn.r1lbl -text "$atom folding:"
        
        if { ![info exists NvCBCA(fold,$atom,spectrum)] } {
            set NvCBCA(fold,$atom,spectrum) "none - please select spectrum"
            set NvCBCA(fold,$atom,upper) 999.0
            set NvCBCA(fold,$atom,lower) -999.0
        }
        
        set label [MkNvCBCAFoldLabel $NvCBCA(fold,$atom,spectrum) $NvCBCA(Cdim) $NvCBCA(fold,$atom,upper) $NvCBCA(fold,$atom,lower)]
        
        menubutton $fn.mb$atom -text "$label" -menu $fn.mb$atom.menu
        set m [menu $fn.mb$atom.menu -tearoff 0]
        
        foreach dataset [nv_dataset open] {
            set dimnames {}
            for {set i 1} {$i<=[nv_dataset ndim $dataset]} {incr i} {
                lappend dimnames [nv_dataset label $dataset $i]
            }
            
            set matchdim [expr [lsearch $dimnames $NvCBCA(Cdim)]+1]
            set ppmperpoint [expr [nv_dataset sw $dataset $matchdim]/([nv_dataset sf $dataset $matchdim]*[nv_dataset size $dataset $matchdim])]
            set upperppm [expr [nv_dataset ref $dataset $matchdim]+(([nv_dataset refpt $dataset $matchdim]-1)*$ppmperpoint)]
            set lowerppm [expr [nv_dataset ref $dataset $matchdim]-(([nv_dataset size $dataset $matchdim]-[nv_dataset refpt $dataset $matchdim])*$ppmperpoint)]
            
            set label [MkNvCBCAFoldLabel $dataset $NvCBCA(Cdim) $upperppm $lowerppm]
            $m add command -label $label -command "SetNvCBCAFold $atom $dataset $upperppm $lowerppm; $fn.mb$atom config -text [list $label]"
        }
        
        
        button $fn.r1b1 -text "Unfold" -command "UnfoldNvCBCAResidues $atom $NvCBCA(fold,$atom,upper) $NvCBCA(fold,$atom,lower)"
        pack $fn.r1lbl $fn.mb$atom $fn.r1b1 -padx 10 -side left
        pack $fn -anchor center
    }
}

proc SetNvCBCAFold { atom dataset upperppm lowerppm } {
    global NvCBCA
    
    set NvCBCA(fold,$atom,spectrum) $dataset
    set NvCBCA(fold,$atom,upper) $upperppm
    set NvCBCA(fold,$atom,lower) $lowerppm
}

proc MkNvCBCAFoldLabel { dataset dimname upper lower } {
    set label [format "%s    %s:  %5.1f - %5.1f ppm" $dataset $dimname $upper $lower]
}

proc UnfoldNvCBCAResidues { atom upper lower } {
    global NvCBCA UPPM LPPM
    
    set sweep [expr abs($upper-$lower)]
    
    foreach i [array names UPPM *,$atom] {
        
        if { $UPPM($i)=="NA" || $LPPM($i)=="NA" } { continue }
        if {$UPPM($i)>$upper} { set UPPM($i) [expr $UPPM($i)-$sweep]
        } elseif {$UPPM($i)<$lower} { set UPPM($i) [expr $UPPM($i)+$sweep] }
        
        if {$LPPM($i)>$upper} { set LPPM($i) [expr $LPPM($i)-$sweep]
        } elseif {$LPPM($i)<$lower} { set LPPM($i) [expr $LPPM($i)+$sweep] }
    }
    
}

proc ModResSign {mode} {
    global ResidueSign
    
    #  special case: invert CB signs
    if {$mode=="invertCB"} {
        foreach val [array names ResidueSign *,CB] {
            set ResidueSign($val) [expr -$ResidueSign($val)]
        }
        return
    }
    
    #  signdat contains list of signs for standard acquisition modes
    #	format:  1 or -1 in list of lists {{CA CB} {CA CB}....} in order
    #	of alphabetical sorting of 3 letter aa codes
    #	             " ALA    ARG    ASN    ASP    CYS    GLN    GLU   \
    #			 GLY    HIS    ILE    LEU    LYS    MET    PHE   \
    #			 PRO    SER    THR    TRP    TYR    VAL  "
    
    switch $mode {
        stdCACB {
            set signdat "{1 -1} {1 -1} {1 -1} {1 -1} {1 -1} {1 -1} {1 -1} \
            {1 -1} {1 -1} {1 -1} {1 -1} {1 -1} {1 -1} {1 -1}  \
        {1 -1} {1 -1} {1 -1} {1 -1} {1 -1} {1 -1}" }
        ctCACB {
            set signdat "{1 1} {1 -1} {1 1} {1 1} {1 1} {1 -1} {1 -1} \
            {-1 1} {1 1} {1 1} {1 -1} {1 -1} {1 -1} {1 1}  \
        {1 -1} {1 1} {1 -1} {1 1} {1 1} {1 1}" }
    }
    
    foreach res "ALA ARG ASN ASP CYS GLN GLU GLY HIS ILE LEU LYS MET PHE PRO SER THR TRP TYR VAL" sign $signdat {
        set ResidueSign($res,CA) [lindex $sign 0]
        set ResidueSign($res,CB) [lindex $sign 1]
    }
}

proc NvCBCASetupRows {nm iRow} {
    global NvCBCA
    
    set frame $nm.rows
    destroy $frame
    frame $frame
    pack $frame -side top -fill both -expand yes
    
    set explist {interResidue intraResidue}
    
    set fr $frame.onoff
    frame $fr
    pack $fr -side top -fill both -expand y
    label $fr.label -text "Show row"
    checkbutton $fr.on  -variable NvCBCA($iRow,active) 
    pack $fr.label $fr.on -side left
    
    set fr $frame.limits
    frame $fr
    pack $fr -side top
    label $fr.lbl -text Limits -width 10
    pack $fr.lbl -side left
    checkbutton $fr.full -text Full -variable NvCBCA($iRow,full)
    pack $fr.full -side left
    set NvCBCA($iRow,full) 1
    entry $fr.minY -textvariable NvCBCA($iRow,minY) -width 6
    entry $fr.maxY -textvariable NvCBCA($iRow,maxY) -width 6
    pack $fr.minY $fr.maxY -side left
    
    foreach exp $explist {
        set fr $frame.$exp
        frame $fr
        pack $fr -side top -fill both -expand y
        
        label $fr.title -text $exp
        pack  $fr.title -side top
        
        frame $fr.exp
        pack $fr.exp -side top -fill x -expand y
        
        label $fr.exp.lbl -text Filename -width 10
        pack $fr.exp.lbl -side left
        
        entry $fr.exp.file -textvariable NvCBCA($iRow,$exp,file) -width 12
        pack $fr.exp.file -side left -fill x -expand y
        
        menubutton $fr.exp.mbut -text Select -underline 0 \
        -menu $fr.exp.mbut.menu -width 7 -relief raised
        pack $fr.exp.mbut -side right
        
        set menu $fr.exp.mbut.menu
        menu $menu -postcommand "NvFillDatasetsMenu $menu NvCBCA($iRow,$exp,file) {}  0"
        
        frame $fr.pks
        pack $fr.pks -side top -fill x -expand y
        
        label $fr.pks.lbl -text PeakList -width 10
        pack $fr.pks.lbl -side left
        
        entry $fr.pks.list -textvariable NvCBCA($iRow,$exp,peaks) -width 12
        pack $fr.pks.list -side left -fill x -expand y
        
        menubutton $fr.pks.mbut -text Select -underline 0 \
        -menu $fr.pks.mbut.menu -width 7 -relief raised
        pack $fr.pks.mbut -side right
        
        set menu $fr.pks.mbut.menu
        menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA($iRow,$exp,peaks) {}  0"
        
        
    }
}
proc NvCBCAMkLinks {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) peak
    set nm $NvCBCA(toplevel)
    
    if {[winfo exists $nm.fr1.fraginfo]} {
	destroy $nm.fr1.fraginfo
    }

    destroy $frame
    destroy $nm.mbar.cntrl
    destroy $nm.mbar.best
    destroy $nm.fr2.cntrl
    
    set frame $nm.mbar
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    
    #global NvCBCA
    #set nm $NvCBCA(toplevel)
    #destroy $frame.cntrl
    #set fr $frame.cntrl
    #frame $fr
    #pack $fr -side left  -fill both -expand y -anchor e
    #raise [winfo toplevel $frame]
    
    foreach exp "intraList interList" {
        set fr $frame.cntrl.$exp
        frame $fr
        pack $fr -side left -fill both -expand y
        
        button $fr.$exp -text "Link $exp" -command "NvCBCADoLinks $exp"
        pack $fr.$exp
        
    }
    set fr $nm.fr2.cntrl
    frame $fr
    pack $fr -side top -fill both
    
    label $fr.filterTolL -text Tolerances:
    pack $fr.filterTolL -side top -fill x
   
    set fr1 $fr.label
    frame $fr1
    pack $fr1 -side top -fill x

    label $fr1.tolLHN -text " " -width 3
    pack $fr1.tolLHN -side left

    label $fr1.interTol -text IntraList -width 9
    pack $fr1.interTol -side left
    
    label $fr1.intraTol -text InterList -width 9
    pack $fr1.intraTol -side left
   
    set fr2 $fr.hn
    frame $fr2
    pack $fr2 -side top -fill x

    label $fr2.tolLHN -text $NvCBCA(HNdim) -width 3
    pack $fr2.tolLHN -side left

    entry $fr2.interTol -textvariable NvCBCA(intraList,tolHN) -width 9
    pack $fr2.interTol -side left
    
    entry $fr2.intraTol -textvariable NvCBCA(interList,tolHN) -width 9
    pack $fr2.intraTol -side left

    set fr3 $fr.n
    frame $fr3
    pack $fr3 -side top -fill x

    label $fr3.tolLN -text $NvCBCA(Ndim) -width 3
    pack $fr3.tolLN -side left -fill x -expand y

    entry $fr3.interTolN -textvariable NvCBCA(intraList,tolN) -width 9
    pack $fr3.interTolN -side left

    entry $fr3.intraTolN -textvariable NvCBCA(interList,tolN) -width 9
    pack $fr3.intraTolN -side left
}
proc NvCBCAMkClusterMatchCntrl {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) peak
    set nm $NvCBCA(toplevel)
    
    destroy $frame
    destroy $nm.mbar.cntrl
    destroy $nm.mbar.best
    destroy $nm.fr2.cntrl
    
    set frame $nm.mbar
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    set fr $frame.cntrl
    
    
    button $fr.doMatch -text Match -command "NvCBCA::LinkClust $fr"
    pack $fr.doMatch -side left
    label $fr.matchStatus -width 8 -textvariable NvCBCA(matchStatus)
    pack $fr.matchStatus -side left
    
    button $fr.saveData -text "Save Cluster Data" -command "getAllppms"
    pack $fr.saveData -side left
    
    button $fr.exportPACES -text "Export Data to PACES file" -command DumpClust
    button $fr.exportMONTE -text "Export Data to MONTE file" -command DumpClustMONTE 
    pack $fr.exportPACES $fr.exportMONTE -side left
}

proc NvCBCAMkFilterCntrl {frame} {
    global Nv_Priv NvCBCA
    set NvCBCA(winMode) peak
    set nm $NvCBCA(toplevel)
    
    destroy $frame
    destroy $nm.mbar.cntrl
    destroy $nm.mbar.best
    destroy $nm.fr2.cntrl
    
    set frame $nm.mbar
    frame $frame.cntrl -relief sunken -border 2
    pack $frame.cntrl -side left -fill x
    set fr $frame.cntrl
    
    label $fr.pkslbl -text "Ref PeakList" -width 10
    pack $fr.pkslbl -side left
    
    entry $fr.pkslist -textvariable NvCBCA(filter,list) -width 12
    pack $fr.pkslist -side left
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(filter,list) {}  0"

    label $fr.pkflbl -text "Peaks Filtering" -width 13
    pack $fr.pkflbl -side left
    
    entry $fr.pkslist2 -textvariable NvCBCA(filterLists) -width 12
    pack $fr.pkslist2 -side left
    
    menubutton $fr.pksmbut2 -text Select -underline 0 \
    -menu $fr.pksmbut2.menu -width 7 -relief raised
    pack $fr.pksmbut2 -side left
    
    set menu $fr.pksmbut2.menu
    menu $menu -postcommand "NvFillPeakMenu $menu NvCBCA(filterLists) {}  0"
    
    set busy Filtering
 
    button $fr.doFilter -text "Filter Peaks" -command "puts $busy ; NvCBCA::FilterPeaks"
    pack $fr.doFilter -side left

    set fr $nm.fr2.cntrl
    frame $fr
    pack $fr -side top -fill both
    
    label $fr.filterTolL -text Tolerances:
    pack $fr.filterTolL -side top -fill x
    
    set fr1 $fr.hn
    frame $fr1
    pack $fr1 -side top -fill x

    label $fr1.filterTolLHN -text $NvCBCA(HNdim)
    pack $fr1.filterTolLHN -side left -fill x -expand y

    entry $fr1.filterTol -textvariable NvCBCA(filter,tolHN) -width 9
    pack $fr1.filterTol -side left

    set fr2 $fr.n
    frame $fr2
    pack $fr2 -side top -fill x

    label $fr2.filterTolLN -text $NvCBCA(Ndim)
    pack $fr2.filterTolLN -side left -fill x -expand y

    entry $fr2.filterTolN -textvariable NvCBCA(filter,tolN) -width 9
    pack $fr2.filterTolN -side left
}

proc NvCBCAMkClusterEditor {{iClust 0}} {
    global Nv_Priv Clust NvCBCA
    set nm .nvassignClusterEditor
    set NvCBCA(Editor,iClust) $iClust
    destroy $nm
    toplevel $nm
    wm title $nm ClusterEditor
    set fr $nm.bbar
    frame $fr
    pack $fr -side top -fill x -expand y
    button $fr.prev -bitmap @[file join $Nv_Priv(imagedir) down.xbm] -width 20 -height 20 -command "NvCBCAUpdateClusterEditor move -1"
    button $fr.next -bitmap @[file join $Nv_Priv(imagedir) up.xbm] -width 20 -height 20 -command "NvCBCAUpdateClusterEditor move 1"
    button $fr.update -text Update -command {NvCBCAUpdateClusterEditor goto $NvCBCA(Editor,iClust)}
    button $fr.close -text Close -command "destroy $nm"
    entry $fr.iclust -textvariable NvCBCA(Editor,iClust) -width 12
    pack $fr.prev $fr.next $fr.iclust $fr.update $fr.close -side left
    set fr $nm.fr1
    frame $fr
    pack $fr -side top -fill x -expand yes
    foreach elem "HN N Seq V" {
        set label $fr.label$elem
        set entry $fr.entry$elem
        label $label -text $elem -width 4
        entry $entry -textvariable Clust(0,$elem) -width 8
        pack $label $entry -side left
    }
    
    set fixed "$iClust,HN $iClust,N $iClust,Seq $iClust,V $iClust,pre $iClust,suc"
    set names [array names Clust $iClust,*]
    foreach name $names {
        if {[lsearch $fixed $name] == -1} {
            lappend experiments $name
        }
    }
    set frame $nm.experiments
    frame $frame
    pack $frame -side top -fill both -expand yes
    label $frame.label -text "Peaks in cluster"
    pack $frame.label -side top
    set label1(suc) "Succeeding Clusters"
    set label1(pre) "Preceeding Clusters"
    foreach elem $experiments {
        if {[regexp {([0-9]*)(,)(.*)} $elem all clust comma exp]} {
            set fr $frame.[string tolower $exp]
            frame $fr
            pack $fr -side top -fill x -expand y
            label $fr.label -text $exp -width 10
            entry $fr.entry -textvariable Clust($iClust,$exp) -width 30
            pack $fr.label $fr.entry -side left
        }
    }
    foreach dir "pre suc" {
        set fr $frame.label$dir
        frame $fr
        pack $fr -side top -fill x -expand y
        label $fr.label -text $label1($dir)
        button $fr.update -text Update -command "NvCBCAGetClusterEditor $nm $dir"
        pack $fr.label $fr.update -side left
        set fr $frame.$dir
        frame $fr
        pack $fr -side top -fill both -expand y
        set text $fr.text
        text $text  -height 8 -width 80 -yscrollcommand "$fr.scroll set"
        $text delete 1.0 end
        scrollbar $fr.scroll -command "$text yview" -bg #999999
        pack $text -side left -fill both -expand y
        pack $fr.scroll -side right -fill y -expand y
    }
    NvCBCAUpdateClusterEditor goto  $iClust
}

proc NvCBCAGetClusterEditor {nm dir} {
    global Clust NvCBCA
    if {![winfo exists $nm]} {error "Cluster Editor $nm doesn't exist"}
    set iClust $NvCBCA(Editor,iClust)
    if {![info exists Clust($iClust,$dir)]} {return}
    set frame $nm.experiments
    set fr $frame.$dir
    set text $fr.text
    set end [$fr.text index end]
    regexp {([0-9]*)(\.)([0-9]*)} $end all lastLine dot lastchar
    incr lastLine -1
    set Clust($iClust,$dir) ""
    for {set i 1} {$i<$lastLine} {incr i} {
        set string [$text get $i.0 $i.end]
        lappend Clust($iClust,$dir) $string
    }
    
}
proc NvCBCAUpdateClusterEditor {mode iClust} {
    global Clust NvCBCA
    set nm .nvassignClusterEditor
    if {![winfo exists $nm]} {return}
    if {![info exists Clust]} {return}
    if {$mode == "goto"} {
        set NvCBCA(Editor,iClust) $iClust
    } else {
        incr NvCBCA(Editor,iClust) $iClust
        set iClust $NvCBCA(Editor,iClust)
    }
    wm title $nm ClusterEditor:$iClust
    set fr $nm.fr1
    foreach elem "HN N Seq V" {
        set entry $fr.entry$elem
        $entry config -textvariable Clust($iClust,$elem)
    }
    set fixed "$iClust,HN $iClust,N $iClust,Seq $iClust,V $iClust,pre $iClust,suc"
    set names [array names Clust $iClust,*]
    foreach name $names {
        if {[lsearch $fixed $name] == -1} {
            lappend experiments $name
        }
    }
    set frame $nm.experiments
    foreach elem $experiments {
        if {[regexp {([0-9]*)(,)(.*)} $elem all clust comma exp]} {
            set fr $frame.[string tolower $exp]
            $fr.entry config -textvariable Clust($iClust,$exp)
        }
    }
    foreach dir "pre suc" {
        set fr $frame.$dir
        set text $fr.text
        $text delete 1.0 end
        if {[info exists Clust($iClust,$dir)]} {
            foreach line $Clust($iClust,$dir) {
                $text insert end $line\n
            }
        }
    }
    
}


proc NvCBCAGetPkLists {} {
    global NvCBCA
    set plists ""
    
    for {set iRow 0} {$iRow<$NvCBCA(maxRows)} {incr iRow} {
        if {$NvCBCA($iRow,active)} {
            foreach type "intraResidue interResidue" {
                if {[info exists NvCBCA($iRow,$type,peaks)]} {
                    set plist $NvCBCA($iRow,$type,peaks)
                    if {[lsearch $plists $plist]<0} {
                        lappend plists $plist
                    }
                }
            }
        }
    }
    return $plists
}

proc NvCBCADoLinks {mode} {
    global NvCBCA
    set htol $NvCBCA($mode,tolHN)
    set ntol $NvCBCA($mode,tolN)
    
    set plists [NvCBCAGetPkLists]
    
    foreach plist $plists {
        nv_peak temp $plist $NvCBCA(HNdim) $htol $NvCBCA(Ndim) $ntol
    }
    
    if {$mode == "intraList" } {
        foreach plist $plists { nv_peak zlink $plist }
        foreach plist $plists {
            puts "Clustering list $plist"
            nv_peak cluster $plist
        }
    } else {
        puts "Clustering lists $plists"
        eval nv_peak cluster $plists
        NvCBCAFormClusters
    }
}

proc NvCBCAFormClusters {} {
    global NvCBCA
    set plists [NvCBCAGetPkLists]
    puts "Clustering lists $plists"
    NvFormClusters $plists
    NvCBCASetCluster
    NvCBCACountClusters
}

proc NvCBCACountClusters {} {
    global Clust NvCBCA
    set plists [NvCBCAGetPkLists]
  # set plists $NvCBCA(matchLists)
    
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        set npks 0
        foreach exp $plists {
            incr npks [llength $Clust($i,$exp)]
        }
        if {$npks > 18} {set npks 18}
        if {![info exists peakCount($npks)]} {
            set peakCount($npks) 0
        }
        incr peakCount($npks)
    }
    for {set i 0} {$i <= 18} {incr i} {
        if {[info exists peakCount($i)]} {
            puts "$peakCount($i) cluster(s) with $i peaks"
        }
    }
}

proc NvCBCASetCluster {} {
    global Clust
    set plists [NvCBCAGetPkLists]
    
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        foreach exp $plists {
            set dimName [lindex [nv_peak label $exp] 0]
            set clust $Clust($i,$exp)
            foreach pk $clust {
                eval nv_peak elem $dimName.c $pk $i
            }
        }
    }
}

proc NvCBCANeighbor {} {
    global Clust NvCBCA
    set plists [NvCBCAGetPkLists]
    set refClust $NvCBCA(clust)
    set HNa $Clust($refClust,HN)
    set Na $Clust($refClust,N)
    set min 1.0e6
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        if {$i==$refClust} {continue}
        if {![info exists Clust($i,HN)]} {continue}
        if {![info exists Clust($i,N)]} {continue}
        set HNb $Clust($i,HN)
        set Nb $Clust($i,N)
        set delta [expr {($HNa-$HNb)*($HNa-$HNb)+(($Na-$Nb)*($Na-$Nb)/25)}]
        if {[expr {$delta < $min}]} {
            set min $delta
            set minClust $i
        }
    }
    set NvCBCA(clust2) $minClust
    return $minClust
}
proc NvCBCARestore {} {
    set filename [tk_getOpenFile -title "Choose a previous session to restore" -initialdir [pwd]]
    if {$filename != ""} {
    	source $filename
    }
}

proc NvCBCASave {{checkPoint 1}} {
   set filename [tk_getSaveFile -title "Choose a Filename or Existing File" -initialdir [pwd]] 
   if {$filename == ""} { return } 
   if {[file exists $filename]} {
   	file delete $filename
   	puts "removing $filename"
   }
   foreach var "NvCBCA Clust Fragment Seq" {
        global $var
        if {[catch "dump  variable $var" output]} {
            continue
        }
#        if {[file exists $var]} {
#            if {[catch "glob $var.*" files]} {
 #               set ext 1
 #           } else {
 #              set files [lsort -dictionary $files]
 #              set last [lindex $files end]
  #             if {[regexp "($var)\.(\[0-9\]*)" $last a b ext]} {
  #                 incr ext
  #            } else {
   #                error "Can't figure out next extension"
  #            }
                
 #           }
 #           file copy $var $var.$ext
 #           puts "Copied $var to $var.$ext"
#       }
	
        set f1 [open $filename a]
        puts $f1 $output
        close $f1
        puts "Saved file $var"
    }
}

proc makeActive { framename } {
    global NvCBCA
    $NvCBCA(last) configure -bg #dddddd -activebackground #cccccc
    $framename configure -bg #aa5555 -activebackground #aa4444
}

proc eu {} {
    set win [eval nv_win active]
    set lvl [eval nv_win lvl]
    set nlvl [eval nv_win nlvl]
    set clm [eval nv_win clm]
    set peakcolor [eval nv_win peak_col_on]
    set peakcoloroff [eval nv_win peak_col_off]
    set peakcoltype [eval nv_win peak_col_type]
    set tl [winfo toplevel $win]
    set peakoff [eval nv_win peak_off]
    set lab_type [eval nv_win peak_lab_type] 
    set children [info commands $tl.fr1.spec.0.*]
    foreach child $children {
	nv_win act $child
        nv_win peak_off $peakoff
        nv_win peak_col_type $peakcoltype
	nv_win lvl $lvl
	nv_win peak_col_on $peakcolor
	nv_win peak_col_off $peakcoloroff
	nv_win negcolor 2
	nv_win nlvl $nlvl
	nv_win clm $clm
 	nv_win peak_lab_type $lab_type
	nv_win draw
    }
    set children [info commands $tl.fr1.spec.1.*]
    foreach child $children {
	nv_win act $child
        nv_win peak_off $peakoff
        nv_win peak_col_type $peakcoltype
	nv_win lvl $lvl
	nv_win nlvl $nlvl
	nv_win clm $clm
	nv_win peak_col_on $peakcolor
	nv_win peak_col_off $peakcoloroff
	nv_win negcolor 2
 	nv_win peak_lab_type $lab_type
	nv_win draw
    }
}   

proc NvCBCAToggle {} {
    if {[nv_win peak_lab_type]==0} {
	nv_win peak_lab_type 4
    } else {
	nv_win peak_lab_type 0
    } 
    nv_win draw
}

proc NvCBCAControlUpdate {iClust} {
    global NvCBCA Clust
    set frame $NvCBCA(controlFrame)
    set fr $frame.cntrl.boxes
    $fr.lbox1 delete 0 end
    $fr.lbox2 delete 0 end
    set color white
    set index 0
    foreach clust $Clust($iClust,pre) {
        set pclust [lindex $clust 0]
        set confClust [NvCBCAFindConfirm  $pclust suc]
        set sclusters $Clust($pclust,suc)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        if {$confirmed} {
            set color yellow
        } elseif {$confClust != -1 && $confClust != $iClust} {
 	    set color #B0A050 
	} else {
	    set color #999999
	}
        set nmatches [lindex $clust 3]
        set outs [format "%4d %4.2f %1d %1d %3d %3d" $pclust $score $confirmed $nmatches $sclust $confClust]
        $fr.lbox1 insert end $outs
 	$fr.lbox1 itemconfigure $index -bg red
	incr $index 1
    }
    
    if {[llength $Clust($iClust,pre)] > 0} {
        $fr.lbox1 select set  0
        update
        NvCBCAGotoClust $fr 1 0
    }
    
 #   $fr.lbox1 config -bg $color
    set color white
    set index 0
    foreach clust $Clust($iClust,suc) {
        set pclust [lindex $clust 0]
        set confClust [NvCBCAFindConfirm  $pclust pre]
        set sclusters $Clust($pclust,pre)
        if {[llength $sclusters]>0} {
            set sclust [lindex [lindex $sclusters 0] 0]
        }  else {set sclust -1}
        set score [lindex $clust 1]
        set confirmed [lindex $clust 2]
        if {$confirmed} {
            set color yellow
        } elseif {$confClust != -1 && $confClust != $iClust} {
	    set color #B0A050 
	} else {
	    set color #999999
	}
        set nmatches [lindex $clust 3]
        set outs [format "%4d %4.2f %1d %1d %3d %3d" $pclust $score $confirmed $nmatches $sclust $confClust]
        $fr.lbox2 insert end $outs
	$fr.lbox2 itemconfigure $index -bg red
	incr $index 1

    }
    if {[llength $Clust($iClust,suc)] > 0} {
        $fr.lbox2 select  set 0
        update
        NvCBCAGotoClust $fr 2 3
    }
    
  #  $fr.lbox2 config -bg $color
}

proc creatFrags {} {
    global NvCBCA W Fragment
    set nm $NvCBCA(toplevel)
    set W 5
    rdppm
    ScoreConfirmedClusts
    NvCBCA::TreeLinks
    CleanFrags

    if {[winfo exists $nm.fr1.spec]} {
        destroy $nm.fr1.spec
    }
    if {[winfo exists $nm.fr1.fraginfo]} {
	destroy $nm.fr1.fraginfo
    }

    frame $nm.fr1.fraginfo
    pack $nm.fr1.fraginfo

    set frame $nm.fr1.fraginfo

    label $frame.title -text "Fragments Created: "
    pack $frame.title -side top

    frame $frame.labels -bg #bb5555
    pack $frame.labels -side left

    frame $frame.clusters -bg #bb5555
    pack $frame.clusters -side left

    frame $frame.seqinfo -bg #bb5555
    pack $frame.seqinfo -side left

    frame $frame.button -bg #bb5555
    pack $frame.button -side left

    pack [label $frame.labels.label -text "Frag Num:" -bg #bb5555] -side top
    pack [label $frame.clusters.label -text "Cluster Sequence of Fragment" -bg #bb5555] -side top
    pack [label $frame.seqinfo.label -text "Seq Start" -bg #bb5555] -side top 
    pack [label $frame.button.label -text "Config" -bg #bb5555] -side top

    pack [frame $frame.labels.bottom -bg #ff5555] [frame $frame.clusters.bottom -bg #ff7777] [frame $frame.seqinfo.bottom -bg #ff5555] [frame $frame.button.bottom -bg #ff7777] -side top  

    for {set i 0} {$i<$Fragment(nFrag)} {incr i 1} {
	pack [label $frame.labels.bottom.label${i} -text "Frag $i" -bg #ff5555 -padx 12 -pady 5] -side top

	pack [label $frame.clusters.bottom.frag${i} -anchor w -text $Fragment($i,clust) -bg #ff7777 -pady 5] -side top

	pack [label $frame.seqinfo.bottom.frag${i} -text " " -bg #ff5555 -padx 27 -pady 5] -side top

	pack [button $frame.button.bottom.frag${i} -text "configure" -bg #ff7777 -command "configFragSeq $i"] -side top
    }
}

proc alignFrags {} {
    global Fragment NvCBCA
    set Fragment(AtmTypes) "CA CB" 
    AssignFrag assign.out 
    GetPPM "CA CB HN N" 
    NvCBCASetCluster 

    set frame $NvCBCA(toplevel).fr1.fraginfo
    for {set i 0} {$i<$Fragment(nFrag)} {incr i 1} {
	destroy $frame.seqinfo.bottom.frag${i}
	pack [label $frame.seqinfo.bottom.frag${i} -text $Fragment($i,seqPos) -bg #ff5555 -padx 15 -pady 5] -side top
    }
}

proc CleanFrags {} {
    global Fragment
    for {set i 0} {$i<$Fragment(nFrag)} {incr i 1} {
	set lastClst [lindex $Fragment($i,clst) end]
	set clstend [lindex $lastClst 1]
	if {$clstend == ""} {
	    set end [llength $Fragment($i,clst)]
	    incr end -2
	    set Fragment($i,clst) [lrange $Fragment($i,clst) 0 $end]
	    set Fragment($i,link) [lrange $Fragment($i,link) 0 $end]
	}
    }
    for {set i 0} {$i<$Fragment(nFrag)} {incr i 1} {
	for {set j [expr $i + 1]} {$j<$Fragment(nFrag)} {incr j 1} {
	    if {$Fragment($j,clst) == $Fragment($i,clst)} {
		set lastFrag [incr Fragment(nFrag) -1]
		set Fragment($j,clst) $Fragment($lastFrag,clst)
		set Fragment($j,link) $Fragment($lastFrag,link)
		set Fragment($j,seqScores) $Fragment($lastFrag,seqScores)
		unset Fragment($lastFrag,clst)
		unset Fragment($lastFrag,link)
		unset Fragment($lastFrag,seqScores)
		incr j -1
	    }
	}
	lappend Fragment($i,clust) [lindex [lindex $Fragment($i,clst) 0] 0]
	for {set k 0} {$k < [llength $Fragment($i,clst)]} {incr k 1} {
	    lappend Fragment($i,clust) [lindex [lindex $Fragment($i,clst) $k] 1]
	}
    }
}

proc configFragSeq { iFrag } {
    global Fragment Seq
    set Seq(newPlace) "-1"

    destroy .fragmentPlacement
    toplevel .fragmentPlacement -width 150 -height 200
    wm geometry .fragmentPlacement 300x200
    set fr .fragmentPlacement.win

    pack [frame $fr] -side top

    pack [label $fr.topline -text "Fragment: $iFrag - Length: [llength $Fragment($iFrag,clst)]"] -side top

    pack [label $fr.placement -text "Current Placement in Sequence: $Fragment($iFrag,seqPos)"] -side top

    pack [frame $fr.newPlace] -side top

    pack [label $fr.newPlace.lab -text "Change Placement to:"] \
	[entry $fr.newPlace.ent -textvariable Seq(newPlace) -width 4] \
	[button $fr.newPlace.but -text "Change" -command "switchFragPlace $iFrag"] -side left

    for {set i 0} {$i < [llength $Fragment($iFrag,seqScores)]} {incr i 1} {
	lappend suggestions [lindex [lindex $Fragment($iFrag,seqScores) $i] 0]
    }

    pack [label $fr.sugs -text "Other suggestions: $suggestions"] -side top
}

proc switchFragPlace { iFrag } {
    global Seq Fragment Clust

    if {$Seq(newPlace) < 0} { ; # check if the newPlace is less than 0
	set addBack 0         ; # if it is, the Fragment will only be removed from the Sequence
    } else {
	set addBack 1
    }

    set length [llength $Fragment($iFrag,clst)]

    if {$addBack} {  ; # check to see if this section of the sequence has any conflicts
	if {[isAssigned $Seq(newPlace) $length]} {
	    error "There is some conflict with the new sequence placement, it either contains residues that already have clusters assigned to them or a PRO. Please check that this fragment can actually be moved here."
	}
    }
    if { $Fragment($iFrag,A) } { ; # check if this fragment is being re-assigned
	for {set i 0} {$i < $length} {incr i 1} { ; # if it is, remove it from its current place
	    set Fragment($iFrag,A) 0
	    set iRes [expr $Fragment($iFrag,seqPos) + $i]
	    set Seq($iRes) 0
	    catch "unset Seq($iRes,N) Seq($iRes,HN) Seq($iRes,link) Seq($iRes,clst) Seq($iRes,FragElem) Seq($iRes,Frag)"
	    set Seq($iRes,CA) NA
	    set Seq($iRes,CB) NA
	    foreach atom "CA CB HN N" {
		catch "nv_atom elem ppm $iRes.$atom -10000"
	    }
	}
	set Fragment($iFrag,seqPos) "none"
    }

    if {$addBack} {
	for {set iShift 0} {$iShift<$length} {incr iShift} {
            set iRes [expr {$iShift+$Seq(newPlace)}]
            set Seq($iRes) 2
            set bclst  [lindex $Fragment($iFrag,clst) $iShift]
            set blink  [lindex $Fragment($iFrag,link) $iShift]
            set clst  [lindex $bclst 0]
            if {$clst != ""} {
                set Seq($iRes,HN) $Clust($clst,HN)
                set Seq($iRes,N) $Clust($clst,N)
                lappend Clust($clst,Seq) $iRes
            }
            foreach aname $Fragment(AtmTypes) {
                set ppm  [lindex $Fragment($iFrag,$aname) $iShift]
                set Seq($iRes,$aname) $ppm
            }
            
            set Seq($iRes,clst) $bclst
            set Seq($iRes,link) $blink
            set Seq($iRes,Frag) $iFrag
            set Seq($iRes,FragElem) $iShift

	    foreach aname "CB CA HN N" {
		if {[info exists Seq($iRes,$aname)]} {
		    set ppm $Seq($iRes,$aname)
		    catch "eval nv_atom elem ppm $iRes.$aname $ppm"
		}
	    }	    
	  
            #		    puts "$iFrag $iShift $iRes $Seq($iRes,HN) $Seq($iRes,N) $clst"
        }
        set iRes [expr {$iShift+$Seq(newPlace)-1}]
        set Seq($iRes) 3
        set Seq($Seq(newPlace)) 1
	set Fragment($iFrag,seqPos) $Seq(newPlace)
	set Fragment($iFrag,A) 1
    }

    set frame .nvassign.fr1.fraginfo
    for {set i 0} {$i<$Fragment(nFrag)} {incr i 1} {
	destroy $frame.seqinfo.bottom.frag${i}
	pack [label $frame.seqinfo.bottom.frag${i} -text $Fragment($i,seqPos) -bg #ff5555 -padx 15 -pady 5] -side top
    }
}




proc getAllppms {} {
    global Lists

    foreach exp "hncacb cbcaconh hnco noesy" {
	set Lists($exp) "none"
    }

    toplevel .saveClustdata 
    set top .saveClustdata

    pack [frame $top.main] -side left -expand y -fill both
    pack [label $top.main.header -text "Select peak lists to store cluster data for\nLeave blank if not used"] -side top
    pack [frame $top.main.hncacb] -side top
    set fr $top.main.hncacb
    pack [label $fr.title -text "hncacb peaklist:"] -side left
    pack [entry $fr.entry -textvariable Lists(hncacb)] -side left 
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu Lists(hncacb) {}  0"   
    
    pack [frame $top.main.cbcaconh] -side top
    set fr $top.main.cbcaconh
    pack [label $fr.title -text "cbcaconh peaklist:"] -side left
    pack [entry $fr.entry -textvariable Lists(cbcaconh)] -side left 
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu Lists(cbcaconh) {}  0"   
    
    pack [frame $top.main.hnco] -side top
    set fr $top.main.hnco
    pack [label $fr.title -text "hnco peaklist:"] -side left
    pack [entry $fr.entry -textvariable Lists(hnco)] -side left 
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu Lists(hnco) {}  0"
    
    pack [frame $top.main.noesy] -side top
    set fr $top.main.noesy
    pack [label $fr.title -text "noesy peaklist:"] -side left
    pack [entry $fr.entry -textvariable Lists(noesy)] -side left 
    
    menubutton $fr.pksmbut -text Select -underline 0 \
    -menu $fr.pksmbut.menu -width 7 -relief raised
    pack $fr.pksmbut -side left
    
    set menu $fr.pksmbut.menu
    menu $menu -postcommand "NvFillPeakMenu $menu Lists(noesy) {}  0"

    pack [frame $top.main.bottom] -side top
    button $top.main.bottom.button -text "Store Cluster Data" -command "storeData"
    pack $top.main.bottom.button
} 

proc storeData {} {
    global Clust ClusterData Lists

    foreach exp "hncacb cbcaconh hnco noesy" {
	set ${exp} $Lists($exp)
    }

    catch "unset ClusterData"
    if {$noesy != "none" } {set Hlabel [lindex [nv_peak label $noesy] 1]}

    if { $hncacb == "none" || $cbcaconh == "none"} {
	error "Must have hncacb and cbcaconh peak lists selected"
    } else {
	for {set i 0} {$i < $Clust(nClust)} {incr i 1} {
	    GetClustInfo $i
	} 
    }
}

proc GetClustInfo {i} {
    global ClusterData Clust Lists

    foreach exp "hncacb cbcaconh hnco noesy" {
	set ${exp} $Lists($exp)
    }
    set Clabel [lindex [nv_peak label $hncacb] 1]
    set hncacbPeaks $Clust($i,$hncacb)
    set cbcaconhPeaks $Clust($i,$cbcaconh)

    set hncacbLength [llength $hncacbPeaks]
    set cbcaconhLength [llength $cbcaconhPeaks]

    if { $hncacbLength > 4 || $cbcaconhLength > 2 } {
	set ClusterData($i) 0
	puts "Cluster $i skipped, investigate possible artifacts"
	return
    }
    if { $hncacbLength < 1 && $cbcaconhLength < 2 } {
	set ClusterData($i) 0
	puts "Cluster $i skipped, likely not a complete cluster"
	return
    }

    if { $hncacbLength == 4 } {
	set ClusterData($i) 1
	set t 0
	set j 0
	foreach peak $hncacbPeaks {
    	    set ppm [eval nv_peak elem $Clabel.P $peak]
    	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set CAppm($t) $ppm
		set CAint($t) $int
		incr t
    	    } else {
		set CBppm($j) $ppm
		set CBint($j) $int
		incr j
    	    }
	}
	if {![info exists CBint(1)] || ![info exists CAint(1)]} {
	    puts "Cluster $i skipped, incorrect pos/neg number of peaks"
	    set ClusterData($i) 0
	    return
	} 
	if {$CAint(0) > $CAint(1)} {
    	    set ClusterData($i,CAi) $CAppm(0)
    	    set ClusterData($i,CAiminus1) $CAppm(1)
	} else {
    	    set ClusterData($i,CAi) $CAppm(1)
    	    set ClusterData($i,CAiminus1) $CAppm(0)
	}
	if {$CBint(0) > $CBint(1)} {
    	    set ClusterData($i,CBi) $CBppm(1)
    	    set ClusterData($i,CBiminus1) $CBppm(0)
	} else {
    	    set ClusterData($i,CBi) $CBppm(0)
    	    set ClusterData($i,CBiminus1) $CBppm(1)
	}
	if { $cbcaconhLength == 2 } {
	    set j 0
	    foreach peak $cbcaconhPeaks  {
    	    	set ppm${j} [eval nv_peak elem $Clabel.P $peak]
    	    	set int${j} [eval nv_peak elem int $peak]
    	    	incr j 
	    }
    	    set diff1 [expr abs($ppm0 - $ClusterData($i,CAiminus1))]
    	    set diff2 [expr abs($ppm1 - $ClusterData($i,CAiminus1))]

    	    if {$diff1 < $diff2} {
    	    	set ClusterData($i,CAiminus1) $ppm0
    	    	set ClusterData($i,CBiminus1) $ppm1
    	    } else {
    	    	set ClusterData($i,CAiminus1) $ppm1
    	    	set ClusterData($i,CBiminus1) $ppm0
    	    }
	}
    } elseif { $hncacbLength == 3 && $cbcaconhLength == 2 } {
    	set ClusterData($i) 1
	set t 0
	set j 0
	foreach peak $hncacbPeaks {
    	    set ppm [eval nv_peak elem $Clabel.P $peak]
    	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set CAppm($t) $ppm
		set CAint($t) $int
		incr t
    	    } else {
		set CBppm($j) $ppm
		set CBint($j) $int
		incr j
    	    }
	}
	if { [info exists CAppm(1)] && [info exists CBppm(0)] } {
	    if {$CAint(0) > $CAint(1)} {
    	        set ClusterData($i,CAi) $CAppm(0)
    	        set ClusterData($i,CAiminus1) $CAppm(1)
	    } else {
    	        set ClusterData($i,CAi) $CAppm(1)
    	        set ClusterData($i,CAiminus1) $CAppm(0)
	    }
	    set diff [expr abs(46.5 - $ClusterData($i,CAi))] 
	    if { $diff < 5.0 } {
	    	set ClusterData($i,CBiminus1) $CBppm(0) ; # probably a GLY, so no CBi peak
	    	#set ClusterData($i,CBi) "none"
	    } else {
	        set ClusterData($i,CBi) $CBppm(0) ; # assume overlap in CB
	        set ClusterData($i,CBiminus1) $CBppm(0)
	    }
	} else {
	#assume overlap in CA
	    if { [info exists CAppm(0)] } {
		set ClusterData($i,CAi) $CAppm(0)
		set ClusterData($i,CAiminus1) $CAppm(0)
		if {$CBint(0) > $CBint(1)} {
    	    	    set ClusterData($i,CBi) $CBppm(1)
    	    	    set ClusterData($i,CBiminus1) $CBppm(0)
		} else {
    	    	    set ClusterData($i,CBi) $CBppm(0)
    	    	    set ClusterData($i,CBiminus1) $CBppm(1)
		}
	    } else {
		puts "problem with peak intensities (sign) in Cluster $i"
	        set ClusterData($i) 0
	    }
	}
	set j 0
	foreach peak $cbcaconhPeaks {
    	    set ppm${j} [eval nv_peak elem $Clabel.P $peak]
    	    set int${j} [eval nv_peak elem int $peak]
    	    incr j 
	}
    	set diff1 [expr abs($ppm0 - $ClusterData($i,CAiminus1))]
    	set diff2 [expr abs($ppm1 - $ClusterData($i,CAiminus1))]
    	if {$diff1 < $diff2} {
    	    set ClusterData($i,CAiminus1) $ppm0
    	    set ClusterData($i,CBiminus1) $ppm1
    	} else {
    	    set ClusterData($i,CAiminus1) $ppm1
    	    set ClusterData($i,CBiminus1) $ppm0
    	}
    } elseif { $hncacbLength == 3 && $cbcaconhLength < 2 } {
	set ClusterData($i) 1
	set t 0
	set j 0
	foreach peak $hncacbPeaks {
    	    set ppm [eval nv_peak elem $Clabel.P $peak]
    	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set CAppm($t) $ppm
		set CAint($t) $int
		incr t
    	    } else {
		set CBppm($j) $ppm
		set CBint($j) $int
		incr j
    	    }
	}
	if { [info exists CAppm(1)] && [info exists CBppm(0)] } {
	    if {$CAint(0) > $CAint(1)} {
    	        set ClusterData($i,CAi) $CAppm(0)
    	        set ClusterData($i,CAiminus1) $CAppm(1)
	    } else {
    	        set ClusterData($i,CAi) $CAppm(1)
    	        set ClusterData($i,CAiminus1) $CAppm(0)
	    }
	    set ClusterData($i,CBi) $CBppm(0)
	    if { $cbcaconhLength == 1 } {
		set ClusterData($i,CAiminus1) [eval nv_peak elem $Clabel.P $cbcaconhPeaks]
	    }
	} else {
	    if {$CBint(0) > $CBint(1)} {
    	        set ClusterData($i,CBi) $CBppm(0)
    	        set ClusterData($i,CBiminus1) $CBppm(1)
	    } else {
    	        set ClusterData($i,CBi) $CBppm(1)
    	        set ClusterData($i,CBiminus1) $CBppm(0)
	    }
	    set ClusterData($i,CBi) $CAppm(0)
	    if { $cbcaconhLength == 1 } {
		set ppm [eval nv_peak elem $Clabel.P $cbcaconhPeaks]
		set diff [expr $ClusterData($i,CBiminus1) - $ppm]
		if { $diff < 0.1 && $diff > -0.1} {
		    set ClusterData($i,CBiminus1) $ppm
		}
	    }
	}
    } elseif { $hncacbLength == 2 && $cbcaconhLength == 2 } {
	puts "Cluster $i may need to be investigated, assuming information for all peaks is available"
	set ClusterData($i) 1
	#set ClusterData($i,CAi) "none"
	#set ClusterData($i,CBi) "none"
	foreach peak $hncacbPeaks {
    	    set ppm [eval nv_peak elem $Clabel.P $peak]
    	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set ClusterData($i,CAi) $ppm
    	    } else {
		set ClusterData($i,CBi) $ppm
    	    }
	}
	set j 0
	foreach peak $cbcaconhPeaks {
    	    set ppm${j} [eval nv_peak elem $Clabel.P $peak]
    	    set int${j} [eval nv_peak elem int $peak]
    	    incr j 
	}

	if { $ppm0 > 52.0 && $ppm1 > 52.0 } {
	    if {$ppm0 > $ppm1} {
		set ClusterData($i,CAiminus1) $ppm1
		set ClusterData($i,CBiminus1) $ppm0
	    } else {
		set ClusterData($i,CAiminus1) $ppm0
		set ClusterData($i,CBiminus1) $ppm1
	    }
	} else {
	    if {$ppm0 > $ppm1} {
		set ClusterData($i,CAiminus1) $ppm0
		set ClusterData($i,CBiminus1) $ppm1
	    } else {
		set ClusterData($i,CAiminus1) $ppm1
		set ClusterData($i,CBiminus1) $ppm0
	    }
	}
    } elseif { $hncacbLength == 2 } {
	set ClusterData($i) 1

	set t 0
	set j 0
	foreach peak $hncacbPeaks {
    	    set ppm [eval nv_peak elem $Clabel.P $peak]
    	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set CAppm($t) $ppm
		set CAint($t) $int
		incr t
    	    } else {
		set CBppm($j) $ppm
		set CBint($j) $int
		incr j
    	    }
	}
	
	if {$cbcaconhLength == 0} {
	    if {[info exists CAppm(1)]} {
		if { $CAppm(0) > $CAppm(1) } {
		    set ClusterData($i,CAiminus1) $CAppm(1)
		    set ClusterData($i,CAi) $CAppm(0)
		} else {
		    set ClusterData($i,CAiminus1) $CAppm(0)
		    set ClusterData($i,CAi) $CAppm(1)
		}
	    } elseif {[info exists CBppm(1)]} {
		if { $CBppm(0) > $CBppm(1) } {
		    set ClusterData($i,CBiminus1) $CBppm(1)
		    set ClusterData($i,CBi) $CBppm(0)
		} else {
		    set ClusterData($i,CBiminus1) $CBppm(0)
		    set ClusterData($i,CBi) $CBppm(1)
		}
	    } else {
		set ClusterData($i,CAi) $CAppm(0)
		set ClusterData($i,CBi) $CBppm(0)
	    }
	} else {
	    if {[info exists CBppm(1)] || [info exists CAppm(1)] } {
		set ClusterData($i) 0
		puts "Cluster $i skipped, incorrect pos-neg int matching"
	    } else {
		set ClusterData($i,CAiminus1) [eval nv_peak elem $Clabel.P $cbcaconhPeaks]
	    	set diff [expr abs(46.5 - $ClusterData($i,CAiminus1))] 
		if { !($diff < 5.0) } {
		    set ClusterData($i) 0
		    puts "Cluster $i skipped, i-1 not Gly"
		}
	    }
	}
    } elseif {$hncacbLength == 1} {
	set ClusterData($i) 1

	foreach peak $hncacbPeaks {
	    set ppm [eval nv_peak elem $Clabel.P $peak]
	    set int [eval nv_peak elem int $peak]
	    if {$int > 0} {
		set ClusterData($i,CAi) $ppm
	    } else {
		set ClusterData($i,CBi) $ppm
	    }
	}
	if {$cbcaconhLength == 1} {
	    if {![info exists ClusterData($i,CAi)]} {
		puts "Cluster $i skipped, likely not a complete cluster"
		set ClusterData($i) 0
		return
	    }
	    set diff [expr abs(46.5 - $ClusterData($i,CAi))] 
	    set ClusterData($i,CAiminus1) [eval nv_peak elem $Clabel.P $cbcaconhPeaks]
	    set diff2 [expr abs(46.5 - $ClusterData($i,CAiminus1))] 
	    if { $diff > 5.0 || $diff2 > 5.0 } {
		set ClusterData($i) 0
		puts "Cluster $i skipped, likely not a complete cluster"
	    }
	} elseif {$cbcaconhLength == 2} {
	    if {![info exists ClusterData($i,CAi)]} {
		puts "Cluster $i skipped, likely not a complete cluster"
		set ClusterData($i) 0
		return
	    }
	    foreach peak $cbcaconhPeaks  {
    	    	set ppm${j} [eval nv_peak elem $Clabel.P $peak]
    	    	set int${j} [eval nv_peak elem int $peak]
    	    	incr j 
	    }
	    if { $ppm0 > 52.0 && $ppm1 > 52.0 } {
	    	if {$ppm0 > $ppm1} {
		    set ClusterData($i,CAiminus1) $ppm1
		    set ClusterData($i,CBiminus1) $ppm0
	    	} else {
		    set ClusterData($i,CAiminus1) $ppm0
	  	    set ClusterData($i,CBiminus1) $ppm1
	        } 
	    } else {
	    	if {$ppm0 > $ppm1} {
		    set ClusterData($i,CAiminus1) $ppm0
		    set ClusterData($i,CBiminus1) $ppm1
	    	} else {
		    set ClusterData($i,CAiminus1) $ppm1
		    set ClusterData($i,CBiminus1) $ppm0
	    	}
	    }
	}
    } elseif {$hncacbLength == 0 && $cbcaconhLength == 2} {
	set ClusterData($i) 1
	set j 0
	foreach peak $cbcaconhPeaks {
    	    set ppm${j} [eval nv_peak elem $Clabel.P $peak]
    	    set int${j} [eval nv_peak elem int $peak]
    	    incr j 
	}

	if { $ppm0 > 52.0 && $ppm1 > 52.0 } {
	    if {$ppm0 > $ppm1} {
		set ClusterData($i,CAiminus1) $ppm1
		set ClusterData($i,CBiminus1) $ppm0
	    } else {
		set ClusterData($i,CAiminus1) $ppm0
		set ClusterData($i,CBiminus1) $ppm1
	    }
	} else {
	    if {$ppm0 > $ppm1} {
		set ClusterData($i,CAiminus1) $ppm0
		set ClusterData($i,CBiminus1) $ppm1
	    } else {
		set ClusterData($i,CAiminus1) $ppm1
		set ClusterData($i,CBiminus1) $ppm0
	    }
	}
    } else {
	puts "Cluster $i skipped, likely not a complete cluster"
	set ClusterData($i) 0
    }
    if { $hnco != "none" } {
	set hncoPeak $Clust($i,$hnco)
    	set hncolength [llength $hncoPeak]
    	if { $hncolength != 1 } {
 	    puts "no distinct hnco peak found for $i"
	    return
    	}
    	set ClusterData($i,COiminus1) [eval nv_peak elem $Clabel.P $hncoPeak]
    }
    foreach type "CAppm CBppm CAint CBint" {
    	if { [info exists ${type}] } {
	    unset ${type}
    	}
    }
    if { $noesy != "none" } {
	set j 1
	foreach peak $Clust($i,$noesy) {
    	    set ClusterData($i,noesy,$j) [eval nv_peak elem $Hlabel.P $peak]
	    incr j
	}
	set ClusterData($i,Nnoesy) $j
    }
}

proc getFilename {name} {
    if { $name == "montefile" } {set types {{{MONTE files} {.cs}}}} else { set types ""}
    global Clust
    set Clust($name) [tk_getSaveFile -title "Choose a Filename or Existing File" -initialdir [pwd] -filetypes $types]  
}

proc DumpClust {} {
    global Clust 

    #set Lists(hncacb) none
    #set Lists(cbcaconh) none
    #set Lists(hnco) none

    toplevel .saveForPACES
    set top .saveForPACES

    pack [frame $top.main] -side left -expand y -fill both

    if {![info exists Clust(pacesfile)]} { set Clust(pacesfile) "" }
    pack [frame $top.main.filechooser] -side top
    entry $top.main.filechooser.entry -textvariable Clust(pacesfile)
    button $top.main.filechooser.butt -text "Choose Filename"  -command "getFilename pacesfile"
    button $top.main.filechooser.butt2 -text "Save Data" -command "startPACESsave; destroy .saveForPACES"
    pack $top.main.filechooser.entry $top.main.filechooser.butt $top.main.filechooser.butt2 -side left
}

proc DumpClustMONTE {} {
    global Clust 

    #set Lists(hncacb) none
    #set Lists(cbcaconh) none
    #set Lists(hnco) none

    toplevel .saveForMONTE
    set top .saveForMONTE

    pack [frame $top.main] -side left -expand y -fill both

    if {![info exists Clust(montefile)]} { set Clust(montefile) "" }
    pack [frame $top.main.filechooser] -side top
    entry $top.main.filechooser.entry -textvariable Clust(montefile)
    button $top.main.filechooser.butt -text "Choose Filename"  -command "getFilename montefile"
    button $top.main.filechooser.butt2 -text "Save Data" -command "startMONTEsave; destroy .saveForMONTE"
    pack $top.main.filechooser.entry $top.main.filechooser.butt $top.main.filechooser.butt2 -side left
}

proc startPACESsave {} {
    global ClusterData Clust
    set filename $Clust(pacesfile)

    if { $filename == "" } {
	return
    }    

    set fileid [open $filename w+]  
    
    puts $fileid "PACES Input Data File / 1.0 / 27\n\nProtein:  ubiquitin (with CB)\nUse CA/CB/CO/HA:  yynn\nCATolerance:  0.2\nCBTolerance:  0.4\nCOTolerance:  0.15\nHATolerance:  0\nAASeqStartingNumber:  1\nAASeq:\n{"

    set seqList [PACESseq]

    puts $fileid "$seqList\n}\nInputData:\n{"
    for {set i 0} {$i < $Clust(nClust)} {incr i} {
	if {!$ClusterData($i)} {
	    continue
	}

	foreach type "CAi CBi CAiminus1 CBiminus1 COiminus1" {
	    if { [info exists ClusterData($i,$type)] } {
	    	set ${type} $ClusterData($i,$type)
	    } else {
		set ${type} 0.0
	    }
	}

	set output [format "%4d  %5.2f  %6.2f  %6.2f  %6.2f  %6.2f  %6.2f  000.00  %6.2f  000.00  000.00  ----  n  n  ----" \
	    $i $Clust($i,HN) $Clust($i,N) $CAi $CAiminus1 $CBi $CBiminus1 $COiminus1]
	puts $fileid $output
	
	unset CAi CAiminus1 CBi CBiminus1 COiminus1
    }
    puts $fileid "}"
    close $fileid
}

proc startMONTEsave {} {
    global ClusterData Clust tablerows cs
    set filename $Clust(montefile) 

    if { $filename == "" } {
	return
    }    

    set fileid [open $filename w+]  

    set orders ""

    set CAindex [lsearch $tablerows CA]
    set CBindex [lsearch $tablerows CB]
    set COindex [lsearch $tablerows CO]
    set CAminusindex [lsearch $tablerows CA]
    set CBminusindex [lsearch $tablerows CB]

    set CArow [expr 20 * $CAindex]
    set CBrow [expr 20 * $CBindex]
    set COrow [expr 20 * $COindex]
    set CAminusrow [expr 20 * $CAminusindex]
    set CBminusrow [expr 20 * $CBminusindex]
    for {set i 2} {$i<20} {incr i} {
	set currCA [expr $CArow + $i]
	set currCB [expr $CBrow + $i]
	set currCO [expr $COrow + $i]
	set currCAminus [expr $CAminusrow + $i]
	set currCBminus [expr $CBminusrow + $i]
	if {$cs($currCA)} {
	    set CApos $i
	} elseif {$cs($currCB)} {
	    set CBpos $i
	} elseif {$cs($currCO)} {
	    set COpos $i
	} elseif {$cs($currCAminus)} {
	    set CAminuspos $i
	} elseif {$cs($currCBminus)} {
	    set CBminuspos $i
	}
    }
    if {$cs(0)} {                
	puts -nonewline $fileid "##            N       HN   "
	for {set j 2} {$j < 7} {incr j} {
	    if {$CApos == $j} {
		puts -nonewline $fileid "CA     "
	    } elseif {$CBpos == $j} {
		puts -nonewline $fileid "CB     "
	    } elseif {$COpos == $j} {
		puts -nonewline $fileid "CO     "
	    } elseif {$CAminuspos == $j} {
		puts -nonewline $fileid "CA   "
	    } elseif {$CBminuspos == $j} {
		puts -nonewline $fileid "CB   "
	    } 
	}
    } else {
	puts -nonewline $fileid "##            HN   N      "
	for {set j 2} {$j < 7} {incr j} {
	    if {$CApos == $j} {
		puts -nonewline $fileid "CA     "
	    } elseif {$CBpos == $j} {
		puts -nonewline $fileid "CB     "
	    } elseif {$COpos == $j} {
		puts -nonewline $fileid "CO     "
	    } elseif {$CAminuspos == $j} {
		puts -nonewline $fileid "CA   "
	    } elseif {$CBminuspos == $j} {
		puts -nonewline $fileid "CB   "
	    }
	}
    }
    puts $fileid ""
    for {set i 0} {$i < $Clust(nClust)} {incr i} {
	if {!$ClusterData($i)} {
	    continue
	}

	foreach type "CAi CBi CAiminus1 CBiminus1 COiminus1" order "res${CApos} res${CBpos} res${CAminuspos} res${CBminuspos} res${COpos}" {
	    if { [info exists ClusterData($i,$type)] } {
		if { ${type} == "none" } {
		    set ${order} 0.0
		} else {
	    	    set ${order} $ClusterData($i,$type)
		}
	    } else {
		set ${order} 0.0
	    }
	}
	foreach order "res${CApos} res${CBpos} res${CAminuspos} res${CBminuspos} res${CBminuspos}" {
	    if {![info exists $order]} {
		error "chemical shift index table not set properly"
		return
	    }
	}
	if {$cs(0)} {
	    set output [format "%5.1f        %5.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f" \
	    	$i $Clust($i,HN) $Clust($i,N) $res2 $res3 $res4 $res5 $res6]
	    puts $fileid $output
	} else {	
	    set output [format "%5.1f        %5.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f" \
	    	$i $Clust($i,N) $Clust($i,HN) $res2 $res3 $res4 $res5 $res6]
	    puts $fileid $output
	}


	unset res2 res3 res4 res5 res6
    }
    close $fileid
    MONTEnoesy
    MONTEseq
}
 
proc MONTEseq {} {
    global Seq Nv_Nresidues Clust

    set filename [string trimright $Clust(montefile) .cs]
    set filename "${filename}.seq" 

    if { $filename == "" } {
	return
    }    

    set fileid [open $filename w+]  

    for { set i 1 } { $i < $Nv_Nresidues } {incr i} {
	puts -nonewline $fileid "$Seq($i,rname) "
	if { [expr $i % 25] == 0 } {
	    puts -nonewline $fileid "\n"
	}
    }
    puts $fileid " "
    close $fileid
}

proc PACESseq {} {
    global Seq Nv_Nresidues Clust SGL

    set output ""
    for { set i 1 } { $i < $Nv_Nresidues } {incr i} {
	lappend output $SGL($Seq($i,rname))
    }
    set output [join $output ""]
    return $output
}

proc MONTEnoesy {} {
    global Lists Clust ClusterData
    if { $Lists(noesy) == "none" } {
	return
    }
    set filename [string trimright $Clust(montefile) .cs]
    set filename "${filename}.3dh_noe"

    set fileid [open $filename w+]

    for {set i 0} {$i < $Clust(nClust)} {incr i} {
	if { !$ClusterData($i) } {
	    continue
	}
	set HN $Clust($i,HN)
	set N $Clust($i,N)
	set out [format "%6.2f %6.2f %4.2f " $i $HN $N]
	puts -nonewline $fileid $out
	for {set j 1} {$j < $ClusterData($i,Nnoesy)} {incr j} {
	    puts -nonewline $fileid [format "%4.2f " $ClusterData($i,noesy,$j)]
	}
	puts $fileid ""
    }
    close $fileid
}

proc NvCBCAreadPACES { } {
    set filename [tk_getOpenFile -title "Select resulatant text file from PACES export" -initialdir [pwd]]
    if {$filename != ""} {
    	readPACESfile $filename
    }
}

proc readPACESfile { filename } {
    global Seq Nv_Nresidues
    set input [open $filename]
    
    gets $input readLine
    while { $readLine != "InputData:" } {
	gets $input readLine
    }

    gets $input readLine
    gets $input readLine
    while { $readLine != "\}" } {
	set seqNum [lindex $readLine 11]
	if { $seqNum == "----" } {
    	    gets $input readLine
	    continue
	}
	set seqNum [string trimleft $seqNum 0]
	set Seq($seqNum) 2
	set Seq($seqNum,CA) [lindex $readLine 3] 
	set Seq($seqNum,CB) [lindex $readLine 5] 
	set Seq($seqNum,HN) [lindex $readLine 1] 
	set Seq($seqNum,N) [lindex $readLine 2] 

	set Seq($seqNum,Frag) 0
	set Seq($seqNum,FragElem) 0
	set Seq($seqNum,clst) [string trimleft [lindex $readLine 0] 0]
	foreach atom "HN N CA CB" lab "HN N CA CB" {
	    if {$Seq($seqNum,$atom) == 0} {continue}
	    eval "nv_atom elem ppm $seqNum.$lab $Seq($seqNum,$atom)"
	}
	gets $input readLine
    }

    for {set i 1} {$i <= $Nv_Nresidues} {incr i} {
	if { $Seq($i) == 0 || $Seq([expr $i + 1]) == 0 } {
	    continue
	}
	set firstClust $Seq($i,clst)
	set secondClust $Seq([expr $i + 1],clst)

	set Seq($i,clst) "$firstClust $secondClust"
    }	 
    close $input
}

proc readMONTEfile { filename } {
    global Seq Nv_Nresidues cs tablerows
    set input [open $filename]
    
    set CAindex [lsearch $tablerows CA]
    set CBindex [lsearch $tablerows CB]

    set CArow [expr 20 * $CAindex]
    set CBrow [expr 20 * $CBindex]
    for {set i 2} {$i<20} {incr i} {
	set currCA [expr $CArow + $i]
	set currCB [expr $CBrow + $i]
	if {$cs($currCA)} {
	    set CApos [expr 4 + $i]
	}
	if {$cs($currCB)} {
	    set CBpos [expr 4 + $i]
	} 
    }
    while { [gets $input readLine] != "-1" } {
	set first [lindex $readLine 0]

	if { $first == "%%" || $first == "##"} {
	    continue
	}
	set seqNum [string trimright $first >]
	set seqNum [string trimright $seqNum +]
	set Seq($seqNum) 2
	set Seq($seqNum,CA) [lindex $readLine $CApos] 
	set Seq($seqNum,CB) [lindex $readLine $CBpos] 
	if {$cs(0)} {
	    set Seq($seqNum,HN) [lindex $readLine 5] 
	    set Seq($seqNum,N) [lindex $readLine 4] 
	} else {
	    set Seq($seqNum,HN) [lindex $readLine 4] 
	    set Seq($seqNum,N) [lindex $readLine 5] 
	}

	set Seq($seqNum,Frag) 0
	set Seq($seqNum,FragElem) 0
	set Seq($seqNum,clst) [string trimright [lindex $readLine 2] .0]
	foreach atom "HN N CA CB" lab "HN N CA CB" {
	    if {$Seq($seqNum,$atom) == 0.0} {continue}
	    catch "eval {nv_atom elem ppm $seqNum.$lab $Seq($seqNum,$atom)}"
	}
    }

    for {set i 1} {$i <= $Nv_Nresidues} {incr i} {
	if { $Seq($i) == 0 || $Seq([expr $i + 1]) == 0 } {
	    continue
	}
	set firstClust $Seq($i,clst)
	set secondClust $Seq([expr $i + 1],clst)

	set Seq($i,clst) "$firstClust $secondClust"
    }	 
    close $input
}	
	
proc import {type} {
    set filename [tk_getOpenFile -title "Choose a $type text file to import" -initialdir [pwd]]
    if {$filename != ""} {
	read${type}file $filename
    }
}
