proc CheckLink {clust dir link path} {
    global Clust
    set link1 [lindex $Clust($clust,$dir) $link]
    if {[lindex $link1 2] != $path} { return -1 }
    set newclust [lindex $link1 0]
    
    if {$dir=="suc"} {set newdir pre} else {set newdir suc}
    
    set links $Clust($newclust,$newdir)
    set backclust -1
    
    set j 0
    foreach link2 $links {
        set backclust [lindex $link2 0]
        if {$backclust == $clust} {
            break
        }
        incr j
    }
    if {($backclust == $clust)} {
        set backpath [lindex $link2 2]
        if {$backpath > 0} {
            if {$dir=="suc"} {
                return "$j $backpath"
            } else {
                return "$j $backpath"
            }
        }
    }
    return -1
}

proc CheckStrong {clust dir path} {
    global Clust
    upvar newLnk newLnk
    #Fragment(AtmTypes) AtmTypes
    set backclust b
    set nStrong(0) 0
    set nStrong(1) 0
    #    set nTypes [llength $AtmTypes]
    set foundlink 0
    if {[info exists Clust($clust,$dir) ]} {
        set links $Clust($clust,$dir)
        set j 0
        foreach link $links {
            set result [CheckLink $clust $dir $j $path]
            set newlink [lindex $result 0]
            if {$newlink >= 0} {
                set foundlink 1
                if {$dir=="suc"} {
                    set newLnk(clst) "$clust [lindex $link 0]"
                    set newLnk(link) "$j $newlink"
                    set newLnk(path) "$path [lindex $result 1]"
                } else {
                    set newLnk(clst) "[lindex $link 0] $clust"
                    set newLnk(link) "$newlink $j"
                    set newLnk(path) "[lindex $result 1] $path"
                }
            }
            incr j
        }
    } else {
        return 0
    }
    if {$foundlink} { return 1 } else { return 0}
}

proc flwlinks {{firstClust 0} {lastClust 10000}} {
    global Clust Fragment int_flag
    set nClust $Clust(nClust)
    if {$lastClust >= $nClust} {set lastClust [expr $nClust-1]}
    set nFrag 0
    if {[info exists Fragment]} {unset Fragment}
    for {set i 0} {$i<$nClust} {incr i} {
        set Clust($i,V) 0
    }
    for {set i $firstClust} {$i<=$lastClust} {incr i} {
        if {$int_flag} {
            set int_flag 0
            return
        }
        if {$Clust($i,V)} {continue}
        set Clust($i,V) 1
        
        set preLnk ""
        set sucLnk ""
        set Lnk(suc) ""
        set Lnk(pre) ""
        set Lnk(clst) ""
        set Lnk(link) ""
        set Lnk(path) ""
        set foundlink 0
        
        foreach dir "pre suc" {
            puts "$i $dir"
            #	    puts -nonewline "$i $dir"
            set clust $i
            set ok 1
            set path 1
            while {$ok} {
                if [CheckStrong $clust $dir $path] {
                    set foundlink 1
                    set cluster $newLnk(clst)
                    set ilink $newLnk(link)
                    set path $newLnk(path)
                    if {$dir=="suc"} {
                        lappend Lnk(clst) $cluster
                        lappend Lnk(link) $ilink
                        lappend Lnk(path) $path
                        set path [lindex $path 1]
                        set clust [lindex $newLnk(clst) 1]
                    } else {
                        set Lnk(clst) [linsert $Lnk(clst) 0 $cluster]
                        set Lnk(link) [linsert $Lnk(link) 0 $ilink]
                        set Lnk(path) [linsert $Lnk(path) 0 $path]
                        set path [lindex $path 0]
                        set clust [lindex $newLnk(clst) 0]
                    }
                    #		    puts -nonewline " $path $clust"
                    set Clust($clust,V) 1
                } else {
                    if {$dir=="suc"} {
                        lappend Lnk(clst) "$clust {}"
                        lappend Lnk(link) {"" ""}
                        lappend Lnk(path) {"" ""}
                    } else {
                        set Lnk(clst) [linsert $Lnk(clst) 0 "{} $clust"]
                        set Lnk(link) [linsert $Lnk(link) 0 {"" ""}]
                        set Lnk(path) [linsert $Lnk(path) 0 {"" ""}]
                    }
                    set ok 0
                }
            }
            #puts ""
        }
        if {[llength $Lnk(clst)] > 1} {
            set Fragment($nFrag,clst) $Lnk(clst)
            set Fragment($nFrag,link) $Lnk(link)
            set Fragment($nFrag,path) $Lnk(path)
            GetShifts $nFrag
            incr nFrag
        }
        if {!$foundlink} {continue}
    }
    set Fragment(nFrag) $nFrag
}



proc NvFragGetPeaks {iFrag atype} {
    global Fragment
    foreach peakpair $Fragment($iFrag,$atype,peaks) {
        set pk2 [lindex $peakpair 0]
        set pk1 [lindex $peakpair 1]
        if {$pk2!=""} {
            lappend pks $pk2
        }
        if {$pk1!=""} {
            lappend pks $pk1
        }
    }
    #   puts $pks
    return $pks
}





proc GetCapPeaks {iClust atype type} {
    global NvCBCA Clust
    set peaks $Clust($iClust,$NvCBCA(list,$atype,$type))
    #    puts "$iClust $atype $type $peaks"
    if {[llength $peaks]==1} {
        return $peaks
    }
    
    foreach peak $peaks {
        set intra [NvCBCA::CheckIntra $iClust $peak $NvCBCA(list,$atype,intra) $NvCBCA(list,$atype,inter) 0.6]
        if {$intra == -1} {
            return $peak
        }
    }
    
    return {}
}

proc GetShifts {iFrag} {
    global Clust Fragment NvCBCA
    set fragSize [llength $Fragment($iFrag,clst)]
    set j 4
    set Fragment($iFrag,resType) ""
    set firstTime 1
    foreach atype "CA CB" {
        set Fragment($iFrag,$atype) ""
        set Fragment($iFrag,$atype,peaks) ""
        set Fragment($iFrag,$atype,int) ""
        for {set i 0} {$i<$fragSize} {incr i} {
            set clusterPair [lindex $Fragment($iFrag,clst) $i]
            set linkPair [lindex $Fragment($iFrag,link) $i]
            set cluster ""
            foreach iClust $clusterPair iLink $linkPair ptype "intra inter" {
                if {($iClust != "") && ($iLink != "") } {
                    set  cluster [lindex $Clust($iClust,suc) $iLink]
                    set peaks [lindex $cluster $j]
                    set resType [string toupper [lindex $cluster end]]
                    break
                }  elseif {($iClust != "")} {
                    if {$ptype == "intra"} {
                        set peaks "{} [GetCapPeaks $iClust $atype $ptype]"
                    } else {
                        set peaks "[GetCapPeaks $iClust $atype $ptype] {}"
                    }
                    set resType *
                    set cluster "ok"
                }
            }
            if {$cluster==""} {
                set peaks {"" ""}
                set resType *
            }
            set nPeak 0
            set ppm ""
            set int ""
            foreach peak $peaks {
                if {$peak != ""} {
                    set ppm [expr $ppm+[eval nv_peak elem $NvCBCA(Cdim).P $peak]]
                    set int [eval nv_peak elem int $peak]
                    incr nPeak
                }
            }
            if {$nPeak > 0} {
                set ppm [expr {$ppm/$nPeak}]
            }
            if {$atype=="CA"} {
                if {$resType=="*"} {
                    if {[NvCBCA::GlyPPM $ppm]} {
                        set resType GLY
                    }
                }
                lappend Fragment($iFrag,resType) $resType
            }
	    if {$atype=="CB"} {
		if {$resType=="*"} {
		#    if {[NvCBCA::AlaPPM $ppm]} {
		#	set resType ALA
		#    }
		}
	    }
            
            #BUG following is a kluge because my hncoca experiment has positive gly
            
            if {($resType=="GLY")} {
                if {$int>0.0} {
                    set int [expr -$int]
                }
            }
            
            lappend Fragment($iFrag,$atype) $ppm
            lappend Fragment($iFrag,$atype,peaks) $peaks
            lappend Fragment($iFrag,$atype,int) $int
        }
        set firstTime 0
        incr j
    }
    return
    
}
proc FindFragment {iRes} {
    global Fragment
    for {set i 0} {$i<$Fragment(nFrag)} {incr i} {
        foreach seqScore $Fragment($i,seqScores) {
            if {[lindex $seqScore 0] == $iRes} {
                puts $i
            }
        }
    }
}

proc ScoreConfirmedClusts {} {
    global Clust ResTypes
    catch "unset ResTypes" ; # reset ResTypes var, do nothing if it doesn't exist
    for {set iClust 0} {$iClust<$Clust(nClust)} {incr iClust} {
       # puts "$iClust ***************"
        foreach dir "suc pre" {
            set iLink 0
            foreach clust $Clust($iClust,$dir) {
                set conf [lindex $clust 2] ; # if this clust is confirmed to be linked to another score it
                if {$conf > 0} {
                    ScoreClust $iClust $iLink $dir ; # score iClust, iLink is the number of clusters scoring better
                } ;# dir is the direction the link is
                
                incr iLink
            }
            ScoreClust $iClust -1 $dir
        }
    }
}

proc getFragments {} { ; #create a list of the fragments that were created by confirming matches
    global Clust NvCBCA Frags
    if {[info exists Frags]} {unset Frags}
    set Frags(nFrags) 0
    for {set i 0} {$i<=$Clust(nClust)} {incr i 1} {
	set Clust($i,visited) 0
    }
    for {set i 0} {$i<$Clust(nClust)} {incr i 1} {
	getFrags $i "regMode"
    }
}

proc getFrags {iClust mode} {
    global Clust NvCBCA Frags
    if {$mode != "forward"} {
	if { $Clust($iClust,visited) } { ; #don't investigate further if its already in a Fragment
	    return
	}
	set preClust [getClust $iClust pre] ; # set preClust to the cluster confirmed to be preceeding the current one
	if {$preClust > -1} {
	    getFrags $preClust "recur" ; # recursively get the preceeding clusters
	} else {
	    incr Frags(nFrags) 1
	    set Frags(current) $Frags(nFrags)
	}
	lappend Frags($Frags(current)) $iClust
	if { $mode == "recur" } {
	    set Clust($iClust,visited) 1
	    return
	}
    }
    set sucClust [getClust $iClust suc] ; # set sucClust to the cluster confirmed to be suceeding iClust
    set Clust($iClust,visited) 1 
    if {$sucClust > -1} {
	lappend Frags($Frags(current)) $sucClust
	getFrags $sucClust "forward"
    }
}

proc getClust {iClust dir} {
    global Clust Frags
    if {[info exists Clust($iClust,$dir)]} {
	foreach clust $Clust($iClust,$dir) {
	    set conf [lindex $clust 2]
	    if {$conf > 0} {
		return [lindex $clust 0]
	    }
	}
    }
} 
 
proc ScoreClust {iClust iLink dir {report 0}} {
    global ClustData Nv_Nresidues Seq Clust ResTypes
    if {$iLink >= [llength $Clust($iClust,$dir)]} {return} ; #a trap to make sure iLink is not larger than the number of elements
    set Clust($iClust,$iLink,$dir,scores) ""
    set Clust($iClust,$iLink,$dir,seqs) ""
    GetClustPeaks $iClust $iLink $dir
    if {![info exists ResTypes]} {
	#puts "NvNres: $Nv_Nresidues"
        for {set iRes 2} {$iRes<$Nv_Nresidues} {incr iRes} {
            set totalScore 0.0
            if {$dir == "pre"} {
                set delRes -1
            } else {
                if {$Seq($iRes,rname) == "PRO"} {
                    continue
                }
                set delRes 0
            }
            set res1 [expr {$iRes+$delRes}]
            set res2 [expr {$iRes+$delRes+1}]
            set rname1 $Seq($res1,rname)
            set rname2 $Seq($res2,rname)
            if {$rname2 != "PRO"} {
                set rname2 ALA
            }
            lappend ResTypes($rname1,$rname2) $res1
        }
    }
    
    foreach resType [array names ResTypes] {
        set totalScore 0.0
        regexp {([A-Z]*)(,)([A-Z]*)} $resType all rname1 comma rname2
        if {$ClustData($dir,resType) != "*"} {
            if {![regexp -nocase $ClustData($dir,resType) $rname1]} {
                if {$report} {
                    puts "Res ($rname1) not $ClustData($dir,resType)"
                }
                continue
            }
        }
        foreach atype "CA CB" {
            if {($atype=="CB") && ($rname1 == "GLY")} {continue}
            if {$ClustData($dir,$atype,ppm) == {}} {
                set score 0.5
            } else {
                
                if {$ClustData($dir,$atype,int) != ""} {
                    if {![CheckIntensity $rname1 $atype $ClustData($dir,$atype,int)]} {
                        if {$report} {
                            puts "failedcheckI $rname1 $atype $ClustData($dir,$atype,int)"
                        }
                        set totalScore 1000.0
                        break
                    }
                }
                set score [ScoreShift $rname1  $rname2 $atype $ClustData($dir,$atype,ppm)]
            #    puts $score
            }
            
            set totalScore [expr {$score+$totalScore}]
        }
        if {$totalScore < 0.8} {
            foreach res1 $ResTypes($resType) {
                lappend Clust($iClust,$iLink,$dir,scores) $totalScore
                lappend Clust($iClust,$iLink,$dir,seqs) $res1
            }
        }
    }
    
}

proc GetClustPeaks {iClust iLink dir} {
    global Clust NvCBCA ClustData
    set j 4
    foreach atype "CA CB" {
        if {$iLink >= 0} {
            set cluster [lindex $Clust($iClust,$dir) $iLink] ; # set cluster to the current cluster being scored with respect to iClust
            set peaks [lindex $cluster $j] ; # set peaks to a list of peaks that match best between the two clusters
#	    puts $peaks
            set resType [string toupper [lindex $cluster end]] ; # set resType to the current res assoc with this cluster
        } else {
            if {$dir=="suc"} {
                set dirType intra
            } else {
                set dirType inter
            }
            
            set peaks [GetCapPeaks $iClust $atype $dirType]
            set resType *
        }
        
        set ppm 0.0
        set int 0.0
        set nPeak 0
        foreach peak $peaks {
            if {$peak != ""} {
                set ppm [expr $ppm+[eval nv_peak elem $NvCBCA(Cdim).P $peak]] ; # incr ppm by the C-shift
                set int [eval nv_peak elem int $peak] ; # incr the intensity by the peak's intensity
                incr nPeak
            }
        }
        if {$nPeak > 0} {
            set ppm [expr {$ppm/$nPeak}] ; # get the average ppm
            if {$atype=="CA"} {
                if {$resType=="*"} {
                    if {[NvCBCA::GlyPPM $ppm]} { ;# if the resType is not yet set, check to see if it falls within the bounds of a GLY
                        set resType GLY
                    }
                }
            }
        } else {
            set ppm ""
        }
        
        #BUG following is a kluge because my hncoca experiment has positive gly
        
        if {($resType=="GLY")} {
            if {$int>0.0} {
                set int [expr -$int]
            }
        }
        set ClustData($dir,$atype,ppm) $ppm
        set ClustData($dir,$atype,int) $int
        set ClustData($dir,resType) $resType
        incr j 
    }
    
}

proc SetupSequence {} {
    global Seq Nv_Nresidues Nv_Priv
    if {$Nv_Priv(javaMode)} {
        set atoms ""
        foreach entity [mol entities [mol molnam]] {
            mol select atoms $entity:*.CA
            set atoms [concat $atoms [mol listatoms]]
        }
        
        foreach atom $atoms {
            set iRes [nv_atom elem seq $atom]
            set Seq($iRes) 0
            set Seq($iRes,rname) [nv_atom elem rname $atom]
            set Seq($iRes,CA) "NA"
            set Seq($iRes,CB) "NA"
            foreach aname "CA CB" {
                catch "eval nv_atom elem ppm $iRes.$aname -10000.0"
            }
        }
    } else {
        for {set iRes 1} {$iRes<=$Nv_Nresidues} {incr iRes} {
            set Seq($iRes) 0
            nv_residue $iRes res
            set Seq($iRes,rname) $res(name)
            set Seq($iRes,CA) "NA"
            set Seq($iRes,CB) "NA"
            foreach aname "CA CB" {
                catch "eval nv_atom elem ppm $iRes.$aname -10000.0"
            }
        }
    }
}


proc AssignFragOld {filename } {
    global Nv_FragDisp ClustUsed
    set fileid [open $filename w]
    global Nv_Nresidues Fragment Seq Clust int_flag NvCBCA
    ZeroPeakLab $NvCBCA(0,intraResidue,peaks)
    ZeroPeakLab $NvCBCA(0,interResidue,peaks)
    ZeroPeakLab $NvCBCA(1,intraResidue,peaks)
    ZeroPeakLab $NvCBCA(1,interResidue,peaks)
    catch "unset ClustUsed"
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        set Clust($i,Seq) ""
    }
    if {[info exists Seq]} {unset Seq}
    set nFrag $Fragment(nFrag)
    set minRatio 0.095
    set iPass 1
    set ok 1
    SetupSequence
    set SortFrags ""
    for {set iFrag 0} {$iFrag<$nFrag} {incr iFrag} {
        set Fragment($iFrag,A) 0
        set fragLength  [llength $Fragment($iFrag,clst)]
        if {$fragLength > 1} {
            lappend SortFrags "$iFrag $fragLength"
        }
    }
    set SortFrags [lsort -index 1 -integer -decreasing $SortFrags]
    while {$ok} {
        set ok 0
        for {set iSFrag 0} {$iSFrag<[llength $SortFrags]} {incr iSFrag} {
            if {$int_flag} {
                set int_flag 0
                close $fileid
                return
            }
            set iFrag [lindex [lindex $SortFrags $iSFrag] 0]
            if {[info exists Fragment($iFrag,use)] && !$Fragment($iFrag,use)} {continue}
            if {$Fragment($iFrag,A)} {continue}
            set used 0
            puts $iFrag
            foreach clst $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
                if {[info exists ClustUsed(${clst}_${link})] && $ClustUsed(${clst}_${link})} {
                    set used 1
                    break
                }
            }
            if {$used} {continue}
            set FragSize [llength $Fragment($iFrag,clst)]
            set result [ScoreFrag $iFrag]
            #	    puts "$iFrag $FragSize $result"
            
            set gWorst [lindex $result 6]
            set Ratio [lindex $result 5]
            set firstRes [lindex $result 1]
            set TScore [lindex $result 2]
            set MinScore [expr {$TScore/$FragSize}]
            set first2Res [lindex $result 3]
            set Min2Score [expr [lindex $result 4]/$FragSize]
            if {($TScore < 100.0) && (($Ratio>$minRatio) || ($first2Res==0))} {
                set Assigned 1
                set ok 1
                set Fragment($iFrag,A) 1
                if {[info exists Nv_FragDisp(canvas)] && [winfo exists $Nv_FragDisp(canvas)]} {
                    $Nv_FragDisp(canvas) itemconfigure Frag$iFrag -fill red
                }
                for {set iShift 0} {$iShift<$FragSize} {incr iShift} {
                    set iRes [expr {$iShift+$firstRes}]
                    set Seq($iRes) 2
                    foreach AtmType $Fragment(AtmTypes) {
                        set Seq($iRes,$AtmType) [lindex $Fragment($iFrag,$AtmType) $iShift]
                        set pks [lindex $Fragment($iFrag,$AtmType,peaks) $iShift]
                        foreach pk $pks resDel "0 1" {
                            if {($pk != "NA") && ($pk != "")} {
                                set cRes  [expr {$iRes+$resDel}]
                                eval nv_peak elem $NvCBCA(Cdim).L $pk $iRes.$AtmType
                                eval nv_peak elem $NvCBCA(Ndim).L $pk $cRes.N
                                eval nv_peak elem $NvCBCA(HNdim).L $pk $cRes.HN
                            }
                        }
                    }
                    set bclst  [lindex $Fragment($iFrag,clst) $iShift]
                    set clst  [lindex $bclst 0]
                    if {$clst != ""} {
                        set Seq($iRes,HN) $Clust($clst,HN)
                        set Seq($iRes,N) $Clust($clst,N)
                        lappend Clust($clst,Seq) $iRes
                    }
                    set Seq($iRes,clst) $bclst
                    set Seq($iRes,Frag) $iFrag
                    set Seq($iRes,FragElem) $iShift
                    #		    puts "$iFrag $iShift $iRes $Seq($iRes,HN) $Seq($iRes,N) $clst"
                }
                set iRes [expr {$FragSize+$firstRes-1}]
                set Seq($iRes) 3
                set Seq($firstRes) 1
                if {$Seq($iRes,CA)=="NA"} {set Seq($iRes) 0}
            } else {set Assigned 0}
            set outs [format "%d %3d %3d %3d %3d %5.2f %3d %5.2f %5.3f   %s" $Assigned $iPass $iFrag $FragSize\
            $firstRes $MinScore $first2Res $Min2Score $Ratio $gWorst]
            puts stdout $outs
            puts $fileid $outs
            if {$Assigned} {
                foreach AtmType $Fragment(AtmTypes) {
                    puts $Fragment($iFrag,$AtmType,score)
                    puts $fileid $Fragment($iFrag,$AtmType,score)
                }
                foreach clst $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
                    set ClustUsed(${clst}_${link}) 1
                }
            }
            flush $fileid
        }
        incr iPass
    }
    for {set iRes 1} {$iRes<=$Nv_Nresidues} {incr iRes} {
        puts -nonewline stdout $Seq($iRes)
        puts -nonewline $fileid $Seq($iRes)
        if { [expr {($iRes % 80)==0}]} {puts stdout ""}
    }
    puts stdout ""
    puts $fileid ""
    close $fileid
}

proc SetLinkState {clust1 link1 state} {
    global Fragment
    for {set iFrag 0} {$iFrag < $Fragment(nFrag)} {incr iFrag} {
        foreach cluster $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
            set clust2 [lindex $cluster 0]
            set link2 [lindex $link 0]
            if {($clust1 == $clust2) && ($link1 == $link2)} {
                set Fragment($iFrag,use) $state
            }
        }
    }
}
proc FindFrag {residue} {
    global Fragment
    set fragMatches ""
    for {set iFrag 0} {$iFrag < $Fragment(nFrag)} {incr iFrag} {
        set fragLength [llength $Fragment($iFrag,clst)]
        foreach seqScore $Fragment($iFrag,seqScores) {
            set res1 [lindex $seqScore 0]
            if {($residue >= $res1) && ($residue < ($res1+$fragLength)) } {
                lappend fragMatches $iFrag
            }
        }
    }
    return $fragMatches
}






proc AssignFrag {filename } {
    global Nv_FragDisp ClustUsed
    set fileid [open $filename w]
    global Nv_Nresidues Fragment Seq Clust int_flag NvCBCA
    #    ZeroPeakLab $NvCBCA(0,intraResidue,peaks)
    #    ZeroPeakLab $NvCBCA(0,interResidue,peaks)
    #    ZeroPeakLab $NvCBCA(1,intraResidue,peaks)
    #    ZeroPeakLab $NvCBCA(1,interResidue,peaks)
    catch "unset ClustUsed"
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        set Clust($i,Seq) ""
    }
    if {[info exists Seq]} {unset Seq}
    set nFrag $Fragment(nFrag)
    set minRatio 0.095
    set iPass 1
    set ok 1
    SetupSequence
    set SortFrags ""
    for {set iFrag 0} {$iFrag<$nFrag} {incr iFrag} {
        set Fragment($iFrag,A) 0
	set Fragment($iFrag,seqPos) "none"
        set fragLength  [llength $Fragment($iFrag,clst)]
        if {$fragLength > 1} {
            lappend SortFrags "$iFrag $fragLength"
        }
    }
    set SortFrags [lsort -index 1 -integer -decreasing $SortFrags]
    while {$ok} {
        set ok 0
        for {set iSFrag 0} {$iSFrag<[llength $SortFrags]} {incr iSFrag} {
            if {$int_flag} {
                set int_flag 0
                close $fileid
                return
            }
            set iFrag [lindex [lindex $SortFrags $iSFrag] 0]
            if {[info exists Fragment($iFrag,use)] && !$Fragment($iFrag,use)} {continue}
            if {$Fragment($iFrag,A)} {continue}
            set used 0
            foreach clst $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
                if {[info exists ClustUsed(${clst}_${link})] && $ClustUsed(${clst}_${link})} { 
                    set used 1 ; #if any of the clusters are already sequenced, skip this frag
                    break
                }
            }
            # puts "$iFrag $used"
            if {$used} {continue} ; #skip if already used
            set FragSize [llength $Fragment($iFrag,clst)]
            
            set nScores [llength $Fragment($iFrag,seqScores)]
            if {$nScores==0} {continue}
            set seqScore0 [lindex $Fragment($iFrag,seqScores) 0]
            set firstRes0 [lindex $seqScore0 0]
            set minScore0 [lindex $seqScore0 1]
            if {$nScores == 1} {
                if {[isAssigned $firstRes0 $FragSize]} {
                    continue
                }
                
                set totalScore $minScore0
                set minScore1 10000.0
                set firstRes1 0
                set ok 1
                set Ratio 0.0
            } else {
                set totalScore 0.0
                set firstRes0 0
                set firstRes1 0
                set minScore1 10000.0
                foreach seqScore $Fragment($iFrag,seqScores) {
                    set firstRes [lindex $seqScore 0]
                    if {[isAssigned $firstRes $FragSize]} {continue}
                    if {$firstRes0 == 0} {
                        set firstRes0 [lindex $seqScore 0]
                        set minScore0 [lindex $seqScore 1]
                    } else {
                        if {$firstRes1 == 0} {
                            set firstRes1 [lindex $seqScore 0]
                            set minScore1 [lindex $seqScore 1]
                        }
                    }
                    set totalScore [expr {$totalScore+[lindex $seqScore 1]}]
                }
                if {$firstRes0 == 0} {continue}
                set meanScore [expr {$totalScore/$nScores}]
                if {$meanScore == 0.0} {
                    set meanScore 1.0
                }
                
                if {$firstRes1 == 0} {
                    set Ratio 10.0
                } else {
                    set Ratio [expr {($minScore1-$minScore0)/$meanScore}]
                    
                }
                
            }
            set gWorst ""
            set minScore0 [expr {$minScore0/$FragSize}]
            set minScore1 [expr $minScore1/$FragSize]
            if {($totalScore < 100.0) && (($Ratio>$minRatio) || ($firstRes1==0))} {
                set Assigned 1
                set ok 1
                set Fragment($iFrag,A) 1
                if {[info exists Nv_FragDisp(canvas)] && [winfo exists $Nv_FragDisp(canvas)]} {
                    $Nv_FragDisp(canvas) itemconfigure Frag$iFrag -fill red
                }
                GetShifts $iFrag
                for {set iShift 0} {$iShift<$FragSize} {incr iShift} {
                    set iRes [expr {$iShift+$firstRes0}]
                    set Seq($iRes) 2
                    set bclst  [lindex $Fragment($iFrag,clst) $iShift]
                    set blink  [lindex $Fragment($iFrag,link) $iShift]
                    set clst  [lindex $bclst 0]
                    if {$clst != ""} {
                        set Seq($iRes,HN) $Clust($clst,HN)
                        set Seq($iRes,N) $Clust($clst,N)
                        lappend Clust($clst,Seq) $iRes
                    }
                    foreach aname $Fragment(AtmTypes) {
                        set ppm  [lindex $Fragment($iFrag,$aname) $iShift]
                        set Seq($iRes,$aname) $ppm
                    }
                    
                    set Seq($iRes,clst) $bclst
                    set Seq($iRes,link) $blink
                    set Seq($iRes,Frag) $iFrag
                    set Seq($iRes,FragElem) $iShift
                    #		    puts "$iFrag $iShift $iRes $Seq($iRes,HN) $Seq($iRes,N) $clst"
                }
                set iRes [expr {$FragSize+$firstRes0-1}]
                set Seq($iRes) 3
                set Seq($firstRes0) 1
            } else {
                set Assigned 0
            }
            set outs [format "%d %3d %3d %3d %3d %7.2f %3d %7.2f %5.3f   %s" $Assigned $iPass $iFrag $FragSize $firstRes0 $minScore0 $firstRes1 $minScore1 $Ratio $gWorst]
           # puts stdout $outs
            puts $fileid $outs
            if {$Assigned} {
                foreach clst $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
                    set ClustUsed(${clst}_${link}) $iFrag
                }
		set Fragment($iFrag,seqPos) $firstRes0 ; #the position of this fragment in the seq 
            }
            flush $fileid
        }
        incr iPass
    }
    for {set iRes 1} {$iRes<=$Nv_Nresidues} {incr iRes} {
        if {$Seq($iRes,rname)=="PRO"} {
            puts -nonewline P
        } else {
            puts -nonewline stdout $Seq($iRes)
            puts -nonewline $fileid $Seq($iRes)
        }
        
        if { [expr {($iRes % 20)==0}]} {puts stdout ""}
    }
    puts stdout ""
    puts $fileid ""
    close $fileid
}


proc AssignFragMulti {filename } {
    global Nv_FragDisp
    set fileid [open $filename w]
    global Nv_Nresidues Fragment Seq Clust int_flag NvCBCA
    #    ZeroPeakLab $NvCBCA(0,intraResidue,peaks)
    #    ZeroPeakLab $NvCBCA(0,interResidue,peaks)
    #    ZeroPeakLab $NvCBCA(1,intraResidue,peaks)
    #    ZeroPeakLab $NvCBCA(1,interResidue,peaks)
    ExcludeFragments
    
    set nFrag $Fragment(nFrag)
    set minRatio 0.095
    set SortFrags ""
    for {set iFrag 0} {$iFrag<$nFrag} {incr iFrag} {
        set Fragment($iFrag,A) 0
        set Fragment($iFrag,use) 1
        set fragLength  [llength $Fragment($iFrag,clst)]
        if {$fragLength > 1} {
            lappend SortFrags "$iFrag $fragLength"
        }
    }
    set SortFrags [lsort -index 1 -integer -decreasing $SortFrags]
    set iCombi 0
    set Excludes ""
    set Assigns ""
    set nextFrags -1
    set globalScores ""
    set fragmentList ""
    while {1} {
        set globalScore 0.0
        set iPass 1
        for {set i 0} {$i<$Clust(nClust)} {incr i} {
            set Clust($i,Seq) ""
        }
        if {[info exists Seq]} {unset Seq}
        SetupSequence
        for {set iFrag 0} {$iFrag<$nFrag} {incr iFrag} {
            set Fragment($iFrag,A) 0
            set Fragment($iFrag,use) 1
        }
        foreach excludeGroup $Excludes {
            foreach iFrag $excludeGroup {
                set Fragment($iFrag,use) 0
            }
        }
        foreach assignGroup $Assigns {
            foreach iSeq $assignGroup {
                set Seq($iSeq) 2
            }
        }
        set thisScore 0.0
        foreach score $globalScores {
            set thisScore [expr {$thisScore+$score}]
        }
        set nextFrag [lindex $nextFrags end]
        incr nextFrag
        set nextFrags [lreplace $nextFrags end end]
        set ok 1
        set nsteps 0
        while {$ok} {
            incr nsteps
            if {$nsteps > 1000} {return}
            set ok 0
            while {1} {
                set testFrag -1
                set gotFrag 0
                for {set iSFrag 0} {$iSFrag < [llength $SortFrags]} {incr iSFrag}  {
                    if {$int_flag} {
                        set int_flag 0
                        close $fileid
                        return
                    }
                    set iFrag [lindex [lindex $SortFrags $iSFrag] 0]
                    if {[info exists Fragment($iFrag,use)] && !$Fragment($iFrag,use)} {continue}
                    if {$Fragment($iFrag,A)} {continue}
                    set nScores [llength $Fragment($iFrag,seqScores)]
                    if {$nScores==0} {continue}
                    incr testFrag
                    if {$testFrag == $nextFrag} {
                        set gotFrag 1
                        break
                    }
                }
                puts "$testFrag $nextFrag $gotFrag $iSFrag $iFrag"
                if {$gotFrag} {
                    set FragSize [llength $Fragment($iFrag,clst)]
                    set outs [getFragScore $iFrag $nScores $FragSize 0.0 $iPass ]
                    set result [lindex $outs 0]
                    if {$result} {
                        set ok 1
                    } else {
                        incr nextFrag
                        continue
                    }
                    lappend nextFrags $nextFrag
                    set globalScore [lindex $outs end]
                    set thisScore [expr $thisScore+$globalScore]
                    lappend globalScores $globalScore
                    lappend fragmentList $iFrag
                    puts stdout "$nextFrag $outs"
                    puts $fileid $outs
                    flush $fileid
                } else {
                    incr nextFrag
                    break
                }
            }
            incr iPass
        }
        puts $nextFrags
        puts $fragmentList
        puts "$thisScore $globalScores"
        puts $fileid $nextFrags
        puts $fileid $fragmentList
        puts $fileid "$thisScore $globalScores"
        set Assigns [lreplace $Assigns end end]
        set Excludes [lreplace $Excludes end end]
        set fragmentList [lreplace $fragmentList end end]
        set globalScores [lreplace $globalScores end end]
        set result [CheckPPM CA]
        puts $result
        puts $fileid $result
        flush $fileid
        
    }
    for {set iRes 1} {$iRes<=$Nv_Nresidues} {incr iRes} {
        if {$Seq($iRes,rname)=="PRO"} {
            puts -nonewline P
        } else {
            puts -nonewline stdout $Seq($iRes)
            puts -nonewline $fileid $Seq($iRes)
        }
        
        if { [expr {($iRes % 20)==0}]} {puts stdout ""}
    }
    puts stdout ""
    puts $fileid ""
    close $fileid
}
proc getFragScore {iFrag nScores FragSize globalScore iPass} {
    global Fragment Seq Clust
    upvar Excludes Excludes
    upvar Assigns Assigns
    set minRatio 0.095
    set seqScore0 [lindex $Fragment($iFrag,seqScores) 0]
    set firstRes0 [lindex $seqScore0 0]
    set minScore0 [lindex $seqScore0 1]
    if {$nScores == 1} {
        if {[isAssigned $firstRes0 $FragSize]} {
            return 0
        }
        
        set totalScore $minScore0
        set minScore1 10000.0
        set firstRes1 0
        set ok 1
        set Ratio 0.0
    } else {
        set totalScore 0.0
        set firstRes0 0
        set firstRes1 0
        set minScore1 10000.0
        foreach seqScore $Fragment($iFrag,seqScores) {
            set firstRes [lindex $seqScore 0]
            if {[isAssigned $firstRes $FragSize]} {continue}
            if {$firstRes0 == 0} {
                set firstRes0 [lindex $seqScore 0]
                set minScore0 [lindex $seqScore 1]
            } else {
                if {$firstRes1 == 0} {
                    set firstRes1 [lindex $seqScore 0]
                    set minScore1 [lindex $seqScore 1]
                }
            }
            set totalScore [expr {$totalScore+[lindex $seqScore 1]}]
        }
        if {$firstRes0 == 0} {return 0}
        set meanScore [expr {$totalScore/$nScores}]
        if {$meanScore == 0.0} {
            set meanScore 1.0
        }
        
        if {$firstRes1 == 0} {
            set Ratio 10.0
        } else {
            set Ratio [expr {($minScore1-$minScore0)/$meanScore}]
            
        }
        
    }
    set gWorst ""
    set minScore0 [expr {$minScore0/$FragSize}]
    set minScore1 [expr $minScore1/$FragSize]
    if {($totalScore < 100.0) && (($Ratio>$minRatio) || ($firstRes1==0))} {
        set Assigned 1
        set ok 1
        set Fragment($iFrag,A) 1
        set assigns ""
        set excludes ""
        foreach exclude $Fragment($iFrag,excludes) {
            set Fragment($exclude,use) 0
            lappend excludes $exclude
        }
        if {[info exists Nv_FragDisp(canvas)] && [winfo exists $Nv_FragDisp(canvas)]} {
            $Nv_FragDisp(canvas) itemconfigure Frag$iFrag -fill red
        }
        GetShifts $iFrag
        for {set iShift 0} {$iShift<$FragSize} {incr iShift} {
            set iRes [expr {$iShift+$firstRes0}]
            set Seq($iRes) 2
            lappend assigns $iRes
            set bclst  [lindex $Fragment($iFrag,clst) $iShift]
            set blink  [lindex $Fragment($iFrag,link) $iShift]
            set clst  [lindex $bclst 0]
            if {$clst != ""} {
                set Seq($iRes,HN) $Clust($clst,HN)
                set Seq($iRes,N) $Clust($clst,N)
                lappend Clust($clst,Seq) $iRes
            }
            foreach aname $Fragment(AtmTypes) {
                set ppm  [lindex $Fragment($iFrag,$aname) $iShift]
                set Seq($iRes,$aname) $ppm
            }
            
            set Seq($iRes,clst) $bclst
            set Seq($iRes,link) $blink
            set Seq($iRes,Frag) $iFrag
            set Seq($iRes,FragElem) $iShift
            #		    puts "$iFrag $iShift $iRes $Seq($iRes,HN) $Seq($iRes,N) $clst"
        }
        set iRes [expr {$FragSize+$firstRes0-1}]
        set Seq($iRes) 3
        set Seq($firstRes0) 1
        set globalScore [expr {$globalScore+$totalScore}]
        lappend Excludes $excludes
        lappend Assigns $assigns
    } else {
        set Assigned 0
    }
    set outs [format "%d %3d %3d %3d %3d %3d %7.2f %3d %7.2f %5.3f   %s  %10.3f" $Assigned $iPass 1 $iFrag $FragSize $firstRes0 $minScore0 $firstRes1 $minScore1 $Ratio $gWorst $globalScore]
    return $outs
}


proc isAssigned {iRes fragSize} {
    global Seq
    if {($Seq($iRes)==1) || ($Seq($iRes)==2)} {
        return 1
    }
    if {($Seq([expr {$fragSize+$iRes-1}])==2) ||  ( $Seq([expr {$fragSize+$iRes-1}])==3)} {
        return 1
    }
    for {set iShift 0} {$iShift<[expr {$fragSize-2}]} {incr iShift} {
        if {$Seq([expr {$iShift+$iRes+1}])>0} {
            return 1;
        }
    }
    for {set iShift 0} {$iShift<[expr {$fragSize-1}]} {incr iShift} {
        if {$Seq([expr {$iShift+$iRes+1}],rname)=="PRO"} {
            return 1
        }
    }
    return 0
}


proc CheckFrag {iFrag {checkSeq 1} {beginRes 1} {endRes 10000} {report 0} {skipPos ""}} {
    global Seq Fragment Nv_Nresidues
    set Fragment($iFrag,use) 0
    set FragSize [llength $Fragment($iFrag,CA) ]
    #    puts -nonewline "$iFrag $FragSize "
    if {$FragSize < 3} {
        #	puts ""
        return
    }
    set i 0
    if {$endRes>[expr {$Nv_Nresidues-$FragSize+1}]} {
        set endRes [expr {$Nv_Nresidues-$FragSize+1}]
    }
    set minScore 1.0e6
    for {set iRes $beginRes} {$iRes<=$endRes} {incr iRes} {
        set ok 1
        set tScore 0.0
        for {set iShift 0} {$iShift<[expr {$FragSize-1}]} {incr iShift} {
            set tRes [expr {$iRes+$iShift}]
            foreach AtmType $Fragment(AtmTypes) {
                set testShift [lindex $Fragment($iFrag,$AtmType) $iShift]
                set refShift [Nv_PeakAtomPPM $tRes $AtmType]
                if {$refShift==""} {continue}
                if {$testShift==""} {continue}
                set score [expr {abs($testShift-$refShift)}]
                set tScore [expr {$tScore+$score}]
                #			puts "$iRes $AtmType $tscore"
            }
        }
        #	puts "$iRes $AtmType $tScore"
        if {$tScore < $minScore} {
            set minScore $tScore
            set minRes $iRes
        }
    }
    if {$minScore < 0.01} {
        puts "$iFrag $minRes $minScore"
        set Fragment($iFrag,use) 1
    }
}

proc ScoreFrag {iFrag {checkSeq 1} {beginRes 1} {endRes 10000} {report 0} {skipPos ""}} {
    global Seq Fragment Nv_Nresidues
    set FragSize [llength $Fragment($iFrag,CA) ]
    set i 0
    set iSum 0
    set TotalScore 0.0
    set MinScore 1000.0
    set Min2Score 1000.0
    set firstRes 0
    set first2Res 0
    set gWorst ""
    #puts $iFrag
    if {$endRes>[expr {$Nv_Nresidues-$FragSize+1}]} {
        set endRes [expr {$Nv_Nresidues-$FragSize+1}]
    }
    for {set iRes $beginRes} {$iRes<=$endRes} {incr iRes} {
        if {$report} {
            puts $iRes
        }
        set ok 1
        if {$checkSeq} {
            if {($Seq($iRes)==1) || ($Seq($iRes)==2)} {
                continue;
            }
            if {($Seq([expr {$FragSize+$iRes-1}])==2) ||  ( $Seq([expr {$FragSize+$iRes-1}])==3)} {
                continue;
            }
            for {set iShift 0} {$iShift<[expr {$FragSize-2}]} {incr iShift} {
                if {$Seq([expr {$iShift+$iRes+1}])>0} {
                    set ok 0
                    break;
                }
            }
        }
        for {set iShift 0} {$iShift<[expr {$FragSize-1}]} {incr iShift} {
            if {$Seq([expr {$iShift+$iRes+1}],rname)=="PRO"} {
                set ok 0
                break;
            }
        }
        if {!$ok} {continue}
        foreach AtmType $Fragment(AtmTypes) {
            set worstScore($AtmType) 0.0
            set worstIndex($AtmType) 0
        }
        set ScoreSum 0.0
        foreach AtmType $Fragment(AtmTypes) {
            if {[expr {$ScoreSum>999.0}]} {break}
            
            set lastRes [expr {$iRes+$FragSize-1}]
            set fragScores($AtmType) ""
            
            for {set iShift 0} {$iShift<$FragSize} {incr iShift} {
                if {[lsearch $skipPos $iShift] >= 0} {continue}
                set tRes [expr {$iRes+$iShift}]
                set nextRes [expr {$tRes+1}]
                
                if {[info exists Seq($nextRes,rname)]} {
                    set nextType $Seq($nextRes,rname)
                } else {
                    set nextType TER
                }
                
                set resType [lindex $Fragment($iFrag,resType) $iShift]
                
                if {($Seq($tRes,rname)=="GLY") && ($resType != "GLY")} {
                    if {$report} {
                        puts "notGly $tRes"
                    }
                    set ScoreSum 1000.0
                    break
                }
                # BUG not very general, should exclude CB,CG etc
                if {($resType=="GLY") && ($AtmType == "CB") } {
                    continue
                }
                
                set intensity [lindex $Fragment($iFrag,$AtmType,int) $iShift]
                #set intensity ""
                if {$intensity != ""} {
                    if {![CheckIntensity $Seq($tRes,rname) $AtmType $intensity]} {
                        if {$report} {
                            puts "failedcheckI $tRes $Seq($tRes,rname) $AtmType $intensity"
                        }
                        set ScoreSum 1000.0
                        break
                    }
                }
                
                if {[string match $resType $Seq($tRes,rname) ]} {
                    set testShift [lindex $Fragment($iFrag,$AtmType) $iShift]
                    set score [ScoreShift $Seq($tRes,rname) $nextType $AtmType $testShift]
                } else {
                    if {$report} {
                        puts notRes
                    }
                    set ScoreSum 1000.0
                    break
                }
                
                if {$score>2.0} {
                    if {$report} {
                        puts "failedScore $tRes $Seq($tRes,rname) $AtmType $iShift $testShift $score"
                        
                    }
                    set ScoreSum 1000.0
                    break
                }
                if {$tRes==$lastRes} {
                    if {$checkSeq} {
                        if {$Seq($tRes) == 1} {
                            set ppm1 $Seq($tRes,$AtmType)
                            set ppm2 [lindex $Fragment($iFrag,$AtmType) $iShift]
                            if { ($ppm1 != "NA") && ($ppm2 != "NA") && ($ppm1 != "") && ($ppm2 != "") } {
                                set delta [expr {abs($ppm1-$ppm2)}]
                                if {$delta > 0.35} {
                                    set score [expr {$score+1.0}]
                                }
                            }
                        }
                    }
                }
                lappend fragScores($AtmType) $score
                if {$score>$worstScore($AtmType)} {
                    set worstScore($AtmType) $score
                    set worstIndex($AtmType) $iShift
                }
                set ScoreSum [expr {$score+$ScoreSum}]
            }
            #puts $ScoreSum
        }
        #        xy -x $i $iRes
        #        xy -y $i $ScoreSum
        
        if {[expr {$ScoreSum < 999.0}] } {
            set TotalScore [expr {$TotalScore+$ScoreSum}]
            incr iSum
        }
        if {$ScoreSum<$MinScore} {
            set gWorst ""
            foreach AtmType $Fragment(AtmTypes) {
                append gWorst [format " %5.3f %3d" $worstScore($AtmType) $worstIndex($AtmType)]
                set Fragment($iFrag,$AtmType,score) $fragScores($AtmType)
            }
            set Min2Score $MinScore
            set MinScore $ScoreSum
            set first2Res $firstRes
            set firstRes $iRes
        } else {
            if {$ScoreSum<$Min2Score} {
                set Min2Score $ScoreSum
                set first2Res $iRes
            }
        }
        incr i
    }
    #    xy -n  $i
    if {$iSum==0} { set MeanScore 0.0 } else { set MeanScore [expr {$TotalScore/$iSum}] }
    if {$MeanScore<=0.0}  {
        set Ratio 0.0
    } else {
        set Ratio [expr {($Min2Score-$MinScore)/$MeanScore}]
    }
    return  [list $MeanScore $firstRes $MinScore $first2Res $Min2Score $Ratio $gWorst]
}


proc ScoreFrag3 {iFrag seqs} {
    global Fragment Clust
    set hits ""
    foreach seq $seqs {
        set ok 1
        set score 0.0
        set clusts [lrange $Fragment($iFrag,clst) 1 end]
        set links [lrange $Fragment($iFrag,link) 1 end]
        set nextSeq $seq
        foreach clustPair $clusts linkPair $links {
            set jClust [lindex $clustPair 0]
            set jLink [lindex $linkPair 0]
            if {$jLink == {}} {
                set jLink -1
            }
            if {$jClust == {}} {
                ste jClust [lindex $clustPair 1]
            }
            
            
            incr nextSeq
            set index [lsearch $Clust($jClust,$jLink,suc,seqs) $nextSeq]
            if {$index == -1} {
                set ok 0
                break
            }
            lappend fragSeqs $nextSeq
            set score [expr {$score+[lindex $Clust($jClust,$jLink,suc,scores) $index]}]
        }
        if {$ok} {lappend hits "$seq $score"}
    }
    set hits [lsort -increasing -index 1 -real $hits]
    return $hits
}

proc ScoreFrag {iFrag} {
    puts "Scoring $iFrag"
    global Fragment Clust
    parray Fragment -1,*
    set clustPair [lindex $Fragment($iFrag,clst) 0]
    set linkPair [lindex $Fragment($iFrag,link) 0]
    set iClust [lindex $clustPair 0]
    set iLink [lindex $linkPair 0]
    #puts "$clustPair $linkPair $iClust $iLink"
    #  puts $Fragment($iFrag,clst)
    #  puts $Fragment($iFrag,link)
    set hits ""
    if {$iLink == {}} {return $hits}
    foreach seq $Clust($iClust,$iLink,suc,seqs) {
        set nextSeq $seq
        set fragSeqs $seq
        set ok 1
        set score 0.0
        set clusts [lrange $Fragment($iFrag,clst) 1 end]
        set links [lrange $Fragment($iFrag,link) 1 end]
        #puts $clusts
        foreach clustPair $clusts linkPair $links {
            set jClust [lindex $clustPair 0]
            set jLink [lindex $linkPair 0]
            if {$jLink == {}} {
                set score 1000.0
                set ok 0
                break
            }
            
            incr nextSeq
            set index [lsearch $Clust($jClust,$jLink,suc,seqs) $nextSeq]
            #puts "$index $jClust $jLink"
            if {$index != -1} {
                #puts $fragSeqs
                lappend fragSeqs $nextSeq
                set score [expr {$score+[lindex $Clust($jClust,$jLink,suc,scores) $index]}]
            } else {
                set score 1000.0
                set ok 0
                break
            }
            
        }
        if {$ok} {
            lappend hits "$seq $score"
        }
    }
    if {[llength $hits] > 0} {
        set hits [lsort -increasing -index 1 -real $hits]
    } else {
        set MinScore 1000.0
    }
    
    return $hits
}



proc ScoreFragOld {iFrag {checkSeq 1} {beginRes 1} {endRes 10000} {report 0} {skipPos ""}} {
    global Seq Fragment Nv_Nresidues
    set FragSize [llength $Fragment($iFrag,CA) ]
    set i 0
    set iSum 0
    set TotalScore 0.0
    set MinScore 1000.0
    set Min2Score 1000.0
    set firstRes 0
    set first2Res 0
    set gWorst ""
    #puts $iFrag
    if {$endRes>[expr {$Nv_Nresidues-$FragSize+1}]} {
        set endRes [expr {$Nv_Nresidues-$FragSize+1}]
    }
    for {set iRes $beginRes} {$iRes<=$endRes} {incr iRes} {
        if {$report} {
            puts $iRes
        }
        set ok 1
        if {$checkSeq} {
            if {($Seq($iRes)==1) || ($Seq($iRes)==2)} {
                continue;
            }
            if {($Seq([expr {$FragSize+$iRes-1}])==2) ||  ( $Seq([expr {$FragSize+$iRes-1}])==3)} {
                continue;
            }
            for {set iShift 0} {$iShift<[expr {$FragSize-2}]} {incr iShift} {
                if {$Seq([expr {$iShift+$iRes+1}])>0} {
                    set ok 0
                    break;
                }
            }
        }
        for {set iShift 0} {$iShift<[expr {$FragSize-1}]} {incr iShift} {
            if {$Seq([expr {$iShift+$iRes+1}],rname)=="PRO"} {
                set ok 0
                break;
            }
        }
        if {!$ok} {continue}
        foreach AtmType $Fragment(AtmTypes) {
            set worstScore($AtmType) 0.0
            set worstIndex($AtmType) 0
        }
        set ScoreSum 0.0
        foreach AtmType $Fragment(AtmTypes) {
            if {[expr {$ScoreSum>999.0}]} {break}
            
            set lastRes [expr {$iRes+$FragSize-1}]
            set fragScores($AtmType) ""
            
            for {set iShift 0} {$iShift<$FragSize} {incr iShift} {
                if {[lsearch $skipPos $iShift] >= 0} {continue}
                set tRes [expr {$iRes+$iShift}]
                set nextRes [expr {$tRes+1}]
                
                if {[info exists Seq($nextRes,rname)]} {
                    set nextType $Seq($nextRes,rname)
                } else {
                    set nextType TER
                }
                
                set resType [lindex $Fragment($iFrag,resType) $iShift]
                
                if {($Seq($tRes,rname)=="GLY") && ($resType != "GLY")} {
                    if {$report} {
                        puts "notGly $tRes"
                    }
                    set ScoreSum 1000.0
                    break
                }
                # BUG not very general, should exclude CB,CG etc
                if {($resType=="GLY") && ($AtmType == "CB") } {
                    continue
                }
                
                set intensity [lindex $Fragment($iFrag,$AtmType,int) $iShift]
                #set intensity ""
                if {$intensity != ""} {
                    if {![CheckIntensity $Seq($tRes,rname) $AtmType $intensity]} {
                        if {$report} {
                            puts "failedcheckI $tRes $Seq($tRes,rname) $AtmType $intensity"
                        }
                        set ScoreSum 1000.0
                        break
                    }
                }
                
                if {[string match $resType $Seq($tRes,rname) ]} {
                    set testShift [lindex $Fragment($iFrag,$AtmType) $iShift]
                    set score [ScoreShift $Seq($tRes,rname) $nextType $AtmType $testShift]
                } else {
                    if {$report} {
                        puts notRes
                    }
                    set ScoreSum 1000.0
                    break
                }
                
                if {$score>2.0} {
                    if {$report} {
                        puts "failedScore $tRes $Seq($tRes,rname) $AtmType $iShift $testShift $score"
                        
                    }
                    set ScoreSum 1000.0
                    break
                }
                if {$tRes==$lastRes} {
                    if {$checkSeq} {
                        if {$Seq($tRes) == 1} {
                            set ppm1 $Seq($tRes,$AtmType)
                            set ppm2 [lindex $Fragment($iFrag,$AtmType) $iShift]
                            if { ($ppm1 != "NA") && ($ppm2 != "NA") && ($ppm1 != "") && ($ppm2 != "") } {
                                set delta [expr {abs($ppm1-$ppm2)}]
                                if {$delta > 0.35} {
                                    set score [expr {$score+1.0}]
                                }
                            }
                        }
                    }
                }
                lappend fragScores($AtmType) $score
                if {$score>$worstScore($AtmType)} {
                    set worstScore($AtmType) $score
                    set worstIndex($AtmType) $iShift
                }
                set ScoreSum [expr {$score+$ScoreSum}]
            }
            #puts $ScoreSum
        }
        #        xy -x $i $iRes
        #        xy -y $i $ScoreSum
        
        if {[expr {$ScoreSum < 999.0}] } {
            set TotalScore [expr {$TotalScore+$ScoreSum}]
            incr iSum
        }
        if {$ScoreSum<$MinScore} {
            set gWorst ""
            foreach AtmType $Fragment(AtmTypes) {
                append gWorst [format " %5.3f %3d" $worstScore($AtmType) $worstIndex($AtmType)]
                set Fragment($iFrag,$AtmType,score) $fragScores($AtmType)
            }
            set Min2Score $MinScore
            set MinScore $ScoreSum
            set first2Res $firstRes
            set firstRes $iRes
        } else {
            if {$ScoreSum<$Min2Score} {
                set Min2Score $ScoreSum
                set first2Res $iRes
            }
        }
        incr i
    }
    #    xy -n  $i
    if {$iSum==0} { set MeanScore 0.0 } else { set MeanScore [expr {$TotalScore/$iSum}] }
    if {$MeanScore<=0.0}  {
        set Ratio 0.0
    } else {
        set Ratio [expr {($Min2Score-$MinScore)/$MeanScore}]
    }
    return  [list $MeanScore $firstRes $MinScore $first2Res $Min2Score $Ratio $gWorst]
}

proc ScoreShift {resName  nextName aName shift} {
    if {$shift=="NA"} {return 0.0}
    if {$shift==""} {return 0.0}
    set shift [expr {$shift+1.0}]
    if {$nextName=="PRO"} {
        if {$resName == "GLY"} {
            set shift [expr {$shift+1.0}]
        } else {
            set shift [expr {$shift+2.0}]
        }
    }
    global UPPM LPPM W
    set U $UPPM($resName,$aName)
    if {$U=="NA"} {return 1.0}
    set L $LPPM($resName,$aName)
    if {$L=="NA"} {return 1.0}
    set UW [expr {$U+$W}]
    set LW [expr {$L-$W}]
    set UW2 [expr {$U+$W*2}]
    set LW2 [expr {$L-$W*2}]
    if { ($shift<$U) && ($shift>$L)} {
        return 0.0
    }
    if { $shift>$UW2 } {
        return 999.0
    }
    if { $shift>$UW } {
        return 1.0
    }
    if { $shift>=$U } {
        return  [expr {($shift-$U)/$W}]
    }
    if { $shift<$LW2 } {
        return 999.0
    }
    if { $shift<$LW } {
        return 1.0
    }
    if { $shift<=$L } {
        return  [expr {($L-$shift)/$W}]
    }
}

proc FindPeakInClust {peak list} {
    global Clust
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        set peaks $Clust($i,$list)
        if {[lsearch $peaks $peak]>=0} {puts $i}
    }
}

proc SetPeakClust {} {
    global Clust NvCBCA
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        foreach list $NvCBCA(matchLists) {
            foreach peak $Clust($i,$list) {
                foreach label [nv_peak labels] {
                    eval nv_peak elem $label.c $peak $i
                }
            }
        }
    }
}

proc FindCaps {CAintra CAinter CBintra CBinter tol} {
    global Clust NvCBCA
    for {set i 0} {$i<$Clust(nClust)} {incr i} {
        foreach atype "CA CB" {
            set exp [set ${atype}intra]
            set intraPks $Clust($i,$exp)
            set exp [set ${atype}inter]
            set interPks $Clust($i,$exp)
            set firstPk [lindex $intraPks 0]
            if {[llength $intraPks]==1} {
                set Clust($i,${atype}peak) $firstPk
            } elseif { ([llength $intraPks]==2) && ([llength $interPks]==1)} {
                set secondPk [lindex $intraPks 1]
                set interPk [lindex $interPks 0]
                set interPPM [eval nv_peak elem $NvCBCA(Cdim).P $interPk]
                set firstPPM [eval nv_peak elem $NvCBCA(Cdim).P $firstPk]
                set secondPPM [eval nv_peak elem $NvCBCA(Cdim).P $secondPk]
                if {[expr {abs($interPPM-$firstPPM)<$tol}] } {
                    set Clust($i,${atype}peak) $secondPk
                }
                if {[expr {abs($interPPM-$secondPPM)<$tol}] } {
                    set Clust($i,${atype}peak) $firstPk
                }
            }
        }
    }
}

proc FindClustRes {iRes {firstClust 0} {lastClust 2000}} {
    global Seq Clust NvCBCA
    set preRes [expr {$iRes-1}]
    set nextRes [expr {$iRes+1}]
    if {$lastClust>=$Clust(nClust)} {
        set lastClust [expr {$Clust(nClust)-1}]
    }
    
    set result ""
    for {set i $firstClust} {$i<=$lastClust} {incr i} {
        if {![info exists Clust($i,CApeak)]} {continue}
        if {$Clust($i,CApeak)==""} {continue}
        
        set CA [eval nv_peak elem $NvCBCA(Cdim).P $Clust($i,CApeak)]
        set score1 [ScoreShift $Seq($iRes,rname)  $Seq($nextRes,rname) CA $CA]
        
        if {$Seq($iRes,rname) != "GLY"} {
            if {![info exists Clust($i,CBpeak)]} {continue}
            if {$Clust($i,CBpeak)==""} {continue}
            set CB [eval nv_peak elem $NvCBCA(Cdim).P $Clust($i,CBpeak)]
            set score2 [ScoreShift $Seq($iRes,rname)  $Seq($nextRes,rname) CB $CB]
        } else {
            set score2 0.0
        }
        
        if {[llength $Clust($i,hncoca)] != 1} {continue}
        set pCA [eval nv_peak elem $NvCBCA(Cdim).P $Clust($i,hncoca)]
        set score3 [ScoreShift $Seq($preRes,rname)  $Seq($iRes,rname) CA $pCA]
        set score22 0.0
        
        if {$Seq($preRes,rname) != "GLY"} {
            if {[llength $Clust($i,hncocacb) ]!= 1} {continue}
            set pCB [eval nv_peak elem $NvCBCA(Cdim).P $Clust($i,hncocacb) ]
            set score4 [ScoreShift $Seq($preRes,rname)  $Seq($iRes,rname) CB $pCB]
            set ppm1 $Seq($preRes,CB)
            set ppm2 $pCB
            set score11 0.0
            if { ($ppm1 != "") && ($ppm1 != "NA") && ($ppm2 != "NA") } {
                set delta [expr {abs($ppm1-$ppm2)}]
                if {$delta > 0.35} {
                    set score22 1.0
                }
            }
        } else {
            set score4 0.0
        }
        set ppm1 $Seq($preRes,CA)
        set ppm2 $pCA
        set score11 0.0
        if {($ppm1 != "") &&  ($ppm1 != "NA") && ($ppm2 != "NA") } {
            set delta [expr {abs($ppm1-$ppm2)}]
            if {$delta > 0.35} {
                set score11 1.0
            }
        }
        if {[info exists Clust($i,Seq)]} {
            set clustseq $Clust($i,Seq)
        } else {
            set clustseq U
        }
        lappend result [format "%3d %5.2f %3s" $i [expr {$score1+$score2+$score3+$score4+$score11+$score22}] $clustseq]
    }
    set result [lsort -index 1 -real $result]
    return [lrange $result 0 10]
}

proc FindUnAssignedClust {} {
    global Clust
    set nClust $Clust(nClust)
    for {set i 0} {$i<$nClust} {incr i} {
        if {$Clust($i,Seq)==""} {
            lappend result $i
        }
    }
    return $result
}
proc AssignResClusts {iClusts} {
    global NvCBCA Seq Clust
    foreach pClust $iClusts {
        set iClust [lindex $pClust 0]
        if {[llength $pClust]==2} {
            set aRes [lindex $pClust 1]
        } else {
            set aRes -1
        }
        
        set result ""
        set frcResult [FindResClust $iClust]
        puts $frcResult
        foreach resScore $frcResult {
            set score [lindex $resScore 1]
            set curRes [lindex [lindex $resScore 4] 0]
            set assignPeaks [lindex $resScore 3]
            set preRes [lindex $resScore 5]
            set Res [lindex $resScore 6]
            puts "$score $curRes"
            if {($curRes=="") && (([expr {$score < 0.3}]) || ($Res==$aRes))} {
                if {($aRes<=0) || ($Res==$aRes)} {
                    lappend result "[list [lindex $resScore 0] $assignPeaks $preRes $Res]"
                }
            }
        }
        puts $result
        if {[llength $result]==1} {
            set iresult [lindex $result 0]
            puts $iresult
            set assignPeaks [lindex  $iresult 1]
            set preRes [lindex  $iresult 2]
            set Res [lindex  $iresult 3]
            puts $Res
            set pCApeak [lindex $assignPeaks 0]
            set pCBpeak [lindex $assignPeaks 1]
            set CApeak [lindex $assignPeaks 2]
            set CBpeak [lindex $assignPeaks 3]
            eval nv_peak elem $NvCBCA(Cdim).L $CApeak $Res.CA
            puts "$preRes $Res $assignPeaks"
            set Seq($Res,CA) [eval nv_peak elem $NvCBCA(Cdim).P $CApeak]
            set Seq($Res,HN) [eval nv_peak elem $NvCBCA(HNdim).P $CApeak]
            set Seq($Res,N) [eval nv_peak elem $NvCBCA(Ndim).P $CApeak]
            #puts $Seq($Res,CA)
            eval nv_peak elem $NvCBCA(Cdim).L $pCApeak $preRes.CA
            set Seq($preRes,CA) [eval nv_peak elem $NvCBCA(Cdim).P $pCApeak]
            
            if {$CBpeak != ""} {
                eval nv_peak elem $NvCBCA(Cdim).L $CBpeak $Res.CB
                set Seq($Res,CB) [eval nv_peak elem $NvCBCA(Cdim).P $CBpeak]
            }
            if {$pCBpeak != ""} {
                set Seq($preRes,CB) [eval nv_peak elem $NvCBCA(Cdim).P $pCBpeak]
                eval nv_peak elem $NvCBCA(Cdim).L $pCBpeak $preRes.CB
            }
            
            set Seq($Res) 1
            set Seq($preRes) 1
            set Seq($Res,clst) $iClust
            lappend Clust($iClust,Seq) $Res
            set Seq($Res,Frag) AA
            set Seq($Res,FragElem) -1
            
        }
    }
}
proc FindResClust {iClust} {
    global Seq Clust NvCBCA Nv_Nresidues
    if {[llength $Clust($iClust,hncoca)] != 1} {error "no hncoca"}
    set CApeak [GetCapPeaks $iClust CA intra]
    set CBpeak [GetCapPeaks $iClust CB intra]
    
    if {$CApeak == ""} {error "no CApeak"}
    set CA [eval nv_peak elem $NvCBCA(Cdim).P $CApeak]
    puts "$CApeak $CBpeak $CA"
    
    set result ""
    set pCBpeak ""
    
    for {set iRes 2} {$iRes<$Nv_Nresidues} {incr iRes} {
        set preRes [expr {$iRes-1}]
        set nextRes [expr {$iRes+1}]
        set score1 [ScoreShift $Seq($iRes,rname)  $Seq($nextRes,rname) CA $CA]
        
        if {$Seq($iRes,rname) != "GLY"} {
            if {$CBpeak == ""} {continue}
            set CB [eval nv_peak elem $NvCBCA(Cdim).P $CBpeak]
            set score2 [ScoreShift $Seq($iRes,rname)  $Seq($nextRes,rname) CB $CB]
            set intensity [eval nv_peak elem int $CBpeak]
            if {![CheckIntensity $Seq($iRes,rname) CB $intensity]} {
                continue
            }
        } else {
            set score2 0.0
        }
        
        set pCApeak $Clust($iClust,hncoca)
        set pCA [eval nv_peak elem $NvCBCA(Cdim).P $pCApeak]
        set score3 [ScoreShift $Seq($preRes,rname)  $Seq($iRes,rname) CA $pCA]
        set score22 0.0
        
        if {$Seq($preRes,rname) != "GLY"} {
            if {[llength $Clust($iClust,hncocacb)]!= 1} {continue}
            set pCBpeak $Clust($iClust,hncocacb)
            set pCB [eval nv_peak elem $NvCBCA(Cdim).P $pCBpeak]
            set intensity [eval nv_peak elem int $pCBpeak]
            if {![CheckIntensity $Seq($preRes,rname) CB $intensity]} {
                continue
            }
            set score4 [ScoreShift $Seq($preRes,rname)  $Seq($iRes,rname) CB $pCB]
            set ppm1 $Seq($preRes,CB)
            set ppm2 $pCB
            set score11 0.0
            if { ($ppm1 != "") && ($ppm1 != "NA") && ($ppm2 != "NA") } {
                set delta [expr {abs($ppm1-$ppm2)}]
                if {$delta > 0.35} {
                    set score22 1.0
                }
            }
        } else {
            set score4 0.0
        }
        set ppm1 $Seq($preRes,CA)
        set ppm2 $pCA
        set score11 0.0
        if {($ppm1 != "") &&  ($ppm1 != "NA") && ($ppm2 != "NA") } {
            set delta [expr {abs($ppm1-$ppm2)}]
            if {$delta > 0.35} {
                set score11 1.0
            }
        }
        set score  [expr {$score1+$score2+$score3+$score4+$score11+$score22}]
        puts "$iRes $score1+$score2+$score3+$score4+$score11+$score22"
        set assign "$pCApeak $pCBpeak $CApeak $CBpeak"
        if {[info exists Seq($iRes,clst)] } {
            set aclust $Seq($iRes,clst)
        } else {
            set aclust ""
        }
        lappend result [list [format "%3d" $iRes] [format %5.2f $score] "$score1+$score2+$score3+$score4+$score11+$score22" $assign $aclust $preRes $iRes]
    }
    #puts $result
    set result [lsort -index 1 -real $result]
    return [lrange $result 0 10]
}

proc CheckIntensity {rname aname intensity} {
    global ResidueSign
    
    # check to see if the signs of ResidueSign and intensity agree
    #	by seeing if their product is greater than 0
    set value [expr $ResidueSign($rname,$aname)*$intensity]
    
    if {$value > 0} {
        return 1
    } else {
        return 0
    }
}


proc NvFindLinkFromList {opeak list} {
    set lpeaks [eval nv_peak link $opeak]
    foreach peak $lpeaks {
        if {[eval string match $list.* $peak]} {
            return $peak
            break
        }
    }
    return ""
}


proc ZeroPeakLab {lists} {
    foreach list $lists {
        set npeaks [nv_peak n $list]
        set labels [nv_peak label $list]
        for {set i 0} {$i<$npeaks} {incr i} {
            set iPeak [eval nv_peak idnum $list.$i]
            foreach lab $labels {
                eval nv_peak elem $lab.L $list.$iPeak ?
            }
        }
    }
}

proc FindSignPattern {aname pattern} {
    global Seq Nv_Nresidues
    set pattern [split $pattern ""]
    set lastRes [expr $Nv_Nresidues-[llength $pattern]]
    puts $pattern
    for {set iRes 1} {$iRes<=$lastRes} {incr iRes} {
        set ok 1
        set tRes $iRes
        foreach elem $pattern {
            if {$elem=="g"} {
                if {$Seq($tRes,rname)!="GLY"} {
                    set ok 0
                    break
                } else {
                    incr tRes
                    continue
                }
            }
            
            if {$elem == "+"} {
                set intensity 1.0
            } else {
                set intensity -1.0
            }
            if {![CheckIntensity $Seq($tRes,rname) $aname $intensity]} {
                set ok 0
                break
            }
            incr tRes
        }
        if {$ok} { puts "Match at $iRes" }
    }
}


proc GetPPM {anames} {
    global Seq Nv_Nresidues
    for {set i 1} {$i<=$Nv_Nresidues} {incr i} {
        foreach aname $anames {
            catch "eval nv_atom elem ppm $i.$aname -10000.0"
        }
    }
    
    for {set i 1} {$i<=$Nv_Nresidues} {incr i} {
        foreach aname $anames {
            if {[info exists Seq($i,$aname)]} {
                set ppm $Seq($i,$aname)
                catch "eval nv_atom elem ppm $i.$aname $ppm"
            }
        }
    }
}

proc CheckPPM {anames} {
    global Seq Nv_Nresidues
    set nAss 0
    set nWrong 0
    for {set i 1} {$i<=$Nv_Nresidues} {incr i} {
        foreach aname $anames {
            if {[info exists Seq($i,$aname)]} {
                set ppm1 $Seq($i,$aname)
                if {$ppm1 == {}} {continue}
                if {$ppm1 == "NA"} {continue}
                set ppm2 [eval nv_atom elem ppm $i.$aname]
                if {[expr {abs($ppm1-$ppm2)> 0.01}] } {
                    puts "Mismatch at residue $i: $i.$aname $ppm1 $ppm2"
                    incr nWrong
                }
                incr nAss
            }
        }
    }
    set Accuracy [expr 100.0*($Nv_Nresidues-$nWrong)/$Nv_Nresidues]
    set Assigned [expr 100.0*$nAss/$Nv_Nresidues]
    return "Wrong $nWrong Total $nAss Assigned $Assigned Accuracy $Accuracy"
}

proc rdppm { {filename "ppmrange.tbl"} } {
    global UPPM LPPM ResidueSign
    if {[file exists $filename]} {
        puts "Reading $filename to obtain residue-specific CA/CB shifts"
        set fileid [open $filename r]
        set data [read $fileid]
        close $fileid
    } else {
        puts "Reading internal database to generate residue-specific CA/CB shifts"
        
        #  ranges from Guntert et al., J Bio NMR 18(2000): 129-137
        #	using mean +/- 2 s.d. for
        set data {
            ALA 22.6 14.8 positive 56.9 48.3 positive
            ARG 34.6 26.9 positive 61.5 51.6 positive
            ASN 41.7 34.6 positive 57.1 49.3 positive
            ASP 44.2 36.2 positive 58.1 51.0 positive
            CYS 49.8 24.4 positive 63.0 49.5 positive
            GLN 33.5 25.0 positive 60.2 51.0 positive
            GLU 33.6 26.0 positive 61.5 51.8 positive
            GLY NA   NA   positive 47.8 41.9 positive
            HIS 35.8 24.1 positive 60.3 50.7 positive
            ILE 44.0 33.7 positive 66.4 55.4 positive
            LEU 47.3 37.2 positive 59.1 50.4 positive
            LYS 36.7 28.5 positive 60.6 52.2 positive
            MET 37.5 27.0 positive 58.9 51.3 positive
            PHE 41.2 35.6 positive 61.7 52.6 positive
            PRO 34.8 28.7 positive 65.6 60.1 positive
            SER 67.4 60.4 positive 61.6 53.9 positive
            THR 73.3 65.4 positive 66.9 56.6 positive
            TRP 33.5 25.0 positive 62.4 52.3 positive
            TYR 43.4 34.2 positive 61.8 52.3 positive
            VAL 37.1 28.6 positive 66.9 55.9 positive
        }
    }
    set data2 [split $data \n]
    foreach s $data2 {
        set resname [lindex $s 0]
        set ucb [lindex $s 1]
        set lcb [lindex $s 2]
        set icb [lindex $s 3]
        set uca [lindex $s 4]
        set lca [lindex $s 5]
        set ica [lindex $s 6]
        set UPPM($resname,CB) $ucb
        set LPPM($resname,CB) $lcb
        set UPPM($resname,CA) $uca
        set LPPM($resname,CA) $lca
        set UPPM($resname,HCA) 20.0
        set LPPM($resname,HCA) -20.0
        
        if {$ica=="positive"} { set ResidueSign($resname,CA) 1 } \
        else { set ResidueSign($resname,CA) -1 }
        
        if {$icb=="positive"} { set ResidueSign($resname,CB) 1 } \
        else { set ResidueSign($resname,CB) -1 }
        
    }
}

proc wrppm { {filename "ppmrange.tcl"} } {
    global UPPM LPPM ResidueSign
    
    puts "Writing residue-specific CA/CB shifts to $filename"
    set fileid [open $filename w]
    
    foreach res "ALA ARG ASN ASP CYS GLN GLU GLY HIS ILE LEU LYS MET PHE \
    PRO SER THR TRP TYR VAL" {
        
        if { $ResidueSign($res,CA)==1 } { set rsCA positive } \
        else { set rsCA negative }
        
        if { $ResidueSign($res,CB)==1 } { set rsCB positive } \
        else { set rsCB negative }
        
        puts $fileid "$res $UPPM($res,CB) $LPPM($res,CB) $rsCB \
        $UPPM($res,CA) $LPPM($res,CA) $rsCA"
    }
    
    close $fileid
}

proc AssignSeq {} {
    global W Fragment NvCBCA
    set W 5
    rdppm
    set NvCBCA(list,CA,intra) hnca
    set NvCBCA(list,CA,inter) hncoca
    set NvCBCA(list,CB,intra) hncacb
    set NvCBCA(list,CB,inter) hncocacb
    flwlinks links.out
    set Fragment(AtmTypes) "CA CB"
    AssignFrag assign.out
    GetPPM "CA CB HN N"
}
proc ExcludeFragments {} {
    global Fragment
    set nFrag $Fragment(nFrag)
    
    for {set jFrag 0} {$jFrag<$nFrag} {incr jFrag} {
        puts -nonewline " $jFrag"
        set Fragment($jFrag,excludes) ""
        for {set iFrag 0} {$iFrag<$nFrag} {incr iFrag} {
            foreach clst $Fragment($iFrag,clst) link $Fragment($iFrag,link) {
                if {[lsearch $Fragment($jFrag,clst) $clst] != -1} {
                    if {[lsearch $Fragment($jFrag,link) $link] != -1} {
                        puts -nonewline " $iFrag"
                        lappend Fragment($jFrag,excludes) $iFrag
                        break
                    }
                }
            }
        }
        puts " "
    }
}

proc CheckPeakAssign {} {
    global Nv_Nresidues Seq Clust
    set nAssigned 0
    set nWrong 0
    for {set i 1} {$i<$Nv_Nresidues} {incr i} {
        if {![info exists Seq($i,clst)]} {continue}
        set bclust $Seq($i,clst)
        set blink $Seq($i,link)
        set clust [lindex $bclust 0]
        
        if {$clust == ""} {
            set clust [lindex $bclust 1]
            set link [lindex $blink 1]
            set peaks1 [lindex [lindex $Clust($clust,pre) $link] 4]
            set peaks2 [lindex [lindex $Clust($clust,pre) $link] 5]
            # don't use yet
            set peaks1 ""
            
        } else {
            
            set link [lindex $blink 0]
            set peaks1 [lindex [lindex $Clust($clust,suc) $link] 4]
            set peaks2 [lindex [lindex $Clust($clust,suc) $link] 5]
        }
        if {$peaks1 != ""} {
            incr nAssigned
            regexp {(.*)(\.)(.*)} [nv_peak elem 1HN.L [lindex $peaks1 0]] a seq dot atom
            if {$i != $seq} {
                incr nWrong
                puts "$i $seq $Seq($i,Frag) $Seq($i,FragElem)"
            }
            
        }
        
    }
    puts "$nWrong / $nAssigned"
}

proc confirmAll {} {
    global Clust
    for {set i 0} {$i < $Clust(nClust)} {incr i 1} {
	foreach dir "suc pre" {
	    for {set j 0} {$j < [llength $Clust($i,$dir)]} {incr j} {
		set clust [lindex $Clust($i,$dir) $j]
		set clust [lreplace $clust 2 2 [expr 1 + $j]]
		set Clust($i,$dir) [lreplace $Clust($i,$dir) $j $j $clust]
		if {$dir == "suc"} {
		    lappend Clust($i,used) [lindex [lindex $Clust($i,suc) $j] 0]
		} elseif {[info exists Clust($i,used)]} {
		    set clustToFind [lindex [lindex $Clust($i,pre) $j] 0]
		    set found [lsearch $Clust($i,used) $clustToFind]
		    if {$found >= 0} {
			set score1 [lindex [lindex $Clust($i,suc) $found] 1] 
			set score2 [lindex [lindex $Clust($i,pre) $j] 1]
			if {$score1 > $score2} {
			    set clust [lindex $Clust($i,pre) $j]
			    set clust [lreplace $clust 2 2 0] 
			    set Clust($i,pre) [lreplace $Clust($i,pre) $j $j $clust]
			} else {
			    set clust [lindex $Clust($i,suc) $found]
			    set clust [lreplace $clust 2 2 0] 
			    set Clust($i,suc) [lreplace $Clust($i,suc) $found $found $clust]
			}
		    }
		}
	    }
	}
    }
}
