proc Nv_SeqDisplay { nm} {
    global Nv_Nresidues Seq SGL Nv_SeqDisp CSI Nv_Priv
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    toplevel $nm
    wm minsize $nm 1 1
    
    set Nv_SeqDisp(displayAtoms) "HA HB HN CA CB C N"
    #    set Nv_SeqDisp(csiAtoms) "HA HB HN CA CB C N"
    set Nv_SeqDisp(csiAtoms) "HA HN CA CB C N"
    set Nv_SeqDisp(csiDispMode) threshold
    set Nv_SeqDisp(csiDispType) CSI
    set Nv_SeqDisp(maxCSI) 1.0
    set Nv_SeqDisp(nfields) 50
    foreach atom $Nv_SeqDisp(displayAtoms) {
        set Nv_SeqDisp(displayAtom,$atom) 0
        set Nv_SeqDisp(csiAtom,$atom) 0
        set Nv_SeqDisp(csiAtom_old,$atom) 0
        set Nv_SeqDisp(csiCalcAtom,$atom) 0
    }
    
    set Nv_SeqDisp(fontSize) 10
    set Nv_SeqDisp(annoTypes) Cartoon
    set Nv_SeqDisp(anno,Cartoon) 0
    set Nv_SeqDisp(noes) "hnhn"
    set Nv_SeqDisp(noes,hnhn) 0
    set Nv_SeqDisp(displayAtom,HN) 1
    set Nv_SeqDisp(csiCalcAtom,CA) 0
    set Nv_SeqDisp(erase) 0
    set Nv_SeqDisp(ascii) 0
    
    set CSI(deuterated) 0
    set CSI(assignflag) 0
    set CSI(trosy) 0
    set CSI(ph) ""
    set CSI(temp) ""
    set CSI(assignfactor) ""
    set CSI(assign) ""
    
    
    set fr $nm.cntrlBar
    frame $fr
    pack $fr -side top -fill x
    
    button $fr.close -text Close -command "wm withdraw $nm"
    pack $fr.close -side left
    
    button $fr.options -text Options -command "NvSeqOptions $nm"
    pack $fr.options -side left
    
    button $fr.plot -text Plot -command "NvSeqPlot"
    pack $fr.plot -side left
    
    
    button $fr.colAss -text ColorAssigned -command "NvSeqColorAssign $nm"
    pack $fr.colAss -side left
    
    #    button $fr.calCSI -text CalcCSI -command "NvSeqCalCSI $nm;CSISec $nm;NvSeqMkCanvas"
    button $fr.calCSI -text CalcCSI -command "NvSeqOptionsCSI $nm"
    pack $fr.calCSI -side left

    button $fr.add -text Add -command "NvEditSeq"
    pack $fr.add -side left
    
    label $fr.sheetLabel -width 12 -text CurrentRes:
    label $fr.sheetStatus -width 4 -relief sunken -textvariable Nv_SeqDisp(CurrentRes)
    pack $fr.sheetLabel $fr.sheetStatus -side left
    
    set fr $nm.assignBar
    frame $fr
    pack $fr -side top -fill x
    
    label $fr.assignLabel -width 10 -text Assigned:
    label $fr.assignStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Assigned)
    pack $fr.assignLabel $fr.assignStatus -side left
    
    label $fr.sheetLabel -width 10 -text Sheet:
    label $fr.sheetStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Sheet)
    pack $fr.sheetLabel $fr.sheetStatus -side left
    
    label $fr.helixLabel -width 10 -text Helix:
    label $fr.helixStatus -width 12 -relief sunken -textvariable Nv_SeqDisp(Helix)
    pack $fr.helixLabel $fr.helixStatus -side left
    
    label $fr.colorcodelabel -text "CSI color coding:"
    pack $fr.colorcodelabel  -side top
    
    set fr $nm.statusBar
    frame $fr
    pack $fr -side top -fill x
    
    foreach item "Fragment Element Cluster" {
        set litem [string tolower $item]
        label $fr.${litem}Label -width 10  -text $item
        label $fr.${litem}Status -width 12 -relief sunken -textvariable Nv_SeqDisp($item)
        pack $fr.${litem}Label $fr.${litem}Status -side left
    }
    
    label $fr.colorcodelabel1 -width 13 -bg red -fg white -text "Positive (+1)."
    pack $fr.colorcodelabel1  -side left
    
    label $fr.colorcodelabel2 -width 9 -bg grey -fg black -text "Zero (0)."
    pack $fr.colorcodelabel2  -side left
    
    label $fr.colorcodelabel3 -width 13 -bg blue -fg white -text "Negative (-1)."
    pack $fr.colorcodelabel3  -side left
    
    
    frame $nm.fr1 -border 5 -relief raised -bg white
    pack $nm.fr1 -side top -fill both  -expand y
    set Nv_SeqDisp(canvas) $nm.fr1.canvas
    wm deiconify $nm
    raise $nm
    if {$Nv_Priv(javaMode)} {
        set molName [mol molname]
        mol select atoms ${molName}:*.CA
        foreach atom [mol listatoms] {
            set rname [nv_atom elem rname $atom]
            set j [nv_atom elem seq $atom]
            foreach atom $Nv_SeqDisp(csiAtoms) {
                set Seq($j,CSIdelta,$atom) 0.0
            }
        }
    } else {
        foreach residue [nv_list seq] {
            set j [lindex $residue 4]
            foreach atom $Nv_SeqDisp(csiAtoms) {
                set Seq($j,CSIdelta,$atom) 0.0
            }
        }
    }
    
    NvSeqMkCanvas
}

proc NvSeqNoes { } {
    global Seq
    if {[info command nv_noe] != "nv_noe"} {
        return
    }
    set nNoes [nv_noe n]
    for {set i 0} {$i<$nNoes} {incr i} {
        set status [nv_noe -elem active $i]
        if {!$status} {continue}
        set res0 [nv_noe -elem res.0 $i]
        set res1 [nv_noe -elem res.1 $i]
        set aname0 [string tolower [nv_noe -elem aname.0 $i]]
        set aname1 [string tolower [nv_noe -elem aname.1 $i]]
        if {[string match hn $aname0] && [string match hn $aname1]} {
            if {[expr {abs($res0-$res1) == 1}]} {
                if {$res0 > $res1} {
                    set iRes $res1
                } else {
                    set iRes $res0
                }
                set upper [nv_noe -elem upper $i]
                set height [expr {(5.0-$upper)/3.0}]
                if {$height > 1.0} {
                    set height 1.0
                }
                if {$height < 0.0} {
                    set height 0.0
                }
                set Seq($iRes,hnhn) $height
            }
        }
        
    }
}

proc NvSeqPlot {} {
    global Nv_SeqDisp
    $Nv_SeqDisp(canvas) postscript -colormode color -file seq.ps -rotate y -pagewidth 8.6i
}

proc NvSeqMkCanvas {} {
    global Nv_Nresidues Seq SGL Nv_SeqDisp
    
    set canvas $Nv_SeqDisp(canvas)
    set Nv_SeqDisp(canvas) $canvas
    
    if {[winfo exists $canvas]} {
        destroy $canvas
    }
    set nAtypes 0
    foreach atom $Nv_SeqDisp(displayAtoms) {
        incr nAtypes $Nv_SeqDisp(displayAtom,$atom)
    }
    foreach noeType $Nv_SeqDisp(noes) {
        incr nAtypes $Nv_SeqDisp(noes,$noeType)
    }
    foreach anno $Nv_SeqDisp(annoTypes) {
        incr nAtypes $Nv_SeqDisp(anno,$anno)
    }
    foreach atom $Nv_SeqDisp(csiAtoms) {
        incr nAtypes $Nv_SeqDisp(csiAtom,$atom)
    }
    set lineGap [expr $nAtypes/4.0]
    set xborder 80
    set yborder 10
    set pixsize  $Nv_SeqDisp(fontSize)
    set xcharsize [expr $pixsize+2]
    set ycharsize [expr $pixsize+16]
    set ssLineWidth 3
    
    set width [expr $xborder*2+$Nv_SeqDisp(nfields)*$xcharsize]
    set height [expr $yborder*2+[expr ($Nv_Nresidues/$Nv_SeqDisp(nfields))+1]*$ycharsize*($nAtypes+$lineGap)]
    canvas $canvas -width $width -height $height -bg white
    set tl [winfo toplevel $canvas]
    pack $canvas -side bottom -fill both -expand yes
    
    set nass 0
    set resMax 0
    set Seq(resoffs) [expr [nv_atom elem seq 1] - 1]
    for {set j 1} {$j<=$Nv_Nresidues} {incr j} {
        nv_residue $j res
        if {$res(num) == "."} {
            break
        }
        set iRes $res(num)
        set Seq($j,annCol) grey
        set Seq(num) $iRes
        foreach noeType $Nv_SeqDisp(noes) {
            set Seq($j,$noeType) ""
        }
        #                puts "NvSeqMkCanvas CON, $iRes, $Seq($iRes,CSIF,CON)"
        if {[info exists Seq($j,CSIF,CON)]} {
            set Seq($j,annType)  $Seq($iRes,CSIF,CON)
        } else {
            set Seq($j,annType)  ""
        }
        #               set Seq($j,annType)  ""
        set Seq($j,rname)  $res(name)
        if {![info exists Seq($j)]} {
            set Seq($j) 0
            
            foreach  atype  $Nv_SeqDisp(displayAtoms) {
                set ppm -999.0
                if {($res(name)=="GLY") && ($atype=="CB")} {continue}
                if {($res(name)=="GLY") && ($atype=="HA")} {
                    if {[catch "nv_atom elem ppm $iRes.${atype}1" ppm]} {
                        if {[catch "nv_atom elem ppm $iRes.${atype}2" ppm]} {
                            if {[catch "nv_atom elem ppm $iRes.${atype}3" ppm]} {
                                continue
                            }
                        }
                    }
                } else {
                    if {[nv_atom num $iRes.$atype]<0} {continue}
                    set ppm [nv_atom elem ppm $iRes.$atype]
                }
                if {$ppm> -990.0} {
                    set Seq($j) 1
                    break
                }
            }
        }
        if {$Seq($j)} { incr nass}
    }
    NvSeqNoes
    
    
    if {[file exists seqdisp.ann]} {
        for {set j 1} {$j<=$Nv_Nresidues} {incr j} {
            puts "resetting annType"
            set Seq($j,annType)  ""
        }
        set f1 [open seqdisp.ann r]
        set nres 50
        while {[gets $f1 s] != -1} {
            set start [lindex $s 0]
            set end  [lindex $s 1]
            set type [lindex $s 2]
            for {set i $start } {$i<=$end} {incr i} {
                set Seq($i,annCol)  $type
                if {$type=="blue"} {
                    set Seq($i,annType) h
                    puts "$i, $Seq($i,annType)"
                } elseif {$type=="red"} {
                    set Seq($i,annType) s
                } else {
                    set Seq($j,annType)  ""
                }
                
            }
        }
        close $f1
    }
    
    
    set font -*-courier-*-r-normal-*-*-[expr 15*$pixsize]-*-*-*-*-*-*
    
    set line 1
    set line1 1
    set j 1
    set xhalf [expr $xcharsize/2]
    set yhalf [expr $ycharsize/2]
    set hElem 0
    set line $yborder
    while {$j<=$Nv_Nresidues} {
        nv_residue $j res
        if {$res(num) == "."} {
            break
        }
        set iRes $res(num)
        set y $line
        foreach atom $Nv_SeqDisp(displayAtoms) {
            if {! $Nv_SeqDisp(displayAtom,$atom)} {continue}
            set x [expr $xborder-$xhalf]
            set rowlabel [expr ($line1-1)*$Nv_SeqDisp(nfields)+1+$Seq(resoffs)]
            $canvas create text $x $y -text $rowlabel.$atom -anchor e
            set x [expr $width-$xborder+$xhalf]
            set rowlabel [expr $line1*$Nv_SeqDisp(nfields)+$Seq(resoffs)]
            $canvas create text $x $y -text $rowlabel.$atom -anchor w
            set y [expr {$y+$ycharsize}]
        }
        foreach atom $Nv_SeqDisp(csiAtoms) {
            if {! $Nv_SeqDisp(csiAtom,$atom)} {continue}
            set x [expr $xborder-$xhalf]
            set rowlabel [expr ($line1-1)*$Nv_SeqDisp(nfields)+1+$Seq(resoffs)]
            $canvas create text $x $y -text $rowlabel.$atom -anchor e
            set x [expr $width-$xborder+$xhalf]
            set rowlabel [expr $line1*$Nv_SeqDisp(nfields)+$Seq(resoffs)]
            $canvas create text $x $y -text $rowlabel.$atom -anchor w
            set y [expr {$y+$ycharsize+10}]
        }
        for {set i 0} {$i<$Nv_SeqDisp(nfields) } {incr i} {
            if {$j>$Nv_Nresidues} {break}
            nv_residue $j res
            if {$res(num) == "."} {
                break
            }
            set y $line
            set iRes $res(num)
            set rname $SGL($Seq($j,rname))
            set x [expr $i*$xcharsize+$xborder+$xhalf]
            set xn [expr ($i+1)*$xcharsize+$xborder+$xhalf]
            set xnn [expr ($i+2)*$xcharsize+$xborder+$xhalf]
            set x1 [expr $x-$xhalf]
            set x2 [expr $x+$xhalf]
            foreach atom $Nv_SeqDisp(displayAtoms) {
                if {! $Nv_SeqDisp(displayAtom,$atom)} {continue}
                set y1 [expr $y+$yhalf-5]
                set y2 [expr $y-$yhalf+5]
                set y3 [expr $y-$yhalf]
                #                                $canvas create rectangle $x1 $y1 $x2 $y2 -fill grey -outline grey -tags SeqB$atom$iRes
                #				$canvas create text $x $y -text $rname -tags Seq$atom$j -anchor center
                #                                $canvas create rectangle $x1 $y2 $x2 $y1 -fill red -outline red -tags SeqB$atom$iRes
                $canvas create text $x $y -text $rname  -tags Seq$atom$j -anchor center -font "Courier $Nv_SeqDisp(fontSize)"
                
                $canvas bind Seq$atom$j <Enter> "NvSeqedCurRes $tl $iRes"
                $canvas bind SeqB$atom$j <Enter> "NvSeqedCurRes $tl $iRes"
                $canvas bind Seq$atom$j <1> "NvSeqDumpResAssign $tl $j $iRes"
                $canvas bind SeqB$atom$j <1> "NvSeqDumpResAssign $tl $j $iRes"
                set y [expr {$y+$ycharsize}]
            }
            foreach noeType $Nv_SeqDisp(noes) {
                if {$Nv_SeqDisp(noes,$noeType)} {
                    set y1 [expr $y+$yhalf-5]
                    if {$Seq($j,$noeType) == ""} {
                        set y2 $y1
                    } else {
                        set noeVal $Seq($j,$noeType)
                        set y2 [expr $y+$yhalf-5-($noeVal+0.3)/1.2*2.0*$yhalf]
                    }
                    $canvas create rectangle $x1 $y1 $x2 $y2 -fill green -outline white
                    set y [expr {$y+$ycharsize}]
                }
                
            }
            set CSIType $Nv_SeqDisp(csiDispType)
            foreach atom $Nv_SeqDisp(csiAtoms) {
                if {$Nv_SeqDisp(csiAtom,$atom)} {
                    set csiValid 1
                    if {$Nv_SeqDisp(csiDispMode) == "value"} {
                        set csiVal [expr $Seq($j,CSIdelta,$atom)/$Nv_SeqDisp(maxCSI)]
                        if {[info exists Seq($j,$CSIType,$atom)]} {
                            if {$Seq($j,$CSIType,$atom) == "n"} {
                                set csiValid 0
                            }
                        }
                    } else {
                        if {[info exists Seq($j,$CSIType,$atom)]} {
                            if {$Seq($j,$CSIType,$atom) == "h"} {
                                set csiVal 1.0
                            } elseif {$Seq($j,$CSIType,$atom) == "s"} {
                                set csiVal -1.0
                            } elseif {$Seq($j,$CSIType,$atom) == "c"} {
                                set csiVal  0.0
                            } else {
                                set csiVal  0.0
                                set csiValid 0
                            }
                        } else {
                            set csiVal  0.0
                            set csiValid 0
                        }
                    }
                    if {$csiVal > 0.0} {
                        set color red
                    } elseif {$csiVal < 0.0} {
                        set color blue
                    } else {
                        set color grey
                    }
                    
                    set y1 $y
                    #					set y2 [expr {$y+$yhalf*$csiVal}]
                    set y2 [expr {$y-$yhalf*$csiVal}]
                    #                                       $canvas create rectangle $x1 $y1 $x2 $y2 -fill $color -outline white
                    $canvas create line $x [expr {$y+$yhalf}] $x [expr {$y-$yhalf}] -fill $color
                    if ($csiValid) {
                        $canvas create arc [expr {$x-3}] [expr {$y2-3}]  [expr {$x+5}] [expr {$y2+5}]\
                        -fill $color -extent 359.9 -outline $color -start 90
                    }
                    set y [expr {$y+$ycharsize+10}]
                }
                
            }
            
            foreach anno $Nv_SeqDisp(annoTypes) {
                if {!$Nv_SeqDisp(anno,$anno)} {continue}
                set y1 [expr $y+$yhalf-5.0]
                set y2 [expr $y-$yhalf+5.0]
                set y4 [expr $y+$yhalf-9.0]
                set y5 [expr $y-$yhalf+9.0]
                set x3 [expr {($x1+$x2)/2.0}]
                set y3 [expr $y-$yhalf]
                set x1n [expr $xn-$xhalf]
                set x2n [expr $xn+$xhalf]
                set x3n [expr {($x1n+$x2n)/2.0}]
                
                
                if {$Seq($j,annType)=="s"} {
                    set k [expr {$j+1}]
                    if {($k <= $Nv_Nresidues) && $Seq($k,annType) == "s"} {
                        $canvas create polygon $x1 $y1 $x1 $y2 $x2 $y2 $x2 $y1 -fill darkgrey
                    } else {
                        #                		    $canvas create polygon $x1 $y1 $x1 $y2 $x3 [expr $y2-3] $x2 $y $x3 [expr $y1+3] -fill darkgrey -outline black
                        $canvas create polygon $x1 $y1 $x1 [expr $y2-3] $x2 $y $x1 [expr $y1+3] -fill darkgrey
                    }
                    set hElem 0
                } elseif {$Seq($j,annType)=="h"} {
                    if {[expr {$hElem == 0}]} {
                        set x1p $x1
                        set x2p $x2
                        set x3p [expr {$x1+3.0*$xhalf}]
                        set x4p [expr {$x2+($x2p-$x1p)}]
                        set x5p $x2
                        set x6p [expr {$x3p-($x2p-$x1p)}]
                        set poly [$canvas create polygon $x3p $y $x3p $y $x3p $y \
                        $x4p $y2 $x4p $y2 $x4p $y2 \
                        $x5p $y2 $x5p $y2 $x5p $y2 \
                        $x6p $y $x6p $y $x6p $y \
                        -fill darkgrey  -outline black -smooth true]
                        $canvas lower $poly
                    }
                    if {[expr {($hElem % 4)==2}]} {
                        set x1p $x1
                        set x2p $x2
                        set x3p [expr {$x2+3.0*$xhalf}]
                        set x4p [expr {$x2n+($x2p-$x1p)}]
                        set x5p $x2n
                        set x6p [expr {$x3p-($x2p-$x1p)}]
                        set poly [$canvas create polygon $x1p $y1 $x1p $y1 $x1p $y1 \
                        $x2p $y1 $x2p $y1 $x2p $y1 \
                        $x3p $y \
                        $x4p $y2 $x4p $y2 $x4p $y2 \
                        $x5p $y2 $x5p $y2 $x5p $y2 \
                        $x6p $y \
                        $x1p $y1 $x1p $y1 $x1p $y1 \
                        -fill darkgrey  -outline black -smooth true]
                        $canvas lower $poly
                    } elseif {[expr {($hElem % 4)==1}]} {
                        set x1p $x1
                        set x2p $x2
                        set x3p [expr {$x2+$xhalf}]
                        set x4p $xnn
                        set x5p [expr {$x4p-($x2p-$x1p)}]
                        set x6p [expr {$x3p-($x2p-$x1p)}]
                        
                        
                        set poly [$canvas create polygon $x1p $y2 $x1p $y2 $x1p $y2 \
                        $x2p $y2 $x2p $y2 $x2p $y2 \
                        $x3p $y \
                        $x4p $y1 $x4p $y1 $x4p $y1 \
                        $x5p $y1 $x5p $y1 $x5p $y1 \
                        $x6p $y \
                        $x1p $y2 $x1p $y2 $x1p $y2 \
                        -fill lightgrey  -outline black -smooth true]
                        $canvas raise $poly
                    }
                    incr hElem
                } else {
                    set hElem 0
                }
                set citem [$canvas create line $x1 [expr {$y-1}] $x2 [expr {$y-1}] -fill lightgrey -width 1]
                $canvas lower $citem
                set y [expr {$y+$ycharsize}]
            }
            set sscolor $Seq($j,annCol)
            set x1 [expr $x-$xhalf]
            set x2 [expr $x+$xhalf]
            set y3 [expr $y-$yhalf-[expr $ssLineWidth/2]]
            $canvas create line $x1 $y3 $x2 $y3 -fill $sscolor -width $ssLineWidth
            incr j
        }
        set line [expr $y+$lineGap]
        incr line1
    }
}

proc CSISec {nm} {
    global Nv_Nresidues Seq SGL CSI Nv_SeqDisp
    
    set color(h) green
    set color(s) blue
    set color(n) lightgrey
    set color(c) orange
    set atypes "$Nv_SeqDisp(csiAtoms) CON"
    
    foreach atype $atypes {
        #	 if {!$Nv_SeqDisp(csiCalcAtom,$atype)} {continue}
        
        if {($atype != "CON") && ($Nv_SeqDisp(csiCalcAtom,$atype)==0)} {continue}
        
        for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
            if {[info exists Seq($i,CSI,$atype)]} {
                if {$Seq($i,CSI,$atype) == "n"} {
                    set Seq($i,CSIF,$atype) n
                } else {
                    set Seq($i,CSIF,$atype) c
                }
            } else {
                set Seq($i,CSIF,$atype) n
            }
            
        }
        
    }
    
    foreach sstype "h s" {
        if {$sstype=="h"} {
            set win 4
        } else {
            set win 3
        }
        foreach atype $atypes {
            if {($atype != "CON") && ($Nv_SeqDisp(csiCalcAtom,$atype)==0)} {continue}
            #	if {$Nv_SeqDisp(csiCalcAtom,$atype)==0} {continue}
            for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
                set ok 0
                set nok 0
                for {set j 0} {$j<$win} {incr  j} {
                    set k [expr $i+$j]
                    if {![info exists Seq($k,CSI,$atype)] } {
                        set nok 1
                        break
                    }
                    if {$Seq($k,CSI,$atype) == "c"} {continue}
                    if {$Seq($k,CSI,$atype) == "n"} {continue}
                    if {$Seq($k,CSI,$atype) != $sstype} {
                        set nok 1
                        break
                    } else {
                        incr ok
                    }
                }
                if {$nok} {continue}
                if {$ok>2} {
                    for {set j 0} {$j<$win} {incr  j} {
                        set k [expr $i+$j]
                        set Seq($k,CSIF,$atype) $sstype
                    }
                }
            }
        }
    }
    set nHelix 0
    set nSheet 0
    for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
        if {[info exists Seq($i,CSIF,CON)]} {
            set sstype $Seq($i,CSIF,CON)
            if {$sstype=="h"} {incr nHelix}
            if {$sstype=="s"} {incr nSheet}
        }
    }
    puts "Secondary Structure from CSI"
    set Nv_SeqDisp(Helix) [format "%3d (%4.1f %%)"  $nHelix [expr 100.0*$nHelix/$Nv_Nresidues] ]
    set Nv_SeqDisp(Sheet) [format "%3d (%4.1f %%)" $nSheet [expr 100.0*$nSheet/$Nv_Nresidues] ]
}

proc NvSeqColorAssign {nm} {
    global Nv_Nresidues Seq Nv_SeqDisp
    set nass 0
    set canvas $Nv_SeqDisp(canvas)
    
    foreach atype $Nv_SeqDisp(displayAtoms) {
        set Nv_SeqDisp(nAssigned,$atype) 0
    }
    for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
        set ok 0
        foreach atype $Nv_SeqDisp(displayAtoms) {
            eval nv_residue $i res
            set fcolor black
            set ppm -999.0
            if {($res(name)=="GLY") && ($atype=="HA")} {
                if {[catch "nv_atom elem ppm $i.${atype}1" ppm]} {
                    if {[catch "nv_atom elem ppm $i.${atype}2" ppm]} {
                        if {[catch "nv_atom elem ppm $i.${atype}3" ppm]} {
                            error "$ppm"
                        }
                    }
                }
            } else {
                if {[nv_atom num $i.$atype]>=0} {
                    set ppm [nv_atom elem ppm $i.$atype]
                }
            }
            if {$ppm> -990.0} {
                set fcolor red
                incr Nv_SeqDisp(nAssigned,$atype)
                set ok 1
            } else {
                set fcolor black
            }
            $canvas itemconfigure Seq$atype$i -fill $fcolor
            
        }
    }
}

proc NvSeqColorRes {color {resTypes *} } {
    global Nv_Nresidues Seq Nv_SeqDisp SGL
    set nass 0
    set canvas $Nv_SeqDisp(canvas)
    
    for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
        foreach atype $Nv_SeqDisp(displayAtoms) {
            if {$resTypes == "*"} {
                set fcolor $color
                $canvas itemconfigure Seq$atype$i -fill $fcolor
            } else {
                set rname $SGL($Seq($i,rname))
                if {[lsearch $resTypes $rname] >= 0} {
                    set fcolor $color
                    $canvas itemconfigure Seq$atype$i -fill $fcolor
                }
            }
        }
    }
}

proc NvSeqColorCSI {nm} {
    global Nv_Nresidues Seq Nv_SeqDisp
    set canvas $Nv_SeqDisp(canvas)
    set color(h) green
    set color(s) blue
    set color(n) lightgrey
    set color(c) orange
    
    set nass 0
    for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
        
        foreach atype $Nv_SeqDisp(csiAtoms) {
            if {$Nv_SeqDisp(csiAtom,$atype)==0} {continue}
            if {[info exists Seq($i)] && ($Seq($i)>0) } {
                if {[info exists Seq($i,CSI,$atype)]} {
                    set sstype $Seq($i,CSI,$atype)
                    set bcolor $color($sstype)
                    $canvas itemconfigure SeqB$atype$i -fill $bcolor  -outline black
                }
                
                if {[info exists Seq($i,CSIF,$atype)]} {
                    set sstype $Seq($i,CSIF,$atype)
                    set bcolor $color($sstype)
                    #                    $canvas itemconfigure SeqB$atype$i  -outline $bcolor
                    $canvas itemconfigure SeqB$atype$i -fill $bcolor  -outline $bcolor
                }
            }
        }
    }
}


proc NvSeqCalCSI {nm} {
    global Nv_Nresidues Seq SGL CSI Nv_SeqDisp NVH
    
    set Nv_SeqDisp(erase) 1
    GetCSITables $CSI(reflist)
    
    set Nv_SeqDisp(maxCSI) 1.0
    foreach atype $Nv_SeqDisp(csiAtoms) {
        if  {$Nv_SeqDisp(csiCalcAtom,$atype)== 1} { lappend atypes $atype }
    }
    
    set nAtypes  [llength $atypes]
    set nass 0
    
    foreach atype $atypes {
        set Nv_SeqDisp(csiAtom_old,$atype) 1
        if { $Nv_SeqDisp(ascii) == 1 } {
            switch $atype {
                "HN" { set fileHN $atype.ppm.$CSI(reflist)
                    set file1HN $atype.csi.$CSI(reflist)
                    set file2HN $atype.csi.as.$CSI(reflist)
                    set file3HN $atype.csi.con.$CSI(reflist)
                    set outfileHN [open $fileHN w]
                    set outfile1HN [open $file1HN w]
                    set outfile2HN [open $file2HN w]
                    set outfile3HN [open $file2HN w]
                }
                "HA" { set fileHA $atype.ppm.$CSI(reflist)
                    set file1HA $atype.csi.$CSI(reflist)
                    set file2HA $atype.csi.as.$CSI(reflist)
                    set file3HA $atype.csi.con.$CSI(reflist)
                    set outfileHA [open $fileHA w]
                    set outfile1HA [open $file1HA w]
                    set outfile2HA [open $file2HA w]
                    set outfile3HA [open $file2HA w]
                }
                "CA" { set fileCA $atype.ppm.$CSI(reflist)
                    set file1CA $atype.csi.$CSI(reflist)
                    set file2CA $atype.csi.as.$CSI(reflist)
                    set file3CA $atype.csi.con.$CSI(reflist)
                    set outfileCA [open $fileCA w]
                    set outfile1CA [open $file1CA w]
                    set outfile2CA [open $file2CA w]
                    set outfile3CA [open $file2CA w]
                }
                "HB" { set fileHB $atype.ppm.$CSI(reflist)
                    set file1HB $atype.csi.$CSI(reflist)
                    set file2HB $atype.csi.as.$CSI(reflist)
                    set file3HB $atype.csi.con.$CSI(reflist)
                    set outfileHB [open $fileHB w]
                    set outfile1HB [open $file1HB w]
                    set outfile2HB [open $file2HB w]
                    set outfile3HB [open $file2HB w]
                }
                "CB" { set fileCB $atype.ppm.$CSI(reflist)
                    set file1CB $atype.csi.$CSI(reflist)
                    set file2CB $atype.csi.as.$CSI(reflist)
                    set file3CB $atype.csi.con.$CSI(reflist)
                    set outfileCB [open $fileCB w]
                    set outfile1CB [open $file1CB w]
                    set outfile2CB [open $file2CB w]
                    set outfile3CB [open $file2CB w]
                }
                "C"  { set fileC $atype.ppm.$CSI(reflist)
                    set file1C $atype.csi.$CSI(reflist)
                    set file2C $atype.csi.as.$CSI(reflist)
                    set file3C $atype.csi.con.$CSI(reflist)
                    set outfileC [open $fileC w]
                    set outfile1C [open $file1C w]
                    set outfile2C [open $file2C w]
                    set outfile3C [open $file2C w]
                }
                "N"  { set fileN $atype.ppm.$CSI(reflist)
                    set file1N $atype.csi.$CSI(reflist)
                    set file2N $atype.csi.as.$CSI(reflist)
                    set file3N $atype.csi.con.$CSI(reflist)
                    set outfileN [open $fileN w]
                    set outfile1N [open $file1N w]
                    set outfile2N [open $file2N w]
                    set outfile3N [open $file2N w]
                }
            }
        }
    }
    
    
    set nass 0
    
    
    for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
        nv_residue $i res
        if {$res(num) == "."} {
            break
        }
        set iRes $res(num)
        
        if {$Seq($i)>=0} {
            incr nass
            set nHelix 0
            set nCoil 0
            set nSheet 0
            foreach atype $atypes {
                set Seq($i,CSI,$atype) n
                
                if {$atype=="CON"} {continue}
                
                set sstype n
                set name $Seq($i,rname)
                
                if { ($i==1) && ($atype=="HN")} {continue}
                if {($name=="GLY") && ($atype=="CB")} {continue}
                if {($name=="GLY") && ($atype=="HB")} {continue}
                if {($name=="PRO") && ($atype=="HN")} {continue}
                if {($name=="GLY") && ($atype=="HA")} {
                    set ppm [nv_atom elem ppm $iRes.${atype}1]
                    if {$ppm < -990.0} {
                        set ppm [nv_atom elem ppm $iRes.${atype}2]
                    }
                } else {
                    set ppm [nv_atom elem ppm $iRes.$atype]
                }
                
                
                if {$ppm > -999.0} {
                    if {$atype=="C"} {set ppm [expr $ppm+0.0]}
                    set ppm [expr $ppm-0.0]
                    set rname $SGL($Seq($i,rname))
                    if { $i > 1 && $CSI(reflist)=="wut" } { set prename $SGL($Seq([expr $i-1],rname)) }
                    if { $i > 1 && $CSI(reflist)=="ure" } { set prename1 $SGL($Seq([expr $i-1],rname)) }
                    if { $i > 2 && $CSI(reflist)=="ure" } { set prename2 $SGL($Seq([expr $i-2],rname)) }
                    if { $i < [expr $Nv_Nresidues - 1] && $CSI(reflist)=="ure" } { set postname1 $SGL($Seq([expr $i+1],rname)) }
                    if { $i < [expr $Nv_Nresidues - 2] && $CSI(reflist)=="ure" } { set postname2 $SGL($Seq([expr $i+2],rname)) }
                    if { $i < [expr $Nv_Nresidues - 1] && $CSI(reflist)=="ala" } { set postname $SGL($Seq([expr $i+1],rname)) }
                    set deltappm same
                    switch $atype {
                        "HN" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$i > 2 && $CSI(correct-2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename2,$atype,-2)]
                            }
                            if {$i > 1 && $CSI(correct-1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename1,$atype,-1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 1] && $CSI(correct1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname1,$atype,1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 2] && $CSI(correct2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname2,$atype,2)]
                            }
                            if { $CSI(trosy) > 0 } {
                                set trosy [expr 45/$CSI(trosy,Hfield)]
                                set CSIshift [expr $CSIshift - $trosy]
                            }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2HN "$i $ppm $CSI(assign)"
                                puts $outfileHN "$i [expr $ppm-$CSIshift]"
                            }
                            
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                        "HA" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$i > 2 && $CSI(correct-2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename2,$atype,-2)]
                            }
                            if {$i > 1 && $CSI(correct-1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename1,$atype,-1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 1] && $CSI(correct1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname1,$atype,1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 2] && $CSI(correct2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname2,$atype,2)]
                            }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2HA "$i $ppm $CSI(assign)"
                                puts $outfileHA "$i [expr $ppm-$CSIshift]"
                            }
                            
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                        "HB" {
                            if {$ppm>[expr $CSI($rname,$atype,shift)+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSI($rname,$atype,shift)-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSI($rname,$atype,shift)-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSI($rname,$atype,shift)+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2HB "$i $ppm $CSI(assign)"
                                puts $outfileHB "$i [expr $ppm-$CSI($rname,$atype,shift)]"
                            }
                            
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSI($rname,$atype,shift)]
                        }
                        "C" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$i > 2 && $CSI(correct-2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename2,$atype,-2)]
                            }
                            if {$i > 1 && $CSI(correct-1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename1,$atype,-1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 1] && $CSI(correct1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname1,$atype,1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 2] && $CSI(correct2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname2,$atype,2)]
                            }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2C "$i $ppm $CSI(assign)"
                                puts $outfileC "$i [expr $ppm-$CSIshift]"
                            }
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                        "CB" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$CSI(deuterated) == 1} { set ppm [expr $ppm-0.4] }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2CB "$i $ppm $CSI(assign)"
                                puts $outfileCB "$i [expr $ppm-$CSIshift]"
                            }
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                        "CA" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$CSI(deuterated) == 1} { set ppm [expr $ppm-0.4] }
                            if {$i > 2 && $CSI(correct-2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename2,$atype,-2)]
                            }
                            if {$i > 1 && $CSI(correct-1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename1,$atype,-1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 1] && $CSI(correct1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname1,$atype,1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 2] && $CSI(correct2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname2,$atype,2)]
                            }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2CA "$i $ppm $CSI(assign)"
                                puts $outfileCA "$i [expr $ppm-$CSIshift]"
                            }
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                        "N" {
                            set CSIshift $CSI($rname,$atype,shift)
                            if { $CSI(reflist) == "ala" && $postname == "P" } {
                                set CSIshift $CSI($rname,$atype,shift,pro)
                            }
                            if {$i > 1 && $CSI(ph) < 3.5 && $CSI(reflist)=="wut" } {
                                set CSIshift [expr $CSIshift + $CSI($prename,$atype,Ndeltaseq2)]
                            }
                            if {$i > 1 && $CSI(ph) >= 3.5 && $CSI(reflist)=="wut" } {
                                set CSIshift [expr $CSIshift + $CSI($prename,$atype,Ndeltaseq5)]
                            }
                            if {$i > 2 && $CSI(correct-2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename2,$atype,-2)]
                            }
                            if {$i > 1 && $CSI(correct-1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($prename1,$atype,-1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 1] && $CSI(correct1) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname1,$atype,1)]
                            }
                            if {$i < [expr $Nv_Nresidues - 2] && $CSI(correct2) == 1 && $CSI(reflist)=="ure" } {
                                set CSIshift [expr $CSIshift + $CSI($postname2,$atype,2)]
                            }
                            if { $CSI(trosy) > 0 } {
                                set Nfield [expr $CSI(trosy,Hfield)*0.10132905]
                                set trosy [expr 45/$Nfield]
                                set CSIshift [expr $CSIshift - $trosy]
                            }
                            if {$ppm>[expr $CSIshift+$CSI($rname,$atype,delta1)]} {
                                set deltappm greater
                            } elseif {$ppm<[expr $CSIshift-$CSI($rname,$atype,delta2)]} {
                                set deltappm lessor
                            }
                            
                            if { $CSI(assignflag) == 1 } {
                                set tol1 [ expr $CSIshift-($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                                set tol2 [ expr $CSIshift+($CSI(assignfactor)*$CSI($rname,$atype,delta1))]
                            }
                            
                            if { $CSI(assignflag) == 1 && $ppm > $tol1 &&  $ppm < $tol2 } {
                                set CSI(assign) 0
                            } else { set CSI(assign) 1 }
                            
                            if { $CSI(assignflag) == 0 } { set CSI(assign) -1 }
                            
                            if { $Nv_SeqDisp(ascii) == 1 } {
                                puts $outfile2N "$i $ppm $CSI(assign)"
                                puts $outfileN "$i [expr $ppm-$CSIshift]"
                            }
                            set Seq($i,CSIdelta,$atype) [expr $ppm-$CSIshift]
                        }
                    }
                    
                    if { $Nv_SeqDisp(maxCSI) < [expr abs($Seq($i,CSIdelta,$atype))]} { set Nv_SeqDisp(maxCSI) [expr abs($Seq($i,CSIdelta,$atype))]}
                    set sstype c
                    switch $atype {
                        "HN" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HN "$i 1"
                                }
                                set sstype s
                                incr nSheet
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HN "$i -1"
                                }
                                set sstype h
                                incr nHelix
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HN "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "HA" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HA "$i 1"
                                }
                                set sstype s
                                incr nSheet
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HA "$i -1"
                                }
                                set sstype h
                                incr nHelix
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HA "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "HB" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HB "$i 1"
                                }
                                set sstype h
                                incr nHelix
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HB "$i -1"
                                }
                                set sstype s
                                incr nSheet
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1HB "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "C" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1C "$i 1"
                                }
                                set sstype h
                                incr nHelix
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1C "$i -1"
                                }
                                set sstype s
                                incr nSheet
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1C "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "CA" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CA "$i 1"
                                }
                                set sstype h
                                incr nHelix
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CA "$i -1"
                                }
                                set sstype s
                                incr nSheet
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CA "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "CB" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CB "$i 1"
                                }
                                set sstype s
                                incr nSheet
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CB "$i -1"
                                }
                                set sstype h
                                incr nHelix
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1CB "$i 0"
                                }
                                incr nCoil
                            }
                        }
                        "N" {
                            if {$deltappm=="greater"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1N "$i 1"
                                }
                                set sstype s
                                incr nSheet
                            } elseif {$deltappm=="lessor"} {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1N "$i -1"
                                }
                                set sstype h
                                incr nHelix
                            } else {
                                if { $Nv_SeqDisp(ascii) == 1 } {
                                    puts $outfile1N "$i 0"
                                }
                                incr nCoil
                            }
                        }
                    }
                }
                set Seq($i,CSI,$atype) $sstype
            }
            
            if {[expr (1.0*$nSheet)/$nAtypes] > 0.6 } {
                set conType s
            } elseif {[expr (1.0*$nHelix)/$nAtypes] > 0.6 } {
                set conType h
            } elseif {[expr (1.0*$nCoil)/$nAtypes] > 0.6 } {
                set conType c
            } else {
                set conType n
            }
            set Seq($i,CSI,CON) $conType
        }
        
    }
    
    set Nv_SeqDisp(Assigned) [format "%3d (%4.1f %%)"  $nass [expr 100.0*$nass/$Nv_Nresidues] ]
    
    
    if { $Nv_SeqDisp(ascii) == 1 } {
        foreach atype $atypes {
            switch $atype {
                "HA" {
                    close $outfileHA
                    close $outfile1HA
                    close $outfile2HA
                    close $outfile3HA
                }
                "CA" {
                    close $outfileCA
                    close $outfile1CA
                    close $outfile2CA
                    close $outfile3CA
                }
                "HB" {
                    close $outfileHB
                    close $outfile1HB
                    close $outfile2HB
                    close $outfile3HB
                }
                "CB" {
                    close $outfileCB
                    close $outfile1CB
                    close $outfile2CB
                    close $outfile3CB
                }
                "C" {
                    close $outfileC
                    close $outfile1C
                    close $outfile2C
                    close $outfile3C
                }
                "N" {
                    close $outfileN
                    close $outfile1N
                    close $outfile2N
                    close $outfile3N
                }
                "HN" {
                    close $outfileHN
                    close $outfile1HN
                    close $outfile2HN
                    close $outfile3HN
                }
            }
        }
    }
    
    #Determine a consensus secondary structure when looking at more than one atomtype.
    
    if { $nAtypes > 2 && $Nv_SeqDisp(ascii) == 1} {
        puts "Determining consensus in CSI between the different atom types."
        set fileid [open CSI_sum.txt w]
        foreach atype $atypes {
            puts $fileid "$atype.csi.$CSI(reflist)"
        }
        close $fileid
        
        if { $Nv_SeqDisp(ascii) == 1 } {
            exec $NVH/scripts/consensusCSI.pl $Nv_Nresidues CSI_sum.txt
            #        exec /dsk2/gerard/nmrview/tcl/consensusCSI_new.pl $Nv_Nresidues CSI_sum.txt
        }
        
        puts "Done"
    }
    
}

proc NvSeqedCurRes {fr i} {
    global Seq Nv_SeqDisp
    
    set Nv_SeqDisp(CurrentRes) "$i"
}
proc NvSeqDumpResAssign {nm i iRes} {
    global Seq Nv_Priv Nv_SeqDisp
    set varnm [NvVarnm $Nv_Priv(assignPanel)]
    global $varnm
    upvar #0 $varnm panvar
    
    if {$Seq($i) && [info exists Seq($i,Frag)] } {
        set Nv_SeqDisp(Fragment) $Seq($i,Frag)
        set Nv_SeqDisp(Element) $Seq($i,FragElem)
        set Nv_SeqDisp(Cluster) $Seq($i,clst)
	set Nv_SeqDisp(Cluster1) [lindex $Nv_SeqDisp(Cluster) 0]
	set Nv_SeqDisp(Cluster2) [lindex $Nv_SeqDisp(Cluster) 1]       
    } else {
        set Nv_SeqDisp(Fragment) ""
        set Nv_SeqDisp(Element) ""
        set Nv_SeqDisp(Cluster) ""
        set Nv_SeqDisp(Cluster1) ""
	set Nv_SeqDisp(Cluster2) ""
    }
    set panvar(curres2) $i
    set panvar(curres) $iRes
    NvUpdateAssignPan $Nv_Priv(assignPanel) set 0
}
proc NvSeqOptions {nm} {
    global Nv_SeqDisp
    set nm $nm.options
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    
    set Options {
        {oframe seqOptions}
        frame
        {label  "Font Size"}
        frame
        { escale Nv_SeqDisp(fontSize) "10 5 20 1" "" }
        frame
        {label  "Number of residues per line:"}
        frame
        { entry fields  ""  Nv_SeqDisp(nfields) }
        frame
        { checkbutton "Print ascii files" Nv_SeqDisp(ascii) 0}
        frame
        {label {Display Atoms}}
        frame
        { checkbutton HN Nv_SeqDisp(displayAtom,HN) 0}
        { checkbutton HA Nv_SeqDisp(displayAtom,HA) 0}
        { checkbutton HB Nv_SeqDisp(displayAtom,HB) 0}
        { checkbutton CA Nv_SeqDisp(displayAtom,CA) 0}
        { checkbutton CB Nv_SeqDisp(displayAtom,CB) 0}
        { checkbutton C  Nv_SeqDisp(displayAtom,C) 0}
        { checkbutton N  Nv_SeqDisp(displayAtom,N) 0}
        frame
        {label {CSI Calc Atoms}}
        frame
        { checkbutton HN Nv_SeqDisp(csiCalcAtom,HN) 0}
        { checkbutton HA Nv_SeqDisp(csiCalcAtom,HA) 0}
        { checkbutton HB Nv_SeqDisp(csiCalcAtom,HB) 0}
        { checkbutton CA Nv_SeqDisp(csiCalcAtom,CA) 0}
        { checkbutton CB Nv_SeqDisp(csiCalcAtom,CB) 0}
        { checkbutton C  Nv_SeqDisp(csiCalcAtom,C) 0}
        { checkbutton N  Nv_SeqDisp(csiCalcAtom,N) 0}
        frame
        {label {CSI Display Atoms}}
        frame
        { checkbutton HN Nv_SeqDisp(csiAtom,HN) 0}
        { checkbutton HA Nv_SeqDisp(csiAtom,HA) 0}
        { checkbutton HB Nv_SeqDisp(csiAtom,HB) 0}
        { checkbutton CA Nv_SeqDisp(csiAtom,CA) 0}
        { checkbutton CB Nv_SeqDisp(csiAtom,CB) 0}
        { checkbutton C  Nv_SeqDisp(csiAtom,C) 0}
        { checkbutton N  Nv_SeqDisp(csiAtom,N) 0}
        frame
        { radiobutton Nv_SeqDisp(csiDispMode) "value threshold" "" }
        frame
        
        {label Annotations}
        frame
        {checkbutton Cartoon Nv_SeqDisp(anno,Cartoon) 0}
        frame
        {label Noes}
        {checkbutton HN-HN Nv_SeqDisp(noes,hnhn) 0}
    }
    
    toplevel $nm
    wm minsize $nm 1 1
    
    
    foreach item $Options {
        NvAddWidget $nm $item duckWin
    }
    
    set fr $nm.bbar
    frame $fr
    pack $fr -side top -fill x
    button $fr.apply -text Apply -command "NvSeqErase; NvSeqMkCanvas"
    pack $fr.apply -side left
    button $fr.close -text Close -command "destroy $nm"
    pack $fr.close -side left
}



proc NvSeqOptionsCSI {nm} {
    global CSI
    
    set tl $nm
    set nm $nm.optionsCSI
    set CSI(reflist) ""
    set CSI(solp) 0
    set CSI(solm) 0
    set CSI(trosy) 0
    set CSI(assignflag) 0
    set CSI(deuterated) 0
    set CSI(correct-2) 1
    set CSI(correct-1) 1
    set CSI(correct1) 1
    set CSI(correct2) 1
    
    if {[winfo exists $nm]} {
        wm deiconify $nm
        raise $nm
        return
    }
    
    toplevel $nm
    
    label $nm.lb1 -text "CSI Options."
    pack $nm.lb1 -side top
    set fr $nm.fr0
    frame $fr
    pack $fr -side top -fill both -expand y
    set fr $nm.fr0.fr1
    frame $fr -border 2 -relief raised
    pack $fr -side left -fill both
    
    button $fr.b1 -text "Info" -command "ReadInfo"
    label $fr.lb -text "Reference: "
    radiobutton $fr.r1  -text "Wishart (Database)" -variable CSI(reflist) -value "csi"
    radiobutton $fr.r7  -text "Wishart (peptides)" -variable CSI(reflist) -value "ala"
    radiobutton $fr.r2  -text "Wright (Urea)"  -variable CSI(reflist) -value "ure"
    radiobutton $fr.r3  -text "Thanabal (AcN)"  -variable CSI(reflist) -value "acn"
    radiobutton $fr.r8  -text "Thanabal (TFE)"  -variable CSI(reflist) -value "tfe"
    radiobutton $fr.r4  -text "Dobson (GdmHCl)"  -variable CSI(reflist) -value "dob"
    radiobutton $fr.r5  -text "Wright (protons)"  -variable CSI(reflist) -value "wri"
    radiobutton $fr.r6  -text "Wuthrich"  -variable CSI(reflist) -value "wut"
    
    pack $fr.lb -side top -anchor center
    pack $fr.r1  $fr.r7  $fr.r3 $fr.r8 $fr.r4 $fr.r2  $fr.r5 $fr.r6 $fr.b1  -side top -anchor w
    
    $fr.r1 invoke
    
    set fr $nm.fr0.fr20
    frame $fr -border 2 -relief raised
    pack $fr -side left -expand y -fill both
    label $fr.lb -text "Standard: "
    radiobutton $fr.r1 -text "DSS" -variable CSI(standard) -value "DSS"
    radiobutton $fr.r2 -text "TMS" -variable CSI(standard) -value "TMS"
    radiobutton $fr.r3 -text "TSP" -variable CSI(standard) -value "TSP"
    radiobutton $fr.r4 -text "DIOXANE" -variable CSI(standard) -value "DIOXANE"
    pack $fr.lb -side top -anchor center
    pack $fr.r1 $fr.r2 $fr.r3 $fr.r4 -side top -anchor w
    $fr.r1 inv
    
    frame $nm.fr21
    label $nm.fr21.lb -text ""
    pack $nm.fr21 -side top -anchor w -expand y
    pack $nm.fr21.lb -side top -anchor center
    
    
    frame $nm.fr40 -border 2 -relief raised
    label $nm.fr40.lb -text "Experimental Conditions: "
    label $nm.fr40.lbP1 -text "pH: " -width 6
    entry $nm.fr40.eP1 -width 6 -textvariable CSI(ph)
    label $nm.fr40.lbT -text "Temperature:" -width 14
    label $nm.fr40.lbT1 -text " K"
    entry $nm.fr40.eT1 -width 6 -textvariable CSI(temp)
    frame $nm.fr42
    checkbutton $nm.fr42.c1 -text "Deuterated Protein." -variable CSI(deuterated)
    pack $nm.fr40 -side top -expand y -fill x
    pack $nm.fr40.lb -side top -anchor c
    pack $nm.fr40.lbP1 $nm.fr40.eP1 -side left
    pack $nm.fr40.lbT  $nm.fr40.eT1  $nm.fr40.lbT1 -side left
    pack $nm.fr42 -side top -anchor w -expand y
    pack $nm.fr42.c1 -side left
    
    frame $nm.fr45
    label $nm.fr45.lb -text ""
    pack $nm.fr45 -side top -anchor w -expand y
    pack $nm.fr45.lb -side top -anchor center
    
    frame $nm.fr2
    label $nm.fr2.lb -text "Other Parameters: "
    pack $nm.fr2 -side top -expand y -anchor w
    pack $nm.fr2.lb -side top
    
    frame $nm.fr3
    pack $nm.fr3 -side top -expand y -anchor w
    checkbutton $nm.fr3.c3 -text "Cosolvent: " -variable CSI(solp)
    label $nm.fr3.l2 -text "% (Acetonitril or TFE)"
    entry $nm.fr3.e2 -width 6 -textvariable CSI(solpercent)
    
    frame $nm.fr4
    pack $nm.fr4 -side top -expand y -anchor w
    checkbutton $nm.fr4.c4 -text "Cosolvent: " -variable CSI(solm)
    label $nm.fr4.l3 -text "M (Urea or Guanidinium HCl)"
    entry $nm.fr4.e3 -width 6 -textvariable CSI(solmolar)
    
    frame $nm.fr6
    pack $nm.fr6 -side top -expand y -anchor w
    checkbutton $nm.fr6.c5 -text "Check Assignment: " -variable CSI(assignflag)
    label $nm.fr6.l4 -text "*Cutoff"
    entry $nm.fr6.e4 -width 3 -textvariable CSI(assignfactor)
    
    frame $nm.fr10
    pack $nm.fr10 -side top -expand y -anchor w
    checkbutton $nm.fr10.c10 -text "TROSY correction: " -variable CSI(trosy)
    label $nm.fr10.l10 -text "MHz (H frequency)"
    entry $nm.fr10.e10 -width 8 -textvariable CSI(trosy,Hfield)
    
    
    pack $nm.fr3.c3 $nm.fr3.e2  $nm.fr3.l2 -side left
    pack $nm.fr4.c4 $nm.fr4.e3  $nm.fr4.l3 -side left
    pack $nm.fr10.c10 $nm.fr10.e10 $nm.fr10.l10 -side left
    pack $nm.fr6.c5 $nm.fr6.e4  $nm.fr6.l4 -side left
    frame $nm.fr24
    label $nm.fr24.lb -text ""
    pack $nm.fr24 -side top -anchor w -expand y
    pack $nm.fr24.lb -side top -anchor center
    
    
    frame $nm.fr5
    button $nm.fr5.b1 -text "Calc CSI" -command "NvSeqCalCSI $tl;CSISec $tl;NvSeqColorCSI $tl;NvSeqMkCanvas"
    button $nm.fr5.b2 -text "Close" -command "destroy $nm "
    pack $nm.fr5 -side top -expand y -anchor w
    pack $nm.fr5.b1 $nm.fr5.b2 -side left
    
}


proc ReadInfo {} {
    global CSI Nv_SeqDisp NVH
    
    set ref $CSI(reflist)
    if { $ref == "dob" || $ref == "wri"} {
        set filename [file join $NVH CSI HA.$ref]
    } else { set filename [file join $NVH CSI CA.$ref] }
    
    set f1 [open $filename r]
    
    gets $f1 s
    set lit $s
    
    gets $f1 s
    set refer [lindex $s 0]
    set temp [lindex $s 2]
    set ph [lindex $s 3]
    
    gets $f1 s
    set comments $s
    
    close $f1
    
    if {$ph == "pH"} { set ph "N/A" }
    if {$temp == "temp"} { set temp "N/A"}
    if {$ref == "dob" || $ref == "wri"} { set atypes "HN HA HB1 HB2" }
    if {$ref == "acn" || $ref == "tfe"} { set atypes "CA CB" }
    if {$ref == "csi" || $ref == "ala" || $ref == "wut" || $ref == "ure" } { set atypes "HN HA HB1 HB2 CA CB C N" }
    
    
    toplevel .infocsi
    set tl infocsi
    frame .$tl.info
    button .$tl.b1 -text "Close" -command "destroy .$tl"
    
    label .$tl.info.lb1 -text "Reference: $lit"
    label .$tl.info.lb5 -text "Atom types: $atypes"
    label .$tl.info.lb3 -text "pH: $ph, Temp: $temp K"
    label .$tl.info.lb4 -text "Comments: $comments"
    
    pack .$tl.info -side top -expand y -anchor w
    pack .$tl.info.lb1 .$tl.info.lb5 .$tl.info.lb3 .$tl.info.lb4 -anchor w
    pack .$tl.b1 -side top -anchor center
    
}

proc NvSeqErase {} {
    global Seq Nv_SeqDisp Nv_Nresidues
    
    
    if {$Nv_SeqDisp(erase) == 1 } {
        set Nv_SeqDisp(erase) 0
        set atypes $Nv_SeqDisp(csiAtoms)
        foreach atype $atypes {
            if {$Nv_SeqDisp(csiAtom_old,$atype)== 1 && $Nv_SeqDisp(csiCalcAtom,$atype)== 0} {
                set Nv_SeqDisp(csiAtom_old,$atype) 0
                for {set i 1} {$i<=$Nv_Nresidues } {incr i} {
                    unset Seq($i,CSI,$atype)
                    unset Seq($i,CSIF,$atype)
                }
            }
        }
    }
}

proc NvEditSeq {} {
    global Nv_SeqDisp

    destroy .seqEdit
    toplevel .seqEdit

    set fr .seqEdit
    frame $fr.res
    frame  $fr.clust
    frame $fr.buttons
    pack $fr.res $fr.clust $fr.buttons -side top

    label $fr.res.label -text "Residue Number:"
    entry $fr.res.entry -textvariable Nv_SeqDisp(CurrentRes)
    pack $fr.res.label $fr.res.entry -side left

    label $fr.clust.iLab -text "Cluster i:"
    entry $fr.clust.ientry -textvariable Nv_SeqDisp(Cluster1) -width 6
    label $fr.clust.iplusLab -text "Cluster i+1:"
    entry $fr.clust.iplusEntry -textvariable Nv_SeqDisp(Cluster2) -width 6
    pack $fr.clust.iLab $fr.clust.ientry $fr.clust.iplusLab $fr.clust.iplusEntry -side left

    button $fr.buttons.save -text "Set this Residue" -command "NvSaveUpdate $Nv_SeqDisp(CurrentRes)"
    pack $fr.buttons.save -side left
}

proc NvSaveUpdate {i} {
    global Nv_SeqDisp Seq Fragment Clust ClusterData
    set Seq($i,clst) ""
    if {$Seq($i) == 0} {
    	set Seq($i) 1
   	set Seq($i,Frag) $Fragment(nFrag)
	incr Fragment(nFrag) 1
    	set Seq($i,FragElem) 0
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster1)
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster2)
	
    } else {
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster1)
    	lappend Seq($i,clst) $Nv_SeqDisp(Cluster2)
    }

    GetClustInfo $Nv_SeqDisp(Cluster1)
    set Nppm $Clust($Nv_SeqDisp(Cluster1),N)
    set HNppm $Clust($Nv_SeqDisp(Cluster1),HN)
    set CAppm $ClusterData($Nv_SeqDisp(Cluster1),CAi)
    set CBppm $ClusterData($Nv_SeqDisp(Cluster1),CBi)
    nv_atom elem ppm [nv_atom num $i.N] $Nppm
    nv_atom elem ppm [nv_atom num $i.HN] $HNppm
    nv_atom elem ppm [nv_atom num $i.CA] $CAppm
    nv_atom elem ppm [nv_atom num $i.CB] $CBppm

}

set SGL(ALA) A
set SGL(ASP) D
set SGL(ASN) N
set SGL(ARG) R
set SGL(CYS) C
set SGL(GLU) E
set SGL(GLN) Q
set SGL(ILE) I
set SGL(VAL) V
set SGL(LEU) L
set SGL(PRO) P
set SGL(PHE) F
set SGL(TYR) Y
set SGL(TRP) W
set SGL(LYS) K
set SGL(MET) M
set SGL(HIS) H
set SGL(GLY) G
set SGL(SER) S
set SGL(THR) T
set SGL(GUA) g
set SGL(CYT) c
set SGL(THY) t
set SGL(A) a
set SGL(G) g
set SGL(C) c
set SGL(T) t
set SGL(a) a
set SGL(g) g
set SGL(c) c
set SGL(t) t
set SGL(ADE) a
set SGL(.) X
