# script history: part of Merck distribution
# modified 9/99 c hastings

# Copyright (c) 1995 Merck and Co., Inc.
#       Whitehouse Station, NJ USA
#          All Rights Reserved

proc NvMkSpecMenu {nm} {
    
    if {[string range $nm 0 0]!="."} {
        errmsg "Window must start with ."
        return
    }
    set varnm [NvVarnm $nm] ; #remove '.' from the variable name
    
    global $varnm
    menu $nm
    $nm add command -label Attributes -command NvShowSpecAttr 
    set menu(Misc) {{Plot {NvMkPlotCntrl .plot}} {Grid {nv_win grid}} {Unify NvSpectrumUnify} {KeyBinding NvSpectrumKeys}}
    set type(Misc) proc
    set menu(View) {Draw Expand Previous Full Center Swap {Zoom In} {Zoom Out}}
    set type(View) command
    set menu(Cursor) { {Crosshairs {NvSetCursorMode crosshairs}} \
        {PeakAdjust {NvSetCursorMode peakadjust}} \
        {PeakAdd    {NvSetCursorMode peakadd}} \
        {PeakDelete    {NvSetCursorMode peakdelete}} \
    {PeakLink   {NvSetCursorMode peaklink}} }
    set type(Cursor) proc
    set menu(Edit) {copy pasteData pasteLimits pasteAll}
    set type(Edit) proc
    set menu(Peak) "Pick Search ShowPeaks PeakAttributes DelRegion"
    set type(Peak) command
    set menu(Slice) "X Y Z A"
    set type(Slice) checkbutton
    set menu(Extract) "X Y Z A"
    set type(Extract) NvProc
    set menu(Procedures) "reref pkreref Nv_SpecMol"
    set type(Procedures) proc
    foreach entry "View Edit Cursor Slice Extract Peak Misc Procedures" {
        set lentry [string tolower $entry]
        $nm add cascade -label $entry -menu $nm.$lentry
        if {$type($entry) == "checkbutton"} {
            menu $nm.$lentry -postcommand  [list NvFillCheckMenu $varnm $entry $menu($entry)]
        } else {
            menu $nm.$lentry
        }
        foreach entry2 $menu($entry) {
            switch $type($entry) {
                command {
		    if {$entry2 == "DelRegion"} {
			$nm.$lentry add command -label $entry2 -command "nv_peak [string tolower $entry2]"
		    } else {
                    	$nm.$lentry add command -label $entry2 -command "nv_win [string tolower $entry2]"
		    }
                }
                NvProc {
                    $nm.$lentry add command -label $entry2 -command "Nv$entry $entry2"
                }
                proc {
                    if {[llength $entry2]>1} {
                        set command [lindex [lrange $entry2 1 end] 0]
                    } else {
                        set command $entry2
                    }
                    $nm.$lentry add command -label [lindex $entry2 0] -command $command
                }
                checkbutton {
                    set var ${varnm}($entry,$entry2)
                    $nm.$lentry add checkbutton -label $entry2 -variable $var -command "nv_win [string tolower $entry] [string tolower $entry2] \$$var"
                }
            }
        }
    }
    
}
proc NvFillCheckMenu {varnm entry menuitems} {
    global $varnm
    upvar #0 $varnm var
    foreach menuitem $menuitems {
        set status [nv_win [string tolower $entry] [string tolower $menuitem]]
        set var($entry,$menuitem) [expr $status > 0]
    }
}
