# script history: part of Merck distribution
# edited 9/99 c hastings, to use user prefs

# Copyright (c) 1995 Merck and Co., Inc.
#       Whitehouse Station, NJ USA
#          All Rights Reserved

proc NvShowFileBox {type {mode nodraw}} {
	global Nv_Priv 
	
	set nm $Nv_Priv(filebox,$type,toplevel)
    if {![winfo exists $nm]} {
    	NvMkFileBox $type
    }
    
    wm deiconify $nm
    raise $nm
    wm geometry $nm +50+50
}

proc NvFileBoxHide {type} {
	global Nv_Priv 
	
	set nm $Nv_Priv(filebox,$type,toplevel)
    if {[winfo exists $nm]} {
    	wm withdraw $nm
    }
}

proc NvMkFileBox {type} {
    global Nv_Priv Nv_Prefs ; #get the global arrays for use in this file
	set nm $Nv_Priv(filebox,$type,toplevel) ; # set variables used for this file type
	set curdir [pwd]
	set filter $Nv_Priv(filebox,$type,filter)
	set options $Nv_Priv(filebox,$type,options)
	set command $Nv_Priv(filebox,$type,command)
	
    set varnm [NvVarnm $nm] ; #remove the first char (the period) from $nm
    global $varnm ; #make global for other proc's use
    upvar #0 $varnm filebox ;  
    if {[winfo exists $nm]} { ; #if there is a window named $nm destroy it and $varnm
        destroy $nm
        unset $varnm
    }
 
    # added to use user prefs

    if {$Nv_Prefs(usedirs)} { ; #this is true if the prefs have been set
        set ${varnm}(curdir) $Nv_Prefs(dir,data) ; #set this array var to the data dir set in prefs
    } else {
        set ${varnm}(curdir) [pwd]
    }

    # end of added code

    toplevel $nm ; #create a new window named $nm
    wm withdraw $nm ; #
    
    frame $nm.dir
    frame $nm.dir.df -relief raised
    frame $nm.dir.ff -relief raised
    frame $nm.dir.df.f1
    frame $nm.dir.ff.f1
    frame $nm.dir.df.f2
    frame $nm.dir.ff.f2
    
    set framePar ""
    if {[llength $options]> 0} {
    
    eval frame $nm.options $framePar
    pack $nm.options
    label $nm.options.label -width 50 -text "Read/Write Options"
    pack $nm.options.label -fill x -expand yes -side top
    set frame $nm.options.optionFrame
    frame $frame -relief sunken
    pack $frame -fill x -expand yes -side top
   foreach option $options {
    	set button [string tolower $option]
            radiobutton $frame.$button -text $option -variable ${varnm}(option) -value $button
    	pack $frame.$button -side left
    }
    set filebox(option) [string tolower [lindex $options 0]]
    } else {
    set filebox(option) ""
    }
    
    eval frame $nm.bframe $framePar
    
    eval frame $nm.curdir -relief raised $framePar
    pack $nm.curdir -fill x -side top
    label $nm.curdir.label -width 50 -text "Current Directory"
    pack $nm.curdir.label -fill x -expand yes -side top
    entry $nm.curdir.entry -width 50 -relief sunken -textvariable ${varnm}(curdir)
    pack $nm.curdir.entry -fill x -expand yes -side top
    
    
    eval frame $nm.filter $framePar
    pack $nm.filter -fill x
    label $nm.filter.label -width 50 -text "File Filters"
    pack $nm.filter.label -fill x -expand yes -side top
    entry $nm.filter.entry -width 50 -relief sunken -textvariable ${varnm}(filter)
    pack $nm.filter.entry -fill x -expand yes -side top
    
    pack $nm.dir -fill both -expand yes
    pack $nm.bframe -fill x
    pack $nm.dir.df $nm.dir.ff -side left -fill both -expand yes
    pack $nm.dir.df.f1 -fill both -expand yes
    pack $nm.dir.df.f2 -fill x
    pack $nm.dir.ff.f1 -fill both -expand yes
    pack $nm.dir.ff.f2 -fill x
    
    listbox $nm.dir.ff.f1.files -yscrollcommand "$nm.dir.ff.f1.scroll set " -xscrollcommand "$nm.dir.ff.f2.xscroll set "

    listbox $nm.dir.df.f1.files -yscrollcommand "$nm.dir.df.f1.scroll set" -xscrollcommand "$nm.dir.df.f2.xscroll set"

    bind $nm.dir.ff.f1.files <Double-Button-1> "NvOpenSelection $nm \{$command\}"
    bind $nm.dir.df.f1.files <Double-Button-1> "NvOpenSelection $nm \{$command\}"
    
    pack $nm.dir.df.f1.files -side left -fill both -expand yes
    pack $nm.dir.ff.f1.files -side left -fill both -expand yes
    
    scrollbar $nm.dir.ff.f1.scroll -command "$nm.dir.ff.f1.files yview"
    scrollbar $nm.dir.df.f1.scroll -command "$nm.dir.df.f1.files yview"
    pack $nm.dir.ff.f1.scroll -side right -fill y
    pack $nm.dir.df.f1.scroll -side right -fill y
    
    scrollbar $nm.dir.ff.f2.xscroll -orient horizontal -command "$nm.dir.ff.f1.files xview"
    scrollbar $nm.dir.df.f2.xscroll -orient horizontal -command "$nm.dir.df.f1.files xview"

    pack $nm.dir.ff.f2.xscroll -fill x -side bottom
    pack $nm.dir.df.f2.xscroll -fill x -side bottom
    
    set ${varnm}(filter) $filter



    NvFillFiles $nm
    button $nm.bframe.filter -text Filter -command "NvFillFiles $nm"
    button $nm.bframe.open -text Open -command "
            NvOpenSelection $nm \{$command\}
            wm withdraw $nm
        "
    button $nm.bframe.close -text Close -command "wm withdraw $nm"
    pack $nm.bframe.filter $nm.bframe.open $nm.bframe.close -side left -expand yes
    bind $nm.filter.entry <Return> "NvFillFiles $nm"
    bind $nm.curdir.entry <Return> "NvFillFiles $nm"

}
proc NvOpenSelection {nm command} {
    set varnm [NvVarnm $nm]
    upvar #0 $varnm filebox

    set dirname $filebox(curdir)
    set filename [selection get]

    if {![file isfile [file join $dirname $filename]]} {
	NvMoveDir $nm $filename
        return
    }
    set file [file join $dirname $filename]
    if {$filebox(option) != ""} {
        eval $command -$filebox(option) [list $file]
    } else {
        eval $command [list $file]
    }
}


proc NvFillDir {nm} {
	global tcl_platform
    set varnm [NvVarnm $nm]
    upvar #0 $varnm filebox
    $nm.dir.df.f1.files delete 0 end
    set dirname $filebox(curdir)
    
    set alldirs [eval [list glob -nocomplain [file join $dirname *]]]
    if {$tcl_platform(platform)=="macintosh"} {
        $nm.dir.df.f1.files insert end "::"
    } else {
        $nm.dir.df.f1.files insert end ".."
    }
    foreach i [lsort $alldirs] {
        if {[file isdir [file join $dirname $i]]} { 
        	set file [file tail $i]
            $nm.dir.df.f1.files insert end $file
        }
    }
}
proc NvMoveDir {nm dir} {
	global Nv_Priv tcl_platform
    set varnm [NvVarnm $nm]
    upvar #0 $varnm filebox
    if {$tcl_platform(platform)=="macintosh"} {
    	set upsep "::"
    } else {
    	set upsep ".."
    }
    set tail $filebox(filter)
    set dirname $filebox(curdir)
    if {$dir==$upsep} {
        set dirname [file dirname $dirname]
        set filebox(curdir) $dirname
    } else {
            set filebox(curdir) [file join $dirname $dir]
    }
    NvFillFiles $nm
}
proc NvFillFiles {nm} {
    set varnm [NvVarnm $nm]
    upvar #0 $varnm filebox
    $nm.dir.ff.f1.files delete 0 1000
    set allfiles ""
    foreach filter $filebox(filter) {
        set dfilter [file join $filebox(curdir) $filter]
        set files [eval [list glob -nocomplain $dfilter]]
    	set allfiles [concat $allfiles $files]
    }
    foreach i [lsort $allfiles] {
        if {[file isfile $i]} {
            $nm.dir.ff.f1.files insert end [file tail $i]
        }
    }
    NvFillDir $nm
}

proc NvGetFile {type} {
    global Nv_Priv env Nv_Prefs

    set types [format { 
		{{%s} {%s} }
	          } $Nv_Priv(filebox,$type,description) $Nv_Priv(filebox,$type,filter)]

    # edited code for nmrview prefs


    if {$Nv_Prefs(usedirs)} {
        if {($type == "vnmrp") ||($type == "vnmr2d")} {
            set idir $Nv_Prefs(dir,vnmr)
        } elseif {$type == "mxyz"} {
            set idir $Nv_Prefs(dir,pdb)
        } else {
            set idir $Nv_Prefs(dir,$type)
        }
    } else {
        if {$type=="vnmrp"} {
            set idir $env(vnmruser)
        } else {
            set idir [pwd]
        }
    }

    set fileName [tk_getOpenFile -filetypes $types -title $Nv_Priv(filebox,$type,title) -initialdir $idir]

   if {$fileName != ""} {
     
	set cmd "$Nv_Priv(filebox,$type,command) {$fileName}"
	
	eval $cmd
	return 0

   } else {
	return 1
   }

}

proc NvSaveFile {type} {
    global Nv_Priv env Nv_Prefs

    set types [format { 
		{{%s} {%s} }
	          } $Nv_Priv(filebox,$type,description) $Nv_Priv(filebox,$type,filter)]

    if {$Nv_Prefs(usedirs)} {
        if {$type == "starWrite"} {
            set idir $Nv_Prefs(dir,starRead)
        }\
        elseif {($type == "vnmrp") ||($type == "vnmr2d")} {
            set idir $Nv_Prefs(dir,vnmr)
        } else {
            set idir $Nv_Prefs(dir,$type)
        }
    } else {
        if {$type=="vnmrp"} {
            set idir $env(vnmruser)
        } else {
            set idir [pwd]
        }
    }

    set fileName [tk_getSaveFile -filetypes $types -title $Nv_Priv(filebox,$type,title) -initialdir $idir]

    if {$fileName != ""} {
	set cmd "$Nv_Priv(filebox,$type,command) {$fileName}"
	
	eval $cmd

   }

}
